#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct p{
    ll x, y;

    bool operator < (const p &other){
        return (x < other.x) || (x == other.x && y < other.y);
    }
};


int main()
{
    ll n;
    cin >> n;
    vector<p> arr(n);

    for(int i = 0; i < n; i++){
        cin >> arr[i].x;
    }
    for(int i = 0; i < n; i++){
        cin >> arr[i].y;
    }


    for(int i = 0; i < n; i++){
        if(arr[i].x > arr[i].y){
            swap(arr[i].x, arr[i].y);
        }
    }

    sort(arr.begin(), arr.end());

    for(int i = 0; i < n-1; i++){
        if(arr[i].y > arr[i+1].y){
            cout << -1;
            return 0;
        }
    }

    for(int i = 0; i < n; i++){
        cout << arr[i].x <<" ";
    }cout << "\n";
    for(int i = 0; i < n; i++){
        cout << arr[i].y << " ";
    }

    return 0;
}
