#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll
const double eps = 1e-6;
const int inf = 1e15;

struct Line {
    double k;
    double b;
    int xs;
};

double xp(Line a, Line b) {
    return (b.b - a.b) / (a.k - b.k);
}

deque<Line> st;

void add(double k, double b, int xs) {
    Line nl = {k, b, xs};
    if (st.size() < 2) {
        st.emplace_back(nl);
        return;
    }
    while (st.size() > 2) {
        int sz = st.size() - 1;
        double xp1 = xp(st[sz], st[sz - 1]);
        double xp2 = xp(st[sz], nl);
        if (xp1 > xp2)
            st.pop_back();
        else
            break;
    }
    st.emplace_back(nl);
}

double opt(int x) {
    int l = 0, r = st.size() - 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (xp(st[mid], st[mid - 1]) <= x)
            r = mid;
        else
            l = mid;
    }
    double r1 = st[r].k * x + st[r].b;
    double r2 = st[0].k * x + st[0].b;
    return min(r1, r2);
}

void solve(){
    int n, m, c;
    cin >> n >> m >> c;
    cout << "work" << endl;
    add(0, 0, 0);
    
    vector<double> dp(n + 1);
    for (int i = 1,x, t; i <= n; i++) {
        cin >> x >> t;
        
    // cout << "work" << endl;
        while (!st.empty() && x - st.front().xs > c)
            st.pop_front();
        dp[i] = opt(x) + (double)(x * x) / c + t;
        // cout << "OPT" << endl;
        // cout << i << " " << opt(x) << endl;
        double k = (double)(-x * 2) / c;
        double b = dp[i] + (double)(x * x) / c + dp[i];
        add(k, b, x);
        // cout << "DP" << endl;
        // cout << i << " " << dp[i] << endl;
    }
    while (!st.empty() && m - st.front().xs > c)
            st.pop_front();
    cout << fixed << setprecision(8) << opt(m);
}

signed main(){

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);


    int t = 1;
    // cin >> t;

    while(t--)
        solve();
}