def generate_multimino(n):
    if n == 1:
        # Тривиальное решение для n = 1
        return [[1]]
    
    if n % 2 == 0:  
        # Если n четное, то уникальное разрезание невозможно
        return -1
    
    # Создаем пустое поле
    result = [[0] * n for _ in range(n)]
    
    # Номер текущей n-миношки
    current = 1
    
    # Разрезаем на уникальные мультиминошки
    for i in range(n):
        for j in range(i, n):
            result[i][j] = current
            result[j][i] = current
            current += 1
            if current > n:
                break
        if current > n:
            break
    
    return result

# Пример вызова
n = int(input("Введите размер n: "))
result = generate_multimino(n)
if result == -1:
    print(-1)
else:
    for row in result:
        print(" ".join(map(str, row)))
