#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<algorithm>
#include<ctime>
#include<random>
#include<iomanip>
#include<fstream>
#include<bitset>
#include<unordered_map>
#include<unordered_set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
ll bpow(ll a, ll n) {
    return n == 0 ? 1 : n % 2 == 0 ? bpow(a * a, n / 2) : bpow(a, n - 1) * a;
}
mt19937 mt(time(0));
const int N = 25e4 + 2, mod = 1e9 + 7, mod2 = 998244353, P = 257, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;
const ld eps = 1e-9;
struct line {
    ld k, b;
    ld get(ld x) {
        return k * x + b;
    }
};
ld cross(line a, line b) {
    return (a.b - b.b) / (b.k - a.k);
}
struct kht {
    vector<pair<line, ld>> a;
    void add(line l) {
        while (!a.empty() && cross(l, a.back().first) <= a.back().second) a.pop_back();
        a.push_back({ l, a.empty() ? -llinf : cross(l, a.back().first)});
    }
    ld get(ld x) {
        int l = 0, r = a.size();
        while (r - l > 1) {
            int m = (l + r) >> 1;
            if (a[m].second > x) r = m;
            else
                l = m;
        }
        return a[l].first.get(x);
    }
};
int n, m, c;
ld dp[N];
ll x[N], cost[N];

void solve() {
    cin >> n >> m >> c;
    kht k;
    k.add({ 0, 0 });
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> cost[i];
        dp[i] = k.get(x[i]) + (ld)x[i] * x[i] / c + cost[i];
        k.add({ (ld)-2 * x[i] / c, dp[i] + (ld)x[i] * x[i] / c });
    }
    ld ans = k.get(m) + (ld)m * m / c;
    cout << setprecision(10) << fixed;
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}