#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <numeric>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <stdio.h>
#include <bitset>
#include <cstdint>
#include <cassert>
#include <complex>
#include <climits>
#include <random>
using namespace std;

#define ll long long
#define pb push_back
#define ull unsigned long long
#define F first
#define S second
#define all(v) v.begin(), v.end() 
#define rall(x) x.rbegin(), (x).rend()
#define ld long double
#define pii pair<int, int>

pair<int, int> ab[300005];
int n;

bool comp(pair<int, int> a, pair<int, int> b){
    if(a.F <= b.F && a.S <= b.S) return 1;
    else if(a.F >= b.F && a.S >= b.S) return 0;
    else{
        if(a.F >= b.S && a.S >= b.F){
            return 0;
        }
        else if(a.F <= b.S && a.S <= b.F){
            return 1;
        }
    }
}

int dp[300005][3];

void solve(){
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> ab[i].F;
    }
    for(int i = 1; i <= n; i++){
        cin >> ab[i].S;
    }
    sort(ab + 1, ab + 1 + n, comp);
    dp[1][1] = 1;
    dp[1][2] = 1;
    for(int i = 2; i <= n; i++){
        if(ab[i - 1].F <= ab[i].F && ab[i - 1].S <= ab[i].S && dp[i - 1][1]){
            dp[i][1] = 1;
        }
        if(ab[i - 1].F <= ab[i].S && ab[i - 1].S <= ab[i].F && dp[i - 1][1]){
            dp[i][2] = 1;
        }
        if(ab[i - 1].S <= ab[i].F && ab[i - 1].F <= ab[i].S && dp[i - 1][2]){
            dp[i][1] = 2;
        }
        if(ab[i - 1].S <= ab[i].S && ab[i - 1].F <= ab[i].F && dp[i - 1][2]){
            dp[i][2] = 2;
        }
    }
    int cur = -1;
    for(int i = n; i >= 1; i--){
        if(cur == -1){
            if(dp[i][1]){
                cur = dp[i][1];
            }
            else if(dp[i][2]){
                swap(ab[i].F, ab[i].S);
                cur = dp[i][2];
            }
            else{
                cout << -1 << '\n';
                return;
            }
        }
        if(cur == 2){
            swap(ab[i].F, ab[i].S);
        }
        if(cur == 0){
            cout << -1 << '\n';
            return;
		}
        if(dp[i][cur]){
            cur = dp[i][cur];
        }
        else{
            cout << -1 << '\n';
            return;
        }
    }
    for(int i = 1; i <= n; i++) cout << ab[i].F << " ";
    cout << '\n';
    for(int i = 1; i <= n; i++) cout << ab[i].S << " ";
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);
    int xach = 1; 
    while(xach--) solve();
}

