/**
 *    data : 09.07.2024  
 *     
**/
#define ORD_SET
#include <bits/stdc++.h>
// #include "algo/turnikmen.h"

using namespace std;
using hash_t = uint64_t;

#ifdef ORD_SET
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#ifdef ROPE
#include <ext/rope>
using namespace __gnu_cxx;
#endif

#define int long long
#define ld long double
#define bitt __builtin_popcountll
#define bitzero __builtin_clz
#define TASK_NAME "log"

void fReopen () {

    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif

    // freopen(TASK_NAME ".in", "r", stdin);
    // freopen(TASK_NAME ".out", "w", stdout);
}

const int N = 1e6;
const int MOD = 1e9 + 7;

ld get(ld k, ld b, ld x, ld y) {
    return abs(-k * x + y - b) / sqrt(k * k + 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1; 
    for (; tt --> 0; ) {
        ld x1, y1, x2, y2, x3, y3;
        cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

        ld mn = 1e18;
        int id1 = 0, id2 = 0;

        {
            ld k, b;
            k = (y1 - y2) / (x1 - x2);
            b = y1 - k * x1;

            if (mn > get(k, b, x3, y3)) {
                mn = get(k, b, x3, y3);
                id1 = 1;
                id2 = 2;
            }
        }
        {
            ld k, b;
            k = (y1 - y3) / (x1 - x3);
            b = y1 - k * x1;

            if (mn > get(k, b, x2, y2)) {
                mn = get(k, b, x2, y2);
                id1 = 1;
                id2 = 3;
            }
        }
        {
            ld k, b;
            k = (y3 - y2) / (x3 - x2);
            b = y3 - k * x3;

            if (mn > get(k, b, x1, y1)) {
                mn = get(k, b, x1, y1);
                id1 = 3;
                id2 = 2;
            }
        }

        if (id1 == 1) cout << x1 << " " << y1 << " ";
        if (id1 == 2) cout << x2 << " " << y2 << " ";
        if (id1 == 3) cout << x3 << " " << y3 << " ";

        if (id2 == 1) cout << x1 << " " << y1 << "\n";
        if (id2 == 2) cout << x2 << " " << y2 << "\n";
        if (id2 == 3) cout << x3 << " " << y3 << "\n";
    }
}
