#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define nl '\n'

int ask(int move) {
    char res;
    cout << "? " << move << ' ' << move << endl;
    cin >> res;
    return res;
}

bool border(int y, int x) {
    return (1 <= x && x <= 8 && 1 <= y && y <= 8) && (y == 1 || x == 1 || y == 8 || x == 8);
}

void solve() {
    int l = 0, r = 8, mid;
    int prev = 0;
    while (r - l > 1) {
        mid = (l + r) >> 1;
        if (mid == 0) break;
        if (ask(mid - prev) == '+'){
            l = mid;
            prev = mid;
        }
        else
            r = mid;
    }

    int save = l;
    l = 0, r = 8;
    prev = 0;
    while (r - l > 1) {
        mid = (l + r) >> 1;
        if (ask(-(mid - prev)) == '+'){
            l = mid;
            prev = mid;
        }
        else
            r = mid;
    }
    
    
    l -= save;
    int sum = save + l + 1;

    vector<string> vec;
    int y = 9 - sum, x = 1;

    while (y <= 8 && x <= 8) {
        if (border(y - l, x - l) && border(y + save, x + save)) {
            string va = "";
            va += char('a' + x - 1);
            va += char('0' + y);
            vec.pb(va);
        }
        y++;
        x++;
    }

    y = 1, x = 9 - sum;
    while (y <= 8 && x <= 8) {
        if (border(y - l, x - l) && border(y + save, x + save)) {
            string va = "";
            va += char('a' + x - 1);
            va += char('0' + y);
            vec.pb(va);
        }
        y++;
        x++;
    }

    string v1 = vec[0];
    string v2 = vec[1];

    if (v1 == v2) {
        cout << "! " << v1 << endl;
        return;
    }

    cout << "? " << -1 << ' ' << 1 << endl;
    char res;
    cin >> res;
    
    if (res == '-')
        cout << "! " << v1 << endl;
    else
        cout << "! " << v2 << endl;
}

signed main() {
    int T = 1;
    while (T--)
        solve();
}
