n, q = map(int, input().split())
edges = {}
color_count = {}
vertex_color_count = [{} for _ in range(n)]
excellent_colors = set()
total_beauty = 0
answers = []

for _ in range(q):
    operation, a, b, c = input().split()
    a, b = int(a) - 1, int(b) - 1
    edge_key = (min(a, b), max(a, b))

    if operation == '+':
        if edge_key not in edges:
            edges[edge_key] = c
            
            if c not in color_count:
                color_count[c] = 0
            color_count[c] += 1
            
            vertex_color_count[a][c] = vertex_color_count[a].get(c, 0) + 1
            vertex_color_count[b][c] = vertex_color_count[b].get(c, 0) + 1
            
            if vertex_color_count[a][c] == 1 and vertex_color_count[b][c] == 1:
                excellent_colors.add(c)
                total_beauty += 1
            
            elif vertex_color_count[a][c] > 1 or vertex_color_count[b][c] > 1:
                if c in excellent_colors:
                    excellent_colors.remove(c)
                    total_beauty -= 1
    else:
        if edge_key in edges:
            c = edges.pop(edge_key)
            color_count[c] -= 1
            vertex_color_count[a][c] -= 1
            vertex_color_count[b][c] -= 1
            
            if vertex_color_count[a][c] == 0 and vertex_color_count[b][c] == 0:
                del vertex_color_count[a][c]
                del vertex_color_count[b][c]
                
            elif vertex_color_count[a][c] == 0 or vertex_color_count[b][c] == 0:
                if c in excellent_colors:
                    excellent_colors.remove(c)
                    total_beauty -= 1

    answers.append(total_beauty)

for ans in answers:
    print(ans)