def three_points(x1, y1, x2, y2, x3, y3):
    def point_to_line_distance(px, py, ax, ay, bx, by):
        return abs((by - ay) * px - (bx - ax) * py + bx * ay - by * ax) / ((bx - ax) ** 2 + (by - ay) ** 2) ** 0.5

    d1 = point_to_line_distance(x3, y3, x1, y1, x2, y2)
    d2 = point_to_line_distance(x1, y1, x2, y2, x3, y3)
    d3 = point_to_line_distance(x2, y2, x3, y3, x1, y1)

    if d1 <= d2 and d1 <= d3:
        print(x1, y1, x2, y2)
    elif d2 <= d1 and d2 <= d3:
        print(x2, y2, x3, y3)
    else:
        print(x3, y3, x1, y1)

x1, y1, x2, y2, x3, y3 = map(int, input().split())
three_points(x1, y1, x2, y2, x3, y3)
