def distance_to_line(x1, y1, x2, y2, x, y):

    A = y2 - y1
    B = x1 - x2
    C = x2 * y1 - x1 * y2
    return abs(A * x + B * y + C) / (A ** 2 + B ** 2) ** 0.5


def find_optimal_trench(x1, y1, x2, y2, x3, y3):

    d1 = distance_to_line(x1, y1, x2, y2, x3, y3)
    d2 = distance_to_line(x1, y1, x3, y3, x2, y2)
    d3 = distance_to_line(x2, y2, x3, y3, x1, y1)


    if d1 <= d2 and d1 <= d3:
        return (x1, y1, x2, y2)
    elif d2 <= d1 and d2 <= d3:
        return (x1, y1, x3, y3)
    else:
        return (x2, y2, x3, y3)



x1, y1, x2, y2, x3, y3 = map(int, input().split())



def collinear(x1, y1, x2, y2, x3, y3):
    return (x2 - x1) * (y3 - y1) == (x3 - x1) * (y2 - y1)



if collinear(x1, y1, x2, y2, x3, y3):
    print(x1, y1, x2, y2)
else:

    result = find_optimal_trench(x1, y1, x2, y2, x3, y3)
    print(result[0], result[1], result[2], result[3])
