#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <cmath>
#include <unordered_map>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;
void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    if (n * m == s) {
        cout << 0;
        return;
    }
    else if (s % n == 0 || s % m == 0) {
        cout << 1;
        return;
    }
    else {
        for (ll x = 1; x < n; ++x) {
            if (s % x == 0 && s / x <= m) {
                cout << 2;
                return;
            }
            if ((n - 2 * x) != 0 && (s - x * m) % (n - 2 * x) == 0 && (s - x * m) / (n - 2 * x) >= 0 && (s - x * m) / (n - 2 * x) <= m) {
                cout << 2;
                return;
            }
            if (((m * n) - s) % x == 0 && ((m * n) - s) / x <= m) {
                cout << 2;
                return;
            }
        }
    }
    cout << 3;

}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}