#include <bits/stdc++.h>

using namespace std;

struct point {
    double x, y;
    point() {;}
    point(double x0, double y0) {
        x = x0;
        y = y0;
    }
};

struct line {
    double A, B, C;
    line() {;}
    line(point a, point b) {
        A = a.y - b.y;
        B = b.x - a.x;
        C = (a.x - b.x) * a.y + (b.y - a.y) * a.x;
    }
};

double d(line l, point p) {
    double ans = (l.A * p.x + l.B * p.y + l.C) / sqrt(l.A * l.A + l.B * l.B);
    return abs(ans);
}

double f(double x1, double y1, double x2, double y2, double x3, double y3) {
    return d(line(point(x1, y1), point(x2, y2)), point(x3, y3));
}

signed main()
{
    double x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    double f1 = f(x1, y1, x2, y2, x3, y3);
    double f2 = f(x1, y1, x3, y3, x2, y2);
    double f3 = f(x3, y3, x2, y2, x1, y1);
    if (f1 <= f2 && f1 <= f3) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
        return 0;
    }
    if (f2 <= f1 && f2 <= f3) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
        return 0;
    }
    if (f3 <= f1 && f3 <= f2) {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
        return 0;
    }
}
