import math

def triangle_area(c, h):
    if h >= c:
        return -1
    discriminant = c**2 - 4 * h**2
    if discriminant < 0:
        return -1
    p = (c + math.sqrt(discriminant)) / 2
    q = c - p
    if p > 0 and q > 0:
        return c * h / 2
    return -1

c = int(input())
h = int(input())
print(triangle_area(c, h))