def min_cuts(n, m, s):
    if s > n * m:
        return -1
    if s == n * m:
        return 0

    min_cuts = float('inf')

    for i in range(1, n):
        if (s % (i * m) == 0 and (i * m) <= s):
            min_cuts = min(min_cuts, 1)

    for j in range(1, m):
        if (s % (j * n) == 0 and (j * n) <= s):
            min_cuts = min(min_cuts, 1)

    if min_cuts == float('inf'):
        min_cuts = 2
    
    return min_cuts

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
