def solve_bishop():
    import sys
    input = sys.stdin.read
    output = sys.stdout.write
    letters = "abcdefgh"
    numbers = "12345678"

    def pos_to_chess(x, y):
        return letters[x - 1] + numbers[y - 1]

    def find_initial_position():
        x_min, x_max = 1, 8
        y_min, y_max = 1, 8
        bishop_x, bishop_y = None, None
        for dx, dy in [(-7, -7), (7, 7), (7, -7), (-7, 7)]:
            print(f"? {dx} {dy}")
            sys.stdout.flush()
            response = input().strip()
            if response == "+":
                if dx == -7 and dy == -7:
                    x_min, y_min = 1, 1
                elif dx == 7 and dy == 7:
                    x_max, y_max = 8, 8
                elif dx == 7 and dy == -7:
                    x_max, y_min = 8, 1
                elif dx == -7 and dy == 7:
                    x_min, y_max = 1, 8
        for dx, dy in [(-1, -1), (1, 1), (-1, 1), (1, -1)]:
            print(f"? {dx} {dy}")
            sys.stdout.flush()
            response = input().strip()
            if response == "+":
                if dx == -1 and dy == -1:
                    bishop_x, bishop_y = x_min, y_min
                elif dx == 1 and dy == 1:
                    bishop_x, bishop_y = x_max, y_max
                elif dx == -1 and dy == 1:
                    bishop_x, bishop_y = x_min, y_max
                elif dx == 1 and dy == -1:
                    bishop_x, bishop_y = x_max, y_min
        initial_pos = pos_to_chess(bishop_x, bishop_y)
        print(f"! {initial_pos}")
        sys.stdout.flush()
    find_initial_position()