n, m, s = map(int, input().split())

def can_form_s_with_two_cuts(n, m, s):
    # Try cuts at positions that split the grid into sections with areas that can sum up to s
    possible_cuts = [
        (1, 1), (1, n//2), (m//2, 1), (m//2, n//2)
    ]
    for c in range(1, min(5, m)):
        for r in range(1, min(5, n)):
            widths = [c, m - c]
            heights = [r, n - r]
            areas = [w * h for w in widths for h in heights]
            possible_sums = set()
            for i in range(1, 1 << 4):
                total = 0
                for j in range(4):
                    if (i >> j) & 1:
                        total += areas[j]
                possible_sums.add(total)
            if s in possible_sums:
                return True
    return False

if s == n * m:
    print(0)
elif (s % n == 0 and s // n <= m) or (s % m == 0 and s // m <= n):
    print(1)
elif can_form_s_with_two_cuts(n, m, s):
    print(2)
else:
    print(3)