#include <bits/stdc++.h>
using namespace std;

const int MAX_COLOR = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    map<int, map<int, int>> ce;
    map<int, int> cb;
    map<int, set<int>> cg;

    int tb = 0;

    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;

        if (t == '+') {
            cg[c].insert(min(v, u) * MAX_COLOR + max(v, u));
            ce[c][v]++;
            ce[c][u]++;
            cb[c]++;
        } 
        else {
            cg[c].erase(min(v, u) * MAX_COLOR + max(v, u));
            ce[c][v]--;
            ce[c][u]--;
            cb[c]--;
        }

        tb = 0;
        for (auto& [color, edges] : cg) {
            bool is_excellent = true;
            for (auto& [v, count] : ce[color]) {
                if (count > 1) {
                    is_excellent = false;
                    break;
                }
            }
            if (is_excellent) {
                tb += cb[color];
            }
        }

        cout << tb << '\n';
    }

    return 0;
}
