#include <bits/stdc++.h>
using namespace std;

#define MAX_COLOR 100000

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    unordered_map<int, tuple<unordered_map<int, int>, int, unordered_set<int>, int>> color_data;

    int tb = 0;

    auto update_tb = [&]() {
        tb = 0;
        for (auto& [color, data] : color_data) {
            auto& [ce, cb, cg, bad_nodes] = data;
            if (bad_nodes == 0) {
                tb += cb;
            }
        }
    };

    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;

        int edge = min(v, u) * MAX_COLOR + max(v, u);

        auto& [ce, cb, cg, bad_nodes] = color_data[c];

        if (t == '+') {
            cg.insert(edge);
            ce[v]++;
            ce[u]++;
            cb++;

            if (ce[v] == 2) bad_nodes++;
            if (ce[u] == 2) bad_nodes++;
        } 
        else {
            cg.erase(edge);
            ce[v]--;
            ce[u]--;
            cb--;

            if (ce[v] == 1) bad_nodes--;
            if (ce[u] == 1) bad_nodes--;
        }

        update_tb();
        cout << tb << '\n';
    }

    return 0;
}
