#include <bits/stdc++.h>

using namespace std;

int min_cuts(int n, int m, int s) {
	if(s == n * m) {
		return 0;
	}
	int min_cuts = numeric_limits<int>::max();
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			vector<int> areas;
			for (int i = 0; i <= x; i++) {
				for (int j = 0; j <= y; j++) {
					int h = (n / (x + 1)) + (i < (n % (x + 1)) ? 1 : 0);
					int w = (m / (y + 1)) + (j < (m % (y + 1)) ? 1 : 0);
					areas.push_back(h * w);
				}
			}
			sort(areas.rbegin(), areas.rend());
			int current_sum = 0;
			for (int area : areas) {
				current_sum += area;
				if (current_sum >= s) {
					break;
				}
			}
			if (current_sum == s) {
				min_cuts = min(min_cuts, x + y);
			}
		}
	}
	return min_cuts;
}

int main() {
	int n, m, s;
	cin >> n >> m >> s;
	cout << min_cuts(n, m, s) << endl;

	return 0;
}
