#include <bits/stdc++.h>

using namespace std;

long long dist(long long a, long long b, long long c, const vector<pair<int, int>>& p) {
    long long res = 0;
    for (auto& pt : p) {
        res += abs(a * pt.first + b * pt.second + c);
    }
    return res;
}

int main() {
    int x1,y1,x2,y2,x3,y3;
    cin>>x1>>y1>>x2>>y2>>x3>>y3;

    vector<pair<int, int>> pts = {{x1, y1}, {x2, y2}, {x3, y3}};
    long long best = numeric_limits<long long>::max();
    pair<int, int> p1, p2;

    for (int i = 0; i < 3; ++i) {
        for (int j = i + 1; j < 3; ++j) {
            int xA = pts[i].first, yA = pts[i].second;
            int xB = pts[j].first, yB = pts[j].second;

            long long a = yB - yA;
            long long b = xA - xB;
            long long c = xB * yA - xA * yB;

            long long d = dist(a, b, c, pts);
            if (d < best) {
                best = d;
                p1 = {xA, yA};
                p2 = {xB, yB};
            }
        }
    }

    cout << p1.first << " " << p1.second << " " << p2.first << " " << p2.second << endl;
    return 0;
}
