#include <bits/stdc++.h>

bool cmp(std::pair<int64_t, int64_t> a, std::pair<int64_t, int64_t> b) {
    if (a.first == b.first) {
        return a.second < b.second;
    }
    return a.first < b.first;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int64_t n;
    std::cin >> n;
    std::vector<int64_t> a(n), b(n);

    for (int64_t& x : a) {
        std::cin >> x;
    }
    for (int64_t& x : b) {
        std::cin >> x;
    }

    std::vector<std::pair<int64_t, int64_t>> arr;

    for (int64_t i = 0; i < n; i++) {
        if (a[i] > b[i]) {
            std::swap(a[i], b[i]);
        }
        arr.push_back({a[i], b[i]});
    }

    std::sort(arr.begin(), arr.end(), cmp);

    for (int64_t i = 0; i + 1 < n; i++) {
        if (!(arr[i].first < arr[i + 1].first && arr[i].second < arr[i + 1].second)) {
            std::cout << -1;
            return 0;
        }
    }

    for (auto [a, b] : arr) {
        std::cout << a << ' ';
    }
    std::cout << '\n';
    for (auto [a, b] : arr) {
        std::cout << b << ' ';
    }
}
