/*
    Author:Sydyk Assyltay AKA kanye_south
    For: CF 919 Round Div. 2
    Time: 20:34
    Day: 13.01.2024
 
*/
#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define all(x) x.begin(),x.end()
#define ins insert
#define yes cout<<"YES"<<'\n';
#define no cout<<"NO"<<'\n';
#define int long long
#define level_up ios_base::sync_with_stdio(false),cin.tie(nullptr)

using namespace std;

void file(string s) {
    freopen((s+".in").c_str(),"r",stdin);
    freopen((s+".out").c_str(),"w",stdout);
}

const double PI = 3.1415926535897932384626433832795;
const int MOD = 1e9 + 7;
const int N = 2e5 + 7;
const int inf=LLONG_MAX;

void run_case(){
    
    int n,m,s,manp=3;
    
    cin >> n >> m >> s;
    
    for(int i=1;i<=m-1;i++){
        int k=0;
        if(i*n==s or (m-i)*n==s){
            manp=1;
        }
        k=(s-(m-i)*n)/i;
        if (k>=1 and (m-i)*n+(k*i)==s and k<=n){
            manp=min(manp,2ll);
        }
        k=s/i;
        if (k>=1 and (i*k)==s and k<=n){
            manp=min(manp,2ll);
        }
        k=(s-i*n)/(m-i);
        if (k>=1 and (i*n)+(m-i)*k==s and k<=n){
            manp=min(manp,2ll);
        }
        if(2*i!=m){
            k=(s-(n*m)+(i*n))/((2*i)-m);
            if(k>=1 and (i*k)+(m-i)*(n-k)==s and k<=n){
                manp=min(manp,2ll);
            }
        }
    }
    
    for(int i=1;i<=n-1;i++){
        int k=0;
        if(i*m==s or (n-i)*m==s){
            manp=1;
        }
        k=(s-(n-i)*m)/i;
        if(k>=1 and ((n-i)*m)+(k*i)==s and k<=m){
            manp=min(manp,2ll);
        }
        k=s/i;
        if(k>=1 and (i*k)==s and k<=m){
            manp=min(manp,2ll);
        }
        k=(s-i*m)/(n-i);
        if(k>=1 and (i*m)+(n-i)*k==s and k<=m){
            manp=min(manp,2ll);
        }
        if(2*i!=n){
            k=(s-(n*m)+(i*m))/((2*i)-n);
            if (k>=1 and (i*k)+(n-i)*(m-k)==s and k<=m){
                manp=min(manp,2ll);
            }
        }
    }
    
    if(n*m==s){
        cout<<0;
        return;
    }
    
    cout << manp;
}

signed main () {
    
    level_up;

    //freopen("rmq.in","r",stdin);
    //freopen("rmq.out","w",stdout);

    int T=1;
        
    //cin >> T;
    
    while(T--) {
        run_case();
    }
}
/*
 
 
 1 1.5
 2 3.8
 3 6.7
 4 9.0
 5 11.2
 6 13.6
 7 16
 
 
 
 


 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 

 
 
 
 
 
 
 
 
 
 
 */
