/*
    Author:Sydyk Assyltay AKA kanye_south
    For: CF 919 Round Div. 2
    Time: 20:34
    Day: 13.01.2024
 
*/
#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define all(x) x.begin(),x.end()
#define ins insert
#define yes cout<<"YES"<<'\n';
#define no cout<<"NO"<<'\n';
#define int long long
#define level_up ios_base::sync_with_stdio(false),cin.tie(nullptr)

using namespace std;

void file(string s) {
    freopen((s+".in").c_str(),"r",stdin);
    freopen((s+".out").c_str(),"w",stdout);
}

const double PI = 3.1415926535897932384626433832795;
const int MOD = 1e9 + 7;
const int N = 2e5 + 7;
const int inf=LLONG_MAX;
double x[10];
double y[10];

double fin(int i,int j){
    
    return (y[i]-y[j])/(x[i]-x[j]);
    
}

double finn(int i,double m){
    
    return y[i]-m*x[i];
    
}

void run_case(){
    
    int n=3;
    
    for(int i=1;i<=n;i++){
        cin >> x[i] >> y[i];
    }
    
    int mn=inf;
    int cnt=1;
    int pos1=0;
    int pos2=0;
    for(int i=1;i<=n;i++){
        for(int j=i+1;j<=n;j++){
            double a=fin(i,j);
            double c=finn(i,a);
            int b=1;
            int dist=0;
            if(cnt==3){
                dist=abs(a*x[1]-b*y[1]+c)/sqrt(a*a+b*b);
                cnt++;
            }
            if(cnt==2){
                dist=abs(a*x[2]-b*y[2]+c)/sqrt(a*a+b*b);
                cnt++;
            }
            if(cnt==1){
                dist=abs(a*x[3]-b*y[3]+c)/sqrt(a*a+b*b);
                cnt++;
            }
            if(dist<mn){
                mn=dist;
                pos1=i;
                pos2=j;
            }
        }
    }
    
    cout<<x[pos1]<<" "<<y[pos1]<<" "<<x[pos2]<<" "<<y[pos2];
}

signed main () {
    
    level_up;

    //freopen("rmq.in","r",stdin);
    //freopen("rmq.out","w",stdout);

    int T=1;
        
    //cin >> T;
    
    while(T--) {
        run_case();
    }
}
/*
 
 
 1 1.5
 2 3.8
 3 6.7
 4 9.0
 5 11.2
 6 13.6
 7 16
 
 
 
 


 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 

 
 
 
 
 
 
 
 
 
 
 */
