def find_a_b(n, digits):
    # Превращаем строку цифр в целое число
    decimal_part = int(digits)
    
    for b in range(1, 10**6):
        # Мы ищем такое a, чтобы a / b дало указанную дробную часть
        a = decimal_part * b // (10 ** n)  # целочисленное деление
        if 0 &lt; a &lt; b &lt; 10**6 and (a * 10**n) % b == decimal_part:
            return ("YES", a, b)
    
    return "NO"

# Чтение входных данных
n = int(input().strip())
digits = input().strip()

# Получаем результат
result = find_a_b(n, digits)

# Печатаем результат
if result == "NO":
    print(result)
else:
    print(result[0])
    print(result[1], result[2])
