import math

def solve():
    # Ввод данных
    x0, y0 = map(int, input().split())  # начальная точка
    x1, y1 = map(int, input().split())  # конечная точка
    n = int(input())  # количество прыжков
    a = list(map(int, input().split()))  # длины прыжков
    
    # Вектор разницы между конечной и начальной точками
    dx_total = x1 - x0
    dy_total = y1 - y0
    total_distance = math.sqrt(dx_total ** 2 + dy_total ** 2)
    
    # Проверим, возможно ли сделать такие прыжки
    total_jump_length = sum(a)
    if total_jump_length != total_distance:
        print("Impossible")
        return
    
    # Начальная точка
    x, y = x0, y0
    current_dx = dx_total
    current_dy = dy_total
    
    # Печатаем начальную точку
    print("Possible")
    
    for i in range(n):
        # Нормализуем вектор направления
        step_length = a[i]
        
        # Вычисляем нормализованный вектор
        norm = math.sqrt(current_dx ** 2 + current_dy ** 2)
        unit_dx = current_dx / norm
        unit_dy = current_dy / norm
        
        # Делая прыжок
        x += unit_dx * step_length
        y += unit_dy * step_length
        
        # Печатаем новую точку
        print(f"{x:.8f} {y:.8f}")
        
        # Обновляем остаточную разницу в координатах
        current_dx = x1 - x
        current_dy = y1 - y

