def can_arrange_cards(n, a, b):
    # Создаем пары (a[i], b[i]) и сортируем их
    pairs = sorted(zip(a, b))
    # Дальнейшие возможности на выход
    result_a = []
    result_b = []
    last_a = last_b = -1  # Начальные значения

    for x, y in pairs:
        if x >= last_a:  # Если можем взять первый год из пары
            result_a.append(x)
            result_b.append(y)  # Добавляем обратный год
            last_a = x  # Обновляем последний использованный год
        elif y >= last_a:  # Если не можем, но можем взять второй год
            result_a.append(y)
            result_b.append(x)  # Добавляем первый год как обратный
            last_a = y  # Обновляем последний использованный год
        else:  # Если невозможно ни без убывания
            return -1

    return result_a, result_b


# Чтение входных данных
n = int(input().strip())
a = list(map(int, input().strip().split()))
b = list(map(int, input().strip().split()))

result = can_arrange_cards(n, a, b)

if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
