def solve():
    # Считываем значение n
    n = int(input().strip())
    
    # Для n = 1, просто выводим поле с одним элементом
    if n == 1:
        print(1)
        return
    
    # Для n = 2 невозможно разбиение
    if n == 2:
        print(-1)
        return
    
    # Строим поле размера n x n
    grid = [[0] * n for _ in range(n)]
    
    # Нумеруем клетки змейкой
    num = 1
    for i in range(n):
        if i % 2 == 0:  # Четные строки
            for j in range(n):
                grid[i][j] = num
                num += 1
        else:  # Нечетные строки
            for j in range(n-1, -1, -1):
                grid[i][j] = num
                num += 1
    
    # Выводим поле
    for row in grid:
        print(' '.join(map(str, row)))

