#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &	u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

using ld = double;

const ld inf = 3e18;

struct Line{
	ld m, c;
	
	Line(ld m = 0, ld c = inf) : m(m), c(c) {}
	
	ld operator ()(ld x){ return m * x + c; }
	
	bool isOpt(Line ff, Line ss){ // ff > ss
		assert(ff.m != m), assert(ss.m != m);
		
		return (c - ff.c) / (ff.m - m) <= (c - ss.c) / (ss.m - m);
	}
};

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

	int n, m, C; cin >> n >> m >> C;
	
	vector <ld> x(n + 2), t(n + 2);
	
	for ( int i = 1; i <= n; i++ ){
		cin >> x[i] >> t[i];
	} n += 1;
	
	x[n] = m;
	
	vector <ld> dp(n + 1, inf);
	
	deque <Line> dq;
	
	auto ins = [&](int j){
		Line cur = {-x[j], dp[j] + t[j] + x[j] * x[j] / C};
		
		while ( (int)dq.size() > 1 && dq[(int)dq.size() - 2].isOpt(cur, dq.back()) ) dq.pop_back();
		
		dq.pb(cur);
	};
	
	dp[0] = 0; ins(0);
	
	for ( int i = 1; i <= n; i++ ){
		ld X = 2 * x[i] / C;
		
		while ( (int)dq.size() > 1 && dq[0](X) >= dq[1](X) ) dq.pop_front();
		
		dp[i] = dq[0](X) + x[i] * x[i] / C; ins(i);
	}
	
	cout << fixed << setprecision(10) << dp.back();

    cout << '\n';
}
