#include <iostream>
#include <algorithm>

using namespace std;

int main() {
    // Ввод данных
    int n, m, s;
    cin >> n >> m >> s;

    int minCuts = n + m;  // Максимальное количество разрезов, начальное значение

    // Перебираем все возможные вертикальные разрезы
    for (int x = 0; x < n; ++x) {
        // Высота каждой вертикальной части (по горизонтали)
        int height = n / (x + 1);

        // Чтобы площадь была s, нужно найти такую ширину прямоугольника
        if (s % height == 0) {
            int width = s / height;  // Ширина прямоугольника

            // Если ширина прямоугольника помещается в m, то можно сделать разрезы
            if (width <= m) {
                // Теперь считаем, сколько горизонтальных разрезов нужно
                int y = m / width - 1;

                // Обновляем минимальное количество разрезов
                minCuts = min(minCuts, x + y);
            }
        }
    }

    // Выводим минимальное количество разрезов
    cout << minCuts << endl;

    return 0;
}
