#include <iostream>
#include <cstdlib>
#include <ctime>

using namespace std;

// Функция, которая генерирует запрос к жюри (интерактивный запрос)
void makeMove(int x, int y) {
    cout << "? " << x << " " << y << endl;
    cout.flush();
}

int main() {
    // Массив возможных смещений для поиска, чтобы проверить диагонали
    int directions[7][2] = {
        {1, 1}, {1, -1}, {-1, 1}, {-1, -1}, // Прямые диагонали
        {2, 2}, {2, -2}, {-2, 2},            // Диагонали с более большими смещениями
    };
    
    // Стартуем с позиции e7 (4,7), это просто выбор начальной точки.
    // В реальной задаче будет взаимодействие с жюри, и мы будем реагировать на их ответы.
    
    for (int i = 0; i < 7; i++) {
        int x = directions[i][0];
        int y = directions[i][1];
        
        makeMove(x, y);
    }
    
    return 0;
}
