#include <bits/stdc++.h>

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define file(s) if (fopen(s".in", "r")) freopen(s".in", "r", stdin), freopen(s".out", "w", stdout)
#define all(a) a.begin() , a.end()
#define F first
#define S second

using namespace std;
using ll = long long;

const ll N = 250000+5 , inf = 2e9 + 7;
const ll INF = 1e18 ,   mod = 1e9+7;


ll dp[N] , c , x[N] , tim[N];
ll n , m;

struct line {
	ll k = 0 , m = INF;
	line() {}
	line(ll k, ll m): k(k), m(m) {}
	ll get(ll x) {
		return k * x + m;
	}
};

line t[1000001];

void upd(ll v, ll tl, ll tr, line L) {
	// cout << tl <<" " << tr <<" " << L.k <<" "<< L.m << "\n";
	if(t[v].m == INF) {
		t[v] = L;
		return;
	}
	if (tl > tr) return;
	ll tm = (tl + tr) / 2;
	bool l = L.get(x[tl]) > t[v].get(x[tl]);
	bool mid = L.get(x[tm]) < t[v].get(x[tm]);
	if (mid) swap(L, t[v]);
	if (l == mid) upd(2 * v, tl, tm - 1, L);
	else upd(2 * v + 1, tm + 1, tr, L);
}

ll get(ll v, ll tl, ll tr, ll p) {
	if (t[v].m == INF) return t[v].m;
	if (tl > tr) return INF;
	ll tm = (tl + tr) / 2;
    if (p == tm) return t[v].get(x[p]);
    if (p < tm) return min(t[v].get(x[p]), get(2 * v, tl, tm - 1, p));
	else return min(t[v].get(x[p]), get(2 * v + 1, tm + 1, tr, p));
}

void solve(){
	cin >> n >> m >> c;
	for(ll i = 1; i <= n+1; i++){
		if(i <= n) cin >> x[i] >> tim[i];
		else x[i] = m , tim[i] = 0;
	}
	for(ll i = 1; i <= n+1; i++){
		dp[i] = min(tim[i]*c+(x[i]*x[i]) , tim[i]*c+(x[i]*x[i])+get(1,0,n+1,i));
		line nw; 
		nw.k = -2*x[i]; nw.m = dp[i]+(x[i]*x[i]);
		upd(1,0,n+1,nw);
	}
	// for(ll i = 0; i <= n; i++){
		// dp[n+1] = INF;
		// dp[n+1] = min(dp[n+1] , (x[n+1]-x[i])*(x[n+1]-x[i])/c+dp[i]);
	// }
	long double ans = dp[n+1]/c;
	cout << fixed << setprecision(7) << ans;
}
/*

*/
signed main(){
	ios;
	solve();
}
