﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>

using namespace std;

#define ll long long
#define pll pair<ll, ll>

namespace I {
    namespace X {
        void f(istream& cin, ostream& cout) {

        }
    }

    namespace A {
        void f(istream& cin, ostream& cout) {
            ll n;
            cin >> n;
            string s;
            cin >> s;
            ll d0 = 0;
            for (ll i = 0; i < n; ++i) {
                ll p = s[i] - '0';
                ll mn = 1;
                for (ll n0 = n - i - 1; n0--;)
                    mn *= 10;
                d0 += p * mn;
            }
            ll mn = 1;
            for (ll n0 = n; n0--;)
                mn *= 10;
            for (ll a = 1; a < 1e6; ++a) {
                ll b = a * mn / d0;
                ll tmp = a * mn % d0;
                if (tmp != 0 || a >= b || b >= 1e6)
                    continue;
                cout << "YES\n" << a << ' ' << b;
                return;
            }
            cout << "NO\n";
        }
    }
    
    namespace A1 {
        void f(istream& cin, ostream& cout) {
            ll n;
            cin >> n;
            ll a;
            cin >> a;
            ll b = 1;
            while (n--)
                b *= 10;
            cout << a << ' ' << b;
        }
    }

    namespace B {
        void f(istream& cin, ostream& cout) {
            ll b, h;
            cin >> b >> h;
            if (b * b > 2 * h * h) {
                cout << b * h / 2;
                if (b * h % 2)
                    cout << ".5";
                return;
            }
            cout << "-1";
        }
    }

    namespace C {
        void f(istream& cin, ostream& cout) {
            ll k;
            cin >> k;
            cout << k + (k + 1) * k / 2;
        }
    }

    namespace I {
        void f(istream& cin, ostream& cout) {
            ll n;
            cin >> n;
            vector<pll> v(n);
            for (auto& [a, b] : v) {
                cin >> a;
            }
            for (auto& [a, b] : v) {
                cin >> b;
            }
            for (auto& [a, b] : v) {
                if (a > b)
                    swap(a, b);
            }

            sort(v.begin(), v.end());
            for (ll i = 1; i < n; ++i) {
                if (v[i].second < v[i - 1].second) {
                    cout << -1;
                    return;
                }
            }

            for (auto& [a, b] : v)
                cout << a << ' ';
            cout << '\n';
            for (auto& [a, b] : v)
                cout << b << ' ';
        }
    }

    namespace D {
        void f(istream& cin, ostream& cout) {
            ll n, m, s;
            cin >> n >> m >> s;
            ll ans = 0;
            while (s > n && s > m && !(s % n) && !(s % m)) {

            }
        }
    }

    namespace H {
        void f(istream& cin, ostream& cout) {
            ll n, q;
            cin >> n >> q;
            vector<map<ll, ll>> pc(n);
            ll ans = 0;
            vector<ll> scv(1e5);
            vector<ll> nvc(1e5);

            while (q--) {
                char pm;
                ll v, u, c;
                cin >> pm >> v >> u >> c;
                --v, --u, --c;
                if (pm == '+') {
                    if ((pc[v][c] == 1 && pc[u][c] <= 1) || (pc[u][c] == 1 && pc[v][c] <= 1)) {
                        if (nvc[c] == 0) {
                            ans -= scv[c];
                        }
                        ++nvc[c];
                    }
                    if (pc[v][c] == 0 || pc[u][c] == 0) {
                        if (nvc[c] == 0) {
                            ++ans;
                        }
                    }
                    ++pc[v][c];
                    ++pc[u][c];
                    ++scv[c];
                }
                else {
                    if ((pc[v][c] == 2 && pc[u][c] <= 2) || (pc[u][c] == 2 && pc[v][c] <= 2)) {
                        --nvc[c];
                        if (nvc[c] == 0) {
                            ans += scv[c] - 1;
                        }
                    }
                    if ((pc[v][c] == 1 && pc[u][c] <= 1) || (pc[u][c] == 1 && pc[v][c] <= 1)) {
                        if (nvc[c] == 0) {
                            --ans;
                        }
                    }
                    --pc[v][c];
                    --pc[u][c];
                    --scv[c];
                }
                cout << ans << '\n';
            }
        }
    }

}

namespace E {
    namespace X {
        void f(istream& cin, ostream& cout) {

        }
    }
}

namespace V {
    namespace X {
        void f(istream& cin, ostream& cout) {

        }
    }

    namespace D {
        ll cmp(ll n, ll m, ll s) {
            if ((n * m) == s) {
                return 0;
            }
            if ((s % m == 0) || (s % n == 0)) {
                return 1;
            }
            if ((s < m) || (s < n)) {
                return 2;
            }
            for (ll n1 = 1; n1 <= n; ++n1) 
                if (!(s % n1) && s / n1 <= m)
                    return 2;
            if (s > n && s > m) {
                bool f = true;
                for (ll n1 = 1; f && n1 < n && s - m * n1 > 0; ++n1)
                    f = (s - m * n1) % (n - n1);
                return 2 + f;
            }
        }

        void f(istream& cin, ostream& cout) {
            ll n, m, s;
            cin >> n >> m >> s;
            cout << min(cmp(n, m, s), cmp(m, n, s));
        }
    }
}

int main()
{
    using namespace I::H;
#ifdef _DEBUG
    while (cin)
#endif // _DEBUG
        f(cin, cout), (cout << endl);
}
