#include <bits/stdc++.h>
#define fi first
#define se second

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const long long inf = 2e9;
const int N = 250001;

ll x, y, n, m, s;

long long brut(long long n, long long m, long long s) {
    if (s == n * m) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }
    if (s <= max(n, m)) {
        return 2;
    }
    for (ll i = 2; i * i <= s; i++) {
        if (s % i == 0) {
            x = i;
            y = s / i;
            if (x <= n && y <= m) {
                return 2;
            }
            if (x <= m && y <= n) {
                return 2;
            }
        }
    }
    s = n * m - s;
    if (s <= max(n, m)) {
        return 2;
    }
    for (ll i = 2; i * i <= s; i++) {
        if (s % i == 0) {
            x = i;
            y = s / i;
            if (x <= n && y <= m) {
                return 2;
            }
            if (x <= m && y <= n) {
                return 2;
            }
        }
    }
    return 3;
}

long long solve(long long n, long long m, long long s) {
    if (s == n * m) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }

    if (s <= max(n, m)) {
        return 2;
    }

    if (n * m - s <= max(n, m)) {
        return 2;
    }

    for (int j = 1; j <= m - 1; ++j) {
        long long t1 = j, t2 = (m - j);

        if (s % t1 == 0 && s / t1 <= n) {
            return 2;
        }

        if (s % t2 == 0 && s / t2 <= n) {
            return 2;
        }

        if (-t1 + t2 == 0) continue;
        if ((s - n * t1) % (-t1 + t2) != 0) continue;
        long long d = (s - n * t1) / (-t1 + t2);
        if (!(d >= 1 && d < n)) continue;

        return 2;
    }

    for (ll i = 2; i * i <= s; i++) {
        if (s % i == 0) {
            x = i;
            y = s / i;
            if (x <= n && y <= m) {
                return 2;
            }
            if (x <= m && y <= n) {
                return 2;
            }
        }
    }
s = n * m - s;
 for (ll i = 2; i * i <= s; i++) {
        if (s % i == 0) {
            x = i;
            y = s / i;
            if (x <= n && y <= m) {
                return 2;
            }
            if (x <= m && y <= n) {
                return 2;
            }
        }
    }

    return 3;
}

mt19937 rng(time(0));

int main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif //

    long long t =100;
    long long n, m, s;
    cin >> n >> m >> s;

    cout << solve(n, m, s) << "\n";
//    while (t--) {
//        n = 8, m = 6, s = 13;
////        n = rng() % 10 + 1;
////        m = rng() % 10 + 1;
////
////        s = rng() % (n * m) + 1;
//
//        if (solve(n, m, s) != brut(n, m, s)) {
//            cout << n << " " << m << " " << s << "\n";
//            cout << solve(n, m, s) << " " << brut(n, m , s) << "\n";
//        }
//    }

    return 0;
}
