#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}

int sgn(ll a) {
    if (a < 0) {
        return -1;
    }
    if (a > 0) {
        return 1;
    }
    return 0;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    if (s == n * m) {
        cout << 0;
        return;
    }
    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return;
    }
    if (s == n * m / 2 && ((n * m) % 2) == 1) {
        cout << 2;
        return;
    }
    if (s < n || s < m) {
        cout << 2;
        return;
    }
    for (ll b = 1; b < n; b++) {
        if (s % b == 0) {
            ll a = s / b;
            if (a < m) {
                cout << 2;
                return;
            }
        }
        if (s % (n - b) == 0) {
            ll a = s / (n - b);
            if (a < m) {
                cout << 2;
                return;
            }
        }
        ll x = m * n - b * m - s;
        ll y = n - 2 * b;
        if (y == 0) {
            if ((m * n) % 2 == 0) {
                ll a = m * n / 2 + m - s;
                if (a < m && a > 0) {
                    cout << 2;
                    return;
                }
            }
            continue;
        }
        if (sgn(y) * sgn(x) <= 0) {
            continue;
        }
        if (abs(x) % abs(y) == 0) {
            if (abs(x) / abs(y) < m) {
                cout << 2;
                return;
            }
        }
    }
    cout << 3;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}