#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}


ld d(ll a, ll b, ll c, ll x, ll y) {
    ld r = a * x + b * y + c;
    ld l = sqrt(a * a + b * b);
    return abs(r / l);
}

void solve() {
    ll x1, x2, x3, y1, y2, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    ll a = y2 - y1;
    ll b = x1 - x2;
    ll c = x2 * y1 - x1 * y2;
    ld s1 = d(a, b, c, x3, y3);

    a = y3 - y1;
    b = x1 - x3;
    c = x3 * y1 - x1 * y3;
    ld s2 = d(a, b, c, x2, y2);

    a = y2 - y3;
    b = x3 - x2;
    c = x2 * y3 - x3 * y2;
    ld s3 = d(a, b, c, x1, y1);
    if (s1 <= s2 && s1 <= s3) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    }
    else if (s2 <= s1 && s2 <= s3) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    }
    else {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}