#include <bits/stdc++.h>

#define mk make_pair
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector < pair < int, int >> c(n);

    for (int i = 0; i < n; ++i) {
        cin >> c[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i].second;
    }

    vector < int > fr(n), ba(n);
    for (int i = 0; i < n; ++i) {
        fr[i] = min(c[i].first, c[i].second);
        ba[i] = max(c[i].first, c[i].second);
    }

    if (is_sorted(fr.begin(), fr.end()) && is_sorted(ba.begin(), ba.end())) {
        for (int i = 0; i < n; ++i) cout << fr[i] << " ";
        cout << "\n";
        for (int i = 0; i < n; ++i) cout << ba[i] << " ";
        cout << "\n";
        return 0;
    }

    sort(c.begin(), c.end(), [](pair < int, int > a, pair < int, int > b) {
        return min(a.first, a.second) < min(b.first, b.second);
    });

    for (int i = 0; i < n; ++i) {
        fr[i] = min(c[i].first, c[i].second);
        ba[i] = max(c[i].first, c[i].second);
    }

    if (is_sorted(fr.begin(), fr.end()) && is_sorted(ba.begin(), ba.end())) {
        for (int i = 0; i < n; ++i) cout << fr[i] << " ";
        cout << "\n";
        for (int i = 0; i < n; ++i) cout << ba[i] << " ";
        cout << "\n";
    } else {
        cout << "-1\n";
    }

    return 0;
}