n, q = map(int, input().split())
graph = {}
colors = {}

def calculate_beauty(graph, colors):
    beauty = 0
    for color in colors:
        is_excessive = True
        count = 0
        for u in graph:
            for v in graph[u]:
                if (u, v) in colors and colors[(u, v)] == color:
                    count += 1
        if count > 0:
          is_excessive = True
          for u in graph:
            count_u = 0
            for v in graph[u]:
              if (u,v) in colors and colors[(u,v)] == color:
                count_u += 1
            if count_u > 1:
              is_excessive = False
              break
          if is_excessive:
            beauty += 1
    return beauty


for _ in range(q):
    query = input().split()
    op = query[0]
    u, v, c = map(int, query[1:])
    u -= 1
    v -= 1
    c -=1
    
    if op == '+':
        if u not in graph:
            graph[u] = []
        if v not in graph:
            graph[v] = []
        graph[u].append(v)
        graph[v].append(u)
        colors[(u, v)] = c
        colors[(v, u)] = c

    else:
        del colors[(u,v)]
        del colors[(v,u)]
        graph[u].remove(v)
        graph[v].remove(u)
        if len(graph[u])==0:
          del graph[u]
        if len(graph[v])==0:
          del graph[v]

    print(calculate_beauty(graph, colors))
