def min_cuts(n, m, s):
    if s == n * m:
        return 0
    min_cuts = float('inf')
    for x in range(n + 1):
        for y in range(m + 1):
            total_rects = (x + 1) * (y + 1)
            max_area = (n // (x + 1)) * (m // (y + 1))
            if total_rects >= s and max_area == s:
                min_cuts = min(min_cuts, x + y)
    return min_cuts if min_cuts != float('inf') else -1
n, m, s = map(int, input().split())
result = min_cuts(n, m, s)
print(result)