#include <iostream>
#include <tuple>
#include <cmath>
using namespace std;
tuple<double, double, double> findt(double x1, double y1, double x2, double y2) {
    double A = y2 - y1;
    double B = x1 - x2;
    double C = -(A * x1 + B * y1);
    return {A, B, C};
}
void solve(double A, double B, double C) {
    double x1, y1, x2, y2;
    if(B == 0){
        x1 = -1e9;
        y1 = (-C - A * x1) / B;
        x2 = 1e9;
        y2 = (-C - A * x2) / B;
    }
    else {
        x1 = -1e9;
        y1 = (-C - A * x1) / B;
        x2 = 1e9;
        y2 = (-C - A * x2) / B;
    }
    cout << static_cast<int>(x1) << " " << static_cast<int>(y1) << " ";
    cout << static_cast<int>(x2) << " " << static_cast<int>(y2) << endl;
}
int main() {
    double x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    tuple<double, double, double> equation = findt(x1, y1, x2, y2);
    solve(std::get<0>(equation), std::get<1>(equation), std::get<2>(equation));
    return 0;
}
