#include <bits/stdc++.h>

using namespace std;

pair<double long, double long> solve (double long x1, double long x2, double long x3, double long y1, double long y2, double long y3)
{
    double long y, x, b, a;
    a = x1 - x2;
    b = y1 - y2;
    y = (-a * x1 * y2 + a * x2 * y1 + b * y3 * y2 - b * y3 * y1 + a * x3 * y2 - a * x3 * y1) / (a * x2 - a * x1 + b * y2 - b * y1);
    x = (x1 * y2 - x2 * y1 + x2 * y - x1 * y) / (y2 - y1);

    return make_pair(x, y);
}

double long rasst(double long x1, double long y1, double long x2, double long y2)
{
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int main()
{
    double long x1, y1, x2, y2, x3, y3, dl1, dl2, dl3;
    pair<double long, double long> x1x2, x2x3, x1x3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    x1x2 = solve(x1, x2, x3, y1, y2, y3);
    x2x3 = solve(x2, x3, x1, y2, y3, y1);
    x1x3 = solve(x1, x3, x2, y1, y3, y2);
    dl1 = rasst(x1x2.first, x1x2.second, x3, y3);
    dl2 = rasst(x2x3.first, x2x3.second, x1, y1);
    dl3 = rasst(x1x3.first, x1x3.second, x2, y2);
    if (dl1 <= dl2 && dl1 <= dl3)
    {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    }
    else if (dl2 <= dl1 && dl2 <= dl3)
    {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
    }
    else if (dl3 <= dl1 && dl3 <= dl2)
    {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    }
    return 0;
}
