# Координаталарды енгізу
x1, y1, x2, y2, x3, y3 = map(int, input("Координаталарды енгізіңіз (x1 y1 x2 y2 x3 y3): ").split())

# Түзу бойында екі нүктенің арасындағы үшінші нүктеге дейінгі қашықтықты есептеу функциясы
def calculate_distance(x1, y1, x2, y2, x3, y3):
    return abs((y2 - y1) * x3 - (x2 - x1) * y3 + x2 * y1 - y2 * x1)

# Үш нүктенің комбинациялары үшін қашықтықты есептеу
d1 = calculate_distance(x1, y1, x2, y2, x3, y3)  # (x1, y1) және (x2, y2) арқылы
d2 = calculate_distance(x1, y1, x3, y3, x2, y2)  # (x1, y1) және (x3, y3) арқылы
d3 = calculate_distance(x2, y2, x3, y3, x1, y1)  # (x2, y2) және (x3, y3) арқылы

# Қандай түзу ең аз қашықтық береді, соны таңдау
if d1 <= d2 and d1 <= d3:
    p1x, p1y = x1 + (x2 - x1) // 10, y1 + (y2 - y1) // 10
    p2x, p2y = x1 + 3 * (x2 - x1) // 10, y1 + 3 * (y2 - y1) // 10
elif d2 <= d1 and d2 <= d3:
    p1x, p1y = x1 + (x3 - x1) // 10, y1 + (y3 - y1) // 10
    p2x, p2y = x1 + 3 * (x3 - x1) // 10, y1 + 3 * (y3 - y1) // 10
else:
    p1x, p1y = x2 + (x3 - x2) // 10, y2 + (y3 - y2) // 10
    p2x, p2y = x2 + 3 * (x3 - x2) // 10, y2 + 3 * (y3 - y2) // 10

# Нәтижені шығару
print(p1x, p1y, p2x, p2y)
