#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

void solve()
{
    int n, q, ans = 0;
    cin >> n >> q;
    map <pair <int, int>, int> mp;
    map <int, int> cnt;
    while (q--) {
        char cmd;
        int a, b, c;
        cin >> cmd >> a >> b >> c;
        if (cmd == '+') {
            mp[{a, c}]++;
            mp[{b, c}]++;
            if (mp[{a, c}] == 2 || mp[{b, c}] == 2) {
                cnt[c]++;
            }
            if (cnt[c] == 1) {
                ans--;
            }
            if (cnt[c] == 0) {
                ans++;
            }
        } else {
            mp[{a, c}]--;
            mp[{b, c}]--;
            cnt[c] -= (mp[{a, c}] == 1 || mp[{b, c}] == 1);
            if (cnt[c] == 0) {
                ans++;
            }
        }
        cout << ans << '\n';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
/*
4 5
+ 1 2 1
+ 3 4 2
+ 2 4 1
- 2 1 1
+ 2 4 4

3 6
+ 1 2 1
+ 2 3 1
+ 1 3 1
- 1 3 1
- 1 2 1
+ 1 2 1
*/
