import math

def solve(n, decimal_str):
    decimal_part = int(decimal_str)
    denominator = 10**n
    
    gcd_value = math.gcd(decimal_part, denominator)
    a = decimal_part // gcd_value
    b = denominator // gcd_value
    
    if a < b and b < 10**6:
        print("YES")
        print(a, b)
    else:
        print("NO")

n = int(input())  
decimal_str = input().strip()  

solve(n, decimal_str)
