def solve():
    # Read the input
    n = int(input())
    
    # If n = 2, it's impossible to create the required tiling
    if n == 2:
        print(-1)
        return
    
    # Initialize an n x n grid to store the n-minoes' assignments
    grid = [[0] * n for _ in range(n)]
    
    # We need to number the n-minoes from 1 to n, so let's fill the grid
    mino_number = 1
    for i in range(n):
        for j in range(n):
            grid[i][j] = (i + j) % n + 1  # This ensures we are assigning distinct numbers

    # Print the result grid
    for row in grid:
        print(" ".join(map(str, row)))

