#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n, q;
    cin >> n >> q;
    
    const int MAX_C = 100005;
    vector<vector<int>> vertices(MAX_C, vector<int>());
    vector<vector<int>> degrees(MAX_C, vector<int>());
    vector<int> bad_c(MAX_C, 0);
    vector<int> m_c(MAX_C, 0);
    
    long long sum_beauty = 0;
    
    while(q--){
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;
        
        bool was_superior = (bad_c[c] == 0);
        int prior_m_c = m_c[c];
        
        auto update_degree = [&](int vertex, bool add) -> void {
            int idx = lower_bound(vertices[c].begin(), vertices[c].end(), vertex) - vertices[c].begin();
            if(idx < vertices[c].size() && vertices[c][idx] == vertex){
                if(add){
                    degrees[c][idx] +=1;
                    if(degrees[c][idx] ==2){
                        bad_c[c] +=1;
                    }
                }
                else{
                    degrees[c][idx] -=1;
                    if(degrees[c][idx] ==1){
                        bad_c[c] -=1;
                    }
                    if(degrees[c][idx] ==0){
                        vertices[c].erase(vertices[c].begin() + idx);
                        degrees[c].erase(degrees[c].begin() + idx);
                    }
                }
            }
            else{
                if(add){
                    vertices[c].insert(vertices[c].begin() + idx, vertex);
                    degrees[c].insert(degrees[c].begin() + idx, 1);
                }
            }
        };
        
        if(op == '+'){
            m_c[c] +=1;
            update_degree(v, true);
            update_degree(u, true);
        }
        else if(op == '-'){
            m_c[c] -=1;
            update_degree(v, false);
            update_degree(u, false);
        }
        
        bool is_superior_now = (bad_c[c] == 0);
        int new_m_c = m_c[c];
        
        if(was_superior){
            if(is_superior_now){
                if(op == '+'){
                    sum_beauty +=1;
                }
                else {
                    sum_beauty -=1;
                }
            }
            else{
                sum_beauty -= prior_m_c;
            }
        }
        else{
            if(is_superior_now){
                sum_beauty += new_m_c;
            }
        }
        
        cout << sum_beauty << "\n";
    }
}
