n = int(input())
ai = list(map(int, input().split()))
bi = list(map(int, input().split()))

cards = []
for idx in range(n):
    a = ai[idx]
    b = bi[idx]
    if a <= b:
        front = a
        back = b
        flip = False
    else:
        front = b
        back = a
        flip = True
    cards.append((front, back, idx, flip))

cards.sort(key=lambda x: x[0])

possible = True
for i in range(n - 1):
    if cards[i][1] > cards[i + 1][1]:
        possible = False
        break

if not possible:
    print(-1)
else:
    front_sequence = []
    back_sequence = []
    for card in cards:
        front_sequence.append(str(card[0]))
        back_sequence.append(str(card[1]))
    print(' '.join(front_sequence))
    print(' '.join(back_sequence))
