def is_power_of_2_and_5(b):
    # Проверка, является ли b произведением только 2 и 5
    while b % 2 == 0:
        b //= 2
    while b % 5 == 0:
        b //= 5
    return b == 1

def check_decimal(a, b, target):
    # Получаем дробь и сравниваем ее с target
    result = a / b
    # Преобразуем результат в строку, извлекаем нужную часть после запятой
    decimal_part = str(result)[2:2 + len(target)]
    return decimal_part == target

def find_a_b(n, target):
    # Перебираем все возможные b, которые могут быть произведением только 2 и 5
    for b in range(1, 1000000):
        if is_power_of_2_and_5(b):
            # Перебираем все возможные a такие, что 0 < a < b
            for a in range(1, b):
                if check_decimal(a, b, target):
                    return a, b
    return None, None

# Ввод данных
n = int(input())  # Количество знаков после запятой
target = input().strip()  # Строка с нужными знаками после запятой

# Находим числа a и b

a, b = find_a_b(n, target)

if a is None and b is None:
    print("NO")
else:
    print("YES")
    print(a, b)
