def find_route(n):
    # Инициализация маршрута
    route = []
    
    # Начальная точка маршрута
    route.append((n - 1, 0))  # Начинаем с (n-1, 0) (нижний левый угол)
    
    # Первая часть маршрута - движение вдоль строк
    for i in range(n - 1):
        route.append((i, 0))  # Двигаемся по первой колонке до (0, 0)
    
    # Вторая часть маршрута - движение вдоль столбцов
    for i in range(n - 1):
        route.append((n - 1, i + 1))  # Двигаемся по последней строке
    
    return route

# Ввод
n = int(input())

# Нахождение маршрута
route = find_route(n)

# Вывод маршрута
for point in route:
    print(point[0], point[1])
