#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int N = 1e6;
ll n, m, s;

bool check(int i, ll n, ll m) {
    ll l = 1, r = m;
    while (r - l > 1) {
        ll sr = (l + r) / 2;
        if (i * m + (n - i) * sr <= s) {
            l = sr;
        } else {
            r = sr;
        }
    }
    return (i * m + (n - i) * l == s);
}

bool check1(int i, ll n, ll m) {
    ll l = 1, r = m;
    while (r - l > 1) {
        ll sr = (l + r) / 2;
        if (i * sr + (n - i) * (m - sr) == s) return true;
        if (i * sr + (n - i) * (m - sr) < s) {
            if (i > n - i) l = sr; else r = sr;
        } else {
            if (i < n - i) l = sr; else r = sr;
        }
    }
    return (i * l + (n - i) * (m - l) == s);
}

void solve() {
    cin >> n >> m >> s;
    if (n * m == s) {
        cout << 0;
        return;
    }
    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return;
    }
    for (ll i = 1; i < n; ++i) {
        if (s % i == 0 && m >= s / i) {
            cout << 2;
            return;
        }
        if (check(i, n, m) || check1(i, n, m)) {
            cout << 2;
            return;
        }
    }
    for (ll i = 1; i < m; ++i) {
        if (s % i == 0 && n >= s / i) {
            cout << 2;
            return;
        }
        if (check(i, m, n) || check1(i, m, n)) {
            cout << 2;
            return;
        }
    }
    cout << 3;
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
