def lazy_cuts(n, m, k):
    # Если k равно n * m, то резать не нужно
    if k == n * m:
        return 0
    
    # Проверяем, можно ли получить k одним разрезом (горизонтальным или вертикальным)
    if k % n == 0 or k % m == 0:
        return 1

    # Если требуется больше одного разреза
    return 2

# Чтение входных данных
n, m, k = map(int, input().split())

# Вычисляем минимальное количество разрезов
result = lazy_cuts(n, m, k)

# Выводим результат
print(result)
