#include <bits/stdc++.h>

#ifdef LOCAL
#include "algo/debug.h"
#else
#define print(...)
#endif

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define str string

#define all(v)  v.begin(), v.end()
#define fi      first
#define se      second
#define pb      push_back
#define ent     cout << "\n";
#define sz(v)   ll(v.size())

using namespace std;

const long long MOD = 1e9+7, inf = 1e18;
void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    if (n * m == s) {
        cout << "0\n";
        return;
    }
    if (s % m == 0 || s % n == 0) {
        cout << "1\n";
        return;
    }

    ll ok = 0, p = s;

    if (s <= max(n, m)) ok = 1;

    for (ll i=1; i*i<=p; i++) {
        if (p % i == 0) {
            ll x = i;
            ll y = p / i;

            if ((x <= n && y <= m) || (x <= m && y <= n)) {
                ok = 1;
                break;
            }
        }
    }
    p = n * m - s;
    for (ll i=1; i*i<=p; i++) {
        if (p % i == 0) {
            ll x = i;
            ll y = p / i;

            if ((x <= n && y <= m) || (x <= m && y <= n)) {
                ok = 1;
                break;
            }
        }
    }

    for (ll x=1; x<=n; x++) {
        ll up = s - n * m + x * m;
        ll dw = 2 * x - n;

        if (up * dw > 0 && up % dw == 0) {
            ok = 1;
            break;
        }

        up = (n * m - s) - n * m + x * m;
        dw = 2 * x - n;

        if (up * dw > 0 && up % dw == 0) {
            ok = 1;
            break;
        }
    }
    if (ok) {
        cout << "2\n";
    }
    else {
        cout << "3\n";
    }
}

int32_t main() {
    #ifdef ONLINE_JUDGE
        // freopen("input.txt","r",stdin);
        // freopen("output.txt","w",stdout);
    #endif
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    ll ttest=1;
    // cin >> ttest;

    for (ll test_number=1; test_number<=ttest; test_number++) {
        solve();
    }

    return 0;
}