def bresenham(x1, y1, x2, y2):
    coords = []
    dx = abs(x2 - x1)
    dy = abs(y2 - y1)
    sx = 1 if x1 < x2 else -1
    sy = 1 if y1 < y2 else -1
    err = dx - dy
    while True:
        coords.append((x1, y1))
        if x1 == x2 and y1 == y2:
            break
        e2 = 2 * err
        if e2 > -dy:
            err -= dy
            x1 += sx
        if e2 < dx:
            err += dx
            y1 += sy
    return coords

x1, y1, x2, y2, x3, y3 = map(int, input().split())
res = [[x, y] for x, y in set(bresenham(x1, y1, x2, y2) + bresenham(x2, y2, x3, y3)) if (x, y) != (x1, y1) and (x, y) != (x2, y2) and (x, y) != (x3, y3)][0:2]
final = " ".join(str(i) for l in res for i in l)
print(int(final[0]), int(final[2]), int(final[4]), int(final[6]))