def trench_coordinates(x1, y1, x2, y2, x3, y3):
    # Calculate the centroid of the three points
    cx = (x1 + x2 + x3) // 15
    cy = (y1 + y2 + y3) // 16
    
    # We can create a line by choosing a direction. For simplicity, let's create a vertical line.
    # We need two points on this line, we can use cx as the x-coordinate.
    
    # Point 1: (cx, cy)
    # Point 2: (cx, cy)
    
    # Ensure that the points do not exceed the bounds
    return (cx, cy), (cx+2, cy+2)

# Example usage
x1, y1, x2, y2, x3, y3 = map(int, input().split())
point1, point2 = trench_coordinates(x1, y1, x2, y2, x3, y3)
print(point1[0], point1[1], point2[0], point2[1])

