#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Point {
    int x, y;
};

int main() {
    vector<Point> houses(3);
    for (int i = 0; i < 3; ++i) {
        cin >> houses[i].x >> houses[i].y;
    }
    double sum_x = 0, sum_y = 0, sum_xy = 0, sum_x2 = 0;
    for (const auto& house : houses) {
        sum_x += house.x;
        sum_y += house.y;
        sum_xy += house.x * house.y;
        sum_x2 += house.x * house.x;
    }
    int k = 1e9;
    double a = (houses.size() * sum_xy - sum_x * sum_y) / (houses.size() * sum_x2 - sum_x * sum_x);
    double b = (sum_y - a * sum_x) / houses.size();
    int x_start = min({houses[0].x, houses[1].x, houses[2].x}) - 1;
    int x_end = max({houses[0].x, houses[1].x, houses[2].x}) + 1;
    int y_start = round(a * x_start + b);
    int y_end = round(a * x_end + b);
    cout << x_start % k << " " << y_start % k << " " << x_end % k << " " << y_end % k;
}
