﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
void solve() {
    int n, m; cin >> n >> m;
    vector <map <int, set <int>>> v(n);
    ll sum = 0;
    while (m--) {
        char t; cin >> t;
        if (t == '+') {
            int a, b, c; cin >> a >> b >> c;
            a--; b--;
            if (v[a][c].size() == 1 && v[b][c].size() == 1 && *v[a][c].begin() == a && *v[b][c].begin() == b)
                sum--;
            else {
                if (v[a][c].size() == 1 && v[*v[a][c].begin()][c].size() == 1)
                    sum--;
                if (v[b][c].size() == 1 && v[*v[b][c].begin()][c].size() == 1)
                    sum--;
            }
            v[a][c].insert(b);
            v[b][c].insert(a);
            if (v[a][c].size() == 1 && v[b][c].size() == 1 && *v[a][c].begin() == b && *v[b][c].begin() == a)
                sum++;
        }
        else {
            int a, b, c; cin >> a >> b >> c;
            a--; b--;
            if (v[a][c].size() == 1 && v[b][c].size() == 1 && *v[a][c].begin() == b && *v[b][c].begin() == a)
                sum--;
            v[a][c].erase(b);
            v[b][c].erase(a);
            if (v[a][c].size() == 1 && v[b][c].size() == 1 && *v[a][c].begin() == a && *v[b][c].begin() == b) {
                sum++;
                continue;
            }
            if (v[a][c].size() == 1 && v[*v[a][c].begin()][c].size() == 1)
                sum++;
            if (v[b][c].size() == 1 && v[*v[b][c].begin()][c].size() == 1)
                sum++;
        }
        cout << sum << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}