def is_sorted(arr):
    """Функция проверяет, является ли список строго возрастающим."""
    return all(arr[i] < arr[i + 1] for i in range(len(arr) - 1))

def galactic_timeline(n, top, bottom):
  
    cards = [(min(top[i], bottom[i]), max(top[i], bottom[i])) for i in range(n)]
 
    cards.sort()

    top_variant_1 = [cards[i][0] for i in range(n)]
    bottom_variant_1 = [cards[i][1] for i in range(n)]

    top_variant_2 = [cards[i][1] for i in range(n)]
    bottom_variant_2 = [cards[i][0] for i in range(n)]

    if is_sorted(top_variant_1) and is_sorted(bottom_variant_1):
        print(*top_variant_1)
        print(*bottom_variant_1)
    elif is_sorted(top_variant_2) and is_sorted(bottom_variant_2):
        print(*top_variant_2)
        print(*bottom_variant_2)
    else:
        print(-1)

n = int(input())
top = list(map(int, input().split()))
bottom = list(map(int, input().split()))

galactic_timeline(n, top, bottom)

