#include <iostream>
#include <cmath>
#include <iomanip>
using namespace std;
int main() {
    double c, h; 
    cin >> c >> h;
 if (c <= 0 || h <= 0 || h >= c) {
        cout << "-1" << endl;
        return 0;
    }
double a_squared = (c * c) / 4.0 + h * h;
    double b_squared = (c * c) / 4.0 - h * h;
if (b_squared < 0) {
        cout << "-1" << endl;
        return 0;
    }
 double a = sqrt(a_squared);
    double b = sqrt(b_squared);
    const double EPS = 1e-9;
    if (fabs(a * a + b * b - c * c) > EPS) {
        cout << "-1" << endl;
        return 0;
    }
double area = (c * h) / 2.0;
    cout << fixed << setprecision(6) << area << endl;
return 0;
}
