#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll gcd(ll a, ll b) {return b ? gcd(b, a % b) : a;}
int lcm(int a, int b) {return a / gcd(a, b) * b;}
ll b_search(vector<ll> &a, ll &n, ll &x) {
    ll l = 0, r = n, mid = 0;
    while (r >= l) {
        mid = (l + r) / 2;
        if (a[mid] == x) {
            return true;
        } else if (a[mid] > x) {
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    return mid;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n; cin >> n;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (ll i = 0; i < n; i++) {
        ll x; cin >> x;
        if (x < a[i].first) {
            a[i].second = x;
            swap(a[i].first, a[i].second);
            continue;
        }
        a[i].second = x;

    }
    sort(a.begin(), a.end());
    for (ll i = 0; i < n; i++) {
        if(a[i].second > a[i + 1].second) {
            cout << -1;
            return 0;
        }
    }
    for (ll i = 0; i < n; i++) {
        cout << a[i].first << ' ';
    }
    cout << endl;
    for (ll i = 0; i < n; i++) {
        cout << a[i].second << ' ';
    }
    return 0;
}
