#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

int main() {
  ll x1, y1, x2, y2, x3, y3;
  cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

  double d1, d2, d3;
  double b1, b2, b3;
  double k1, k2, k3;

  {
    k1 = (y2 - y1) / (x2 - x1);
    b1 = y1 - k1 * x1;

    d1 = abs(k1 * x3 - y3 + b1) / sqrt(k1 * k1 + 1);
  }

  {
    k2 = (y3 - y1) / (x3 - x1);
    b2 = y1 - k2 * x1;

    d2 = abs(k2 * x2 - y2 + b2) / sqrt(k2 * k2 + 1);
  }

  {
    k3 = (y3 - y2) / (x3 - x2);
    b3 = y2 - k3 * x2;

    d3 = abs(k3 * x1 - y1 + b3) / sqrt(k3 * k3 + 1);
  }

  double maximum = min(d1, min(d2, d3));

  if (d1 == maximum) {
    cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
  } else if (d2 == maximum) {
    cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3 << '\n';
  } else if (d3 == maximum) {
    cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3 << '\n';
  }
}
