def find_line_through_points(x1, y1, x2, y2, x3, y3):
    mx = (x1 + x2 + x3) / 3
    my = (y1 + y2 + y3) / 3

    dx = x2 - x1
    dy = y2 - y1

    if dx == 0 and dy == 0:
        raise ValueError()

    p1x = int(mx + dy)
    p1y = int(my - dx)

    p2x = int(mx - dy)
    p2y = int(my + dx)

    return p1x, p1y, p2x, p2y

x1, y1, x2, y2, x3, y3 = map(int, input().split())

p1x, p1y, p2x, p2y = find_line_through_points(x1, y1, x2, y2, x3, y3)

print(p1x, p1y, p2x, p2y)
