#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif

      ll n, m, s;
      cin >> n >> m >> s;

      if (n > m) swap(n, m);

      if (n * m == s) {
            cout << 0 << "\n";
            return 0;
      }

      if (s % n == 0 || s % m == 0) {
            cout << 1 << "\n";
            return 0;
      }

      for (int y = 1; y <= n - 1; ++y) {
            {
                  if ((s - y * m) % (n - y) != 0) continue;
                  ll x = (s - y * m) / (n - y);
                  if (x <= 0 || x >= m) continue;
                  cout << 2 << "\n";
                  return 0;
            }
            {
                  if ((s - n * m + m * y) % (2ll * y - n) != 0) continue;
                  ll x = (s - n * m + m * y) / (2ll * y - n);
                  if (x <= 0 || x >= m) continue;
                  cout << 2 << "\n";
                  return 0;
            }
      }

      for (ll i = 1; i * i <= s; ++i) {
            if (s % i != 0) continue;
            ll j = s / i;

            if (i <= n && j <= m) {
                  cout << 2 << "\n";
                  return 0;
            }
      }
      s = n * m - s;
      for (ll i = 1; i * i <= s; ++i) {
            if (s % i != 0) continue;
            ll j = s / i;

            if (i <= n && j <= m) {
                  cout << 2 << "\n";
                  return 0;
            }
      }


      cout << 3 << "\n";
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion