#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif
      int n;
      cin >> n;
      vector<int> a(n), b(n);
      cin >> a >> b;

      multiset<pair<int, int> > s1, s2;
      for (int i = 0; i < n; ++i) {
            s1.insert({a[i], b[i]});
            s2.insert({b[i], a[i]});
      }

      vector<int> resa, resb;
      for (int i = 0; i < n; ++i) {
            auto f = *s1.begin();
            auto s = *s2.begin();

            if (f < s) {
                  resa.push_back(f.first);
                  resb.push_back(f.second);
                  s1.extract(f);
                  swap(f.first, f.second);
                  s2.extract(f);
            } else {
                  resa.push_back(s.first);
                  resb.push_back(s.second);
                  s2.extract(s);
                  swap(s.first, s.second);
                  s1.extract(s);
            }
      }

      for (int i = 1; i < n; ++i) {
            if (resa[i] < resa[i - 1] || resb[i] < resb[i - 1]) {
                  cout << -1 << "\n";
                  return 0;
            }
      }

      cout << resa << resb;
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion