def is_valid(n):
    
    return n != 2

def solve(n):
    
    if not is_valid(n):
        print(-1)
        return

    grid = [[0] * n for _ in range(n)]

    current_label = 1

    directions = [(0, 1), (1, 0), (0, -1), (-1, 0)]  
    x, y = 0, 0 
    direction_idx = 0  
    for i in range(n * n):
        grid[x][y] = current_label
        nx, ny = x + directions[direction_idx][0], y + directions[direction_idx][1]
        
        if not (0 <= nx < n and 0 <= ny < n and grid[nx][ny] == 0):
            direction_idx = (direction_idx + 1) % 4 
            nx, ny = x + directions[direction_idx][0], y + directions[direction_idx][1]
        
        x, y = nx, ny

        if (i + 1) % n == 0:
            current_label += 1

    for row in grid:
        print(" ".join(map(str, row)))

n = int(input())
solve(n)
