from collections import defaultdict

def main():
    n, q = map(int, input().split())
    fggf = {}
    vr = [defaultdict(int) for _ in range(n + 1)]
    pc = set()

    def klychkov(v, u, c):
        edge = (min(v, u), max(v, u))
        fggf.setdefault(c, set()).add(edge)
        vr[v][c] += 1
        vr[u][c] += 1
        if vr[v][c] <= 1 and vr[u][c] <=1:
            pc.add(c)
        else:
            pc.discard(c)

    def puck(v, u, c):
        edge = (min(v, u), max(v, u))
        fggf[c].remove(edge)
        if not fggf[c]:
            del fggf[c]
        vr[v][c] -= 1
        vr[u][c] -= 1
        if vr[v][c] <= 1 and vr[u][c] <= 1:
            pc.add(c)
        else:
            pc.discard(c)


    for _ in range(q):
        op, v, u, c = input().split()
        v, u, c = int(v), int(u), int(c)

        if op == '+':
            klychkov(v, u, c)
        else:
            puck(v, u, c)

        res = sum(len(fggf.get(c, set())) for c in pc)
        print(res)

main()