from collections import defaultdict

n, q = map(int, input().split())
fgf = defaultdict(set)
vd = defaultdict(lambda: defaultdict(int))

def add_edge(color, u, v):
    edge = (min(u, v), max(u, v))
    fgf[color].add(edge)
    vd[u][color] += 1
    vd[v][color] += 1

def kl(color, u, v):
    edge = (min(u, v), max(u, v))
    fgf[color].discard(edge)
    vd[u][color] -= 1
    vd[v][color] -= 1

def is_perfect(color):
    return all(y <= 1 for x in vd.values() for y in x.values() if x and color in x)


for _ in range(q):
    query = input().split()
    op, u, v, c = query[0], int(query[1]), int(query[2]), int(query[3])
    if op == '+':
        add_edge(c, u, v)
    else:
        kl(c, u, v)
    ans = sum(len(fgf[color]) for color in fgf if is_perfect(color))
    print(ans)