def min_cuts(n, m, s):
    if s == n * m:
        return 0
    min_cuts = float('inf')

    for x in range(n):
        for y in range(m):
            parts = []
            for i in range(x + 1):
                for j in range(y + 1):
                    width = m // (y + 1) + (1 if j < m % (y + 1) else 0)
                    height = n // (x + 1) + (1 if i < n % (x + 1) else 0)
                    parts.append(width * height)

            parts.sort(reverse=True)
            current_sum = 0
            for part in parts:
                if current_sum >= s:
                    break
                current_sum += part
            if current_sum == s:
                min_cuts = min(min_cuts, x + y)

    return min_cuts

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
