import heapq


def f(n, m, c, stations):
    stations.append((m, 0))
    stations.sort()
    dp = [float('inf')] * (n + 1)
    dp[0] = 0
    pq = []
    for i in range(n + 1):
        x_i, t_i = stations[i]
        while pq and stations[pq[0]][0] < x_i - c:
            heapq.heappop(pq)
        if pq:
            j = pq[0]
            dp[i] = dp[j] + (x_i - stations[j][0]) ** 2 / c + t_i
        heapq.heappush(pq, i)

    return dp[n]


n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]
result = f(n, m, c, stations)
print(f"{result:.10f}")
