#include <bits/stdc++.h>
using namespace std;

int main() {
    long long n, q;
    cin >> n >> q;

    unordered_map<long long, long long> total_count;
    vector<unordered_map<long long, long long>> node_color_count(n + 1);
    unordered_map<long long, long long> invalid_count;
    unordered_set<long long> active_colors;
    while (q--) {
        char op;
        long long v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            if (++total_count[c] == 1) active_colors.insert(c);
            if (++node_color_count[v][c] == 2) invalid_count[c]++;
            if (++node_color_count[u][c] == 2) invalid_count[c]++;
        } else if (op == '-') {
            if (--node_color_count[v][c] == 1) invalid_count[c]--;
            if (--node_color_count[u][c] == 1) invalid_count[c]--;
            if (--total_count[c] == 0) active_colors.erase(c);
        }

        long long valid_sum = 0;
        for (long long color : active_colors) {
            if (invalid_count[color] == 0) {
                valid_sum += total_count[color];
            }
        }
        cout << valid_sum << endl;
    }
}
