#include <iostream>

using namespace std;

char check(int x, int y) {
    cout << "? " << x << " " << y << endl;
    char t;
    cin >> t;
    return t;
}

int main() {
    int row = 4; //Start at row 4
    int col = 4; //Start at column 4


    // First move: check moving right and up
    char resp1 = check(4,4); // Start with a relatively large move to quickly rule out sections of the board

    if(resp1 == '+'){
        // If this works, we need to further refine the position
        char resp2 = check(1,1);
        if(resp2 == '+') {row++; col++;} // Adjust position if the smaller move also worked

    }else{
        // Try moving in the opposite direction
        char resp2 = check(-4,-4);
        if (resp2 == '+'){
            // refine position
            char resp3 = check(-1,-1);
            if(resp3 == '+'){ row--; col--;} //Adjust position
        }

    }



    //Further refinement using smaller moves to pinpoint the exact location.
    // The following moves try to "home in" on the bishop's position by checking progressively smaller areas.


    char resp3 = check(1,1);
    if(resp3 == '+'){row++; col++;}
    char resp4 = check(-1,-1);
    if(resp4 == '+'){row--; col--;}
    char resp5 = check(1,-1);
    if(resp5 == '+'){row++; col--;}
    char resp6 = check(-1,1);
    if(resp6 == '+'){row--; col++;}

    cout << "! " << (char)('a' + col -1) << row << endl;
    return 0;
}
