#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;

struct C {
    int i;
    long long x, y;
    long long a, b;
    bool f;
};

int main() {
    int n;
    cin >> n;
    vector<C> c(n);
    for (int j = 0; j < n; ++j) {
        cin >> c[j].a;
        c[j].i = j;
    }
    for (int j = 0; j < n; ++j) {
        cin >> c[j].b;
        c[j].x = min(c[j].a, c[j].b);
        c[j].y = max(c[j].a, c[j].b);
        c[j].f = false;
    }
    sort(c.begin(), c.end(), [](const C& p, const C& q) {
        return p.x < q.x;
    });

    long long pf = numeric_limits<long long>::min();
    long long pb = numeric_limits<long long>::min();

    for (int j = 0; j < n; ++j) {
        if (c[j].x >= pf && c[j].y >= pb) {
            pf = c[j].x;
            pb = c[j].y;
            if (c[j].a != c[j].x) {
                c[j].f = true;
            }
        } else if (c[j].y >= pf && c[j].x >= pb) {
            pf = c[j].y;
            pb = c[j].x;
            if (c[j].a != c[j].y) {
                c[j].f = true;
            }
        } else {
            cout << -1 << endl;
            return 0;
        }
    }

    vector<long long> fr(n), bk(n);
    for (int j = 0; j < n; ++j) {
        int idx = c[j].i;
        if (!c[j].f) {
            fr[j] = c[j].a;
            bk[j] = c[j].b;
        } else {
            fr[j] = c[j].b;
            bk[j] = c[j].a;
        }
    }

    for (int j = 0; j < n; ++j) {
        cout << fr[j] << (j == n - 1 ? '\n' : ' ');
    }
    for (int j = 0; j < n; ++j) {
        cout << bk[j] << (j == n - 1 ? '\n' : ' ');
    }

    return 0;
}