#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n;
    std::cin >> n;
    
    std::vector<int> vec1(n);
    std::vector<int> vec2(n);
    std::vector<int> sums(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> vec1[i];
    }

    for (int j = 0; j < n; ++j) {
        std::cin >> vec2[j];
    }

    // Create vec3 and vec4 by calculating min and max of vec1 and vec2
    std::vector<int> vec3(n);
    std::vector<int> vec4(n);
    for (int j = 0; j < n; ++j) {
        vec3[j] = std::min(vec1[j], vec2[j]);
        vec4[j] = std::max(vec1[j], vec2[j]);
        sums[j] = vec3[j] + vec4[j];
    }

    // Sort vec3, vec4, and sums
    std::sort(vec3.begin(), vec3.end());
    std::sort(vec4.begin(), vec4.end());
    std::sort(sums.begin(), sums.end());

    // Check if the sums are the same
    for (int i = 0; i < n; ++i) {
        if (sums[i] != vec3[i] + vec4[i]) {
            std::cout << -1 << std::endl;
            return 0;
        }
    }

    // Output the sorted vectors
    for (int x : vec3) {
        std::cout << x << ' ';
    }
    std::cout << std::endl;
    
    for (int x : vec4) {
        std::cout << x << ' ';
    }
    std::cout << std::endl;

    return 0;
}
