#include <iostream>
#include <cmath>
using namespace std;

// Функция для нахождения коэффициентов прямой, проходящей через две точки (x1, y1) и (x2, y2)
void findLine(int x1, int y1, int x2, int y2, double& A, double& B, double& C) {
    A = y2 - y1;     // Разность по y
    B = x1 - x2;     // Разность по x
    C = A * x1 + B * y1;  // Коэффициент C для уравнения прямой Ax + By = C
}

int main() {
    // Ввод координат трех точек
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    // Коэффициенты для прямой, минимизирующей расстояние
    double A, B, C;

    // Рассчитываем прямую, минимизирующую расстояние
    // Прямая, проходящая через точки (x1, y1) и (x2, y2)
    findLine(x1, y1, x2, y2, A, B, C);

    // Теперь находим две точки, через которые будет проходить эта прямая
    // Первая точка: пусть x = 1
    double x_start = 1;
    double y_start = (C - A * x_start) / B;

    // Вторая точка: пусть x = 3
    double x_end = 3;
    double y_end = (C - A * x_end) / B;

    // Выводим координаты двух точек
    cout << round(x_start) << " " << round(y_start) << " " << round(x_end) << " " << round(y_end) << endl;

    return 0;
}
