def find_elephant_position():
    row = 4
    col = 4  # Начальная позиция d4
    max_row, max_col = 8, 8

    while True:
        # Поиск ряда
        while row > 1 and row < max_row:
            mid_row = (row + max_row) // 2
            if make_move(0, mid_row - row):
                row = mid_row
            else:
                max_row = mid_row

        # Поиск столбца
        while col > 1 and col < max_col:
            mid_col = (col + max_col) // 2
            if make_move(mid_col - col, 0):
                col = mid_col
            else:
                max_col = mid_col

        # Если область поиска сузилась до одной клетки, то это и есть ответ
        if row == 1 and col == 1:
            return 'a1'
        elif row == 1 and col == 8:
            return 'h1'
        elif row == 8 and col == 1:
            return 'a8'
        elif row == 8 and col == 8:
            return 'h8'

        # Если не нашли точное положение, то слон находится на одной из границ
        # (нужно уточнить, на какой именно)
        # ... (дополнительные проверки)

# Функция для выполнения хода и получения результата
def make_move(dx, dy):
    # Отправляем запрос на сервер
    # ...
    # Возвращаем True, если ход удался, иначе False
