#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    // Массивы для лицевых и оборотных сторон
    vector<int> front, back;

    // Переменные для хранения предыдущих годов
    int prev_front = -1, prev_back = -1;

    for (int i = 0; i < n; ++i) {
        int f = a[i], s = b[i];

        // Рассматриваем два варианта: оставляем как есть или переворачиваем
        if (f < s) {
            if (f >= prev_front && s >= prev_back) {
                front.push_back(f);
                back.push_back(s);
                prev_front = f;
                prev_back = s;
            } else if (s >= prev_front && f >= prev_back) {
                front.push_back(s);
                back.push_back(f);
                prev_front = s;
                prev_back = f;
            } else {
                cout << -1 << endl;
                return 0;
            }
        } else if (s < f) {
            if (s >= prev_front && f >= prev_back) {
                front.push_back(s);
                back.push_back(f);
                prev_front = s;
                prev_back = f;
            } else if (f >= prev_front && s >= prev_back) {
                front.push_back(f);
                back.push_back(s);
                prev_front = f;
                prev_back = s;
            } else {
                cout << -1 << endl;
                return 0;
            }
        } else {
            if (f >= prev_front && s >= prev_back) {
                front.push_back(f);
                back.push_back(s);
                prev_front = f;
                prev_back = s;
            } else {
                cout << -1 << endl;
                return 0;
            }
        }
    }

    // Выводим результат
    for (int i = 0; i < n; ++i) {
        cout << front[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < n; ++i) {
        cout << back[i] << " ";
    }
    cout << endl;

    return 0;
}
