def min_cuts(n, m, s):
    # Пройдем по всем возможным количествам вертикальных и горизонтальных разрезов
    min_cuts = float('inf')  # Изначально считаем, что минимальных разрезов нет
    
    for x in range(n):  # x — вертикальные разрезы
        for y in range(m):  # y — горизонтальные разрезы
            # Вычислим количество частей после разрезов
            num_pieces = (x + 1) * (y + 1)
            
            # Если количество частей больше чем s, продолжаем
            if num_pieces * n * m > s:
                continue
            
    return
