def solve(n, m, s):
    
    if s == n * m:
        print(0)
        return
    
   
    min_cuts = float('inf')

    
    for x in range(n + 1):
        
        if s % (x + 1) == 0:
            area_per_part = s // (x + 1)
            if area_per_part <= m:
               
                y = (area_per_part + m - 1) // area_per_part - 1
                if y >= 0:
                    min_cuts = min(min_cuts, x + y)

    if min_cuts == float('inf'):
        print(-1)
    else:
        print(min_cuts)


n, m, s = map(int, input().split())
solve(n, m, s)
