def solve(n, m, s):
    if n * m == s:
        print(0)
        return
    min_cuts = float('inf')
    for height in range(1, int(s**0.5) + 1):
        if s % height == 0:
            width = s // height
            if height <= n and width <= m:
                x = (n // height) - 1  
                y = (m // width) - 1  
                min_cuts = min(min_cuts, x + y)
            if width <= n and height <= m:
                x = (n // width) - 1 
                y = (m // height) - 1 
                min_cuts = min(min_cuts, x + y)
    if min_cuts == float('inf'):
        print(-1)
    else:
        print(min_cuts)
n, m, s = map(int, input().split())
solve(n, m, s)
