#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define F first
#define S second
struct Station {
    ll x;
    ll t;
};
bool cmp(Station &a, Station &b){
    return a.x < b.x;
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    ll m;
    double c;
    cin >> n >> m >> c;
    vector<Station> stations(n);
    for(int i=0; i<n; ++i){
        cin >> stations[i].x >> stations[i].t;
    }
    n++;
    Station dest;
    dest.x = m;
    dest.t = 0;
    stations.push_back(dest);
    sort(stations.begin(), stations.end(), cmp);
    Station start;
    start.x = 0;
    start.t = 0;
    stations.insert(stations.begin(), start);
    n +=1;
    vector<double> dp(n, 0.0);
    dp[0] = 0.0;
    deque<pair<double, double>> dq;
    double m0 = -2.0 * stations[0].x / c;
    double b0 = dp[0] + (double)(stations[0].x) * stations[0].x / c + (double)(stations[0].t);
    dq.emplace_back(m0, b0);
    for(int i=1; i<n; ++i){
        double xi = (double)(stations[i].x);
        double ti = (double)(stations[i].t);
        while(dq.size() >=2){
            double m1 = dq[0].F;
            double b1 = dq[0].S;
            double m2 = dq[1].F;
            double b2 = dq[1].S;
            double y1 = m1 * xi + b1;
            double y2 = m2 * xi + b2;
            if(y1 <= y2){
                break;
            }
            dq.pop_front();
        }
        double optimal_m = dq[0].F;
        double optimal_b = dq[0].S;
        dp[i] = (xi * xi) / c + optimal_m * xi + optimal_b;
        
        if(i < n){
            double mi = -2.0 * xi / c;
            double bi = dp[i] + (xi * xi) / c + ti;
            while(dq.size() >=2){
                double m1 = dq[dq.size()-2].F;
                double b1 = dq[dq.size()-2].S;
                double m2 = dq[dq.size()-1].F;
                double b2 = dq[dq.size()-1].S;
                double intersect1 = (b2 - b1) / (m1 - m2);
                double intersect2 = (bi - b2) / (m2 - mi);
                
                if(intersect1 >= intersect2){
                    dq.pop_back();
                }
                else{
                    break;
                }
            }
            dq.emplace_back(mi, bi);
        }
    }
    cout << fixed << setprecision(10) << dp[n-1] << "\n";
}
