def collections import deque

def solve():
  x0, y0 = map(int, input().split())
  x1, y1 = map(int, input().split())
  a = list(map(int, input().split()))

  q = deque([(x0, y0, [])])
  visited = set()

  while q:
    x, y, path = q.popleft()
    if (x, y) == (x1, y1):
      print("Possible")
      print(*path)
      return

    visited.add((x, y))

    for step in a:
      for dx, dy in [(0, step), (0, -step), (step, 0), (-step, 0)]:
        nx, ny = x + dx, y + dy
        if (nx, ny) not in visited:
          new_path = path + [(nx, ny)]
          q.append((nx, ny, new_path))

  print("Impossible")

solve()
