#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

bool check_decimal(int a, int b, int n, const string& digits) {
    // ???????? ??????? ???????, ??????? ?????? n ???? ????? ???????
    int remainder = a % b;
    string result = "";
    
    for (int i = 0; i < n; ++i) {
        remainder *= 10;
        int digit = remainder / b;
        remainder = remainder % b;
        result += to_string(digit);
    }
    
    // ?????????? ?????????? ?????? ? ????????? ??????? ????? ???????
    return result == digits;
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;
    
    // ??????? ??? ???????? b ?? 1 ?? 999999
    for (int b = 1; b < 1000000; ++b) {
        for (int a = 1; a < b; ++a) {
            if (check_decimal(a, b, n, digits)) {
                cout << "YES\n" << a << " " << b << endl;
                return 0;
            }
        }
    }
    
    cout << "NO\n";
    return 0;
}
