def is_valid_b(b):
   
    while b % 2 == 0:
        b //= 2
    while b % 5 == 0:
        b //= 5
    return b == 1

def main():
 
    n = int(input())
    digits = input().strip()

    decimal_part = int(digits) / (10 ** n)

    for b in range(1, 10**6):
        if not is_valid_b(b):
            continue  

   
        a_double = b * decimal_part
        a = round(a_double)

  
        if 0 < a < b and abs(a_double - a) < 1e-9:
            print("YES")
            print(a, b)
            return

 
    print("NO")

if __name__ == "__main__":
    main()
