def solve():
    n = int(input())  # Читаем размер поля n
    
    if n == 2 or n == 3:  # Для n = 2 и n = 3 решение невозможно
        print(-1)
        return
    
    # Поле будет размером n x n, создаём его
    field = [[0] * n for _ in range(n)]
    
    # Счетчик для нумерации n-миношек
    counter = 1
    
    # Заполняем поле зигзагом
    for i in range(n):
        if i % 2 == 0:
            for j in range(n):
                field[i][j] = counter
                counter += 1
        else:
            for j in range(n - 1, -1, -1):
                field[i][j] = counter
                counter += 1
    
    # Выводим результат
    for row in field:
        print(" ".join(map(str, row)))

