def min_cuts(n, m, s):
    if s > n * m:
        return -1

    for horizontal in range(n + 1):
        for vertical in range(m + 1):
            area1 = horizontal * m
            area2 = vertical * n
            area3 = (n - horizontal) * (m - vertical)

            if area1 + area2 == s or area1 + area3 == s or area2 + area3 == s:
                return horizontal + vertical

    return -1

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
