def find_optimal_points(x1, y1, x2, y2, x3, y3):
    # Минималды қашықтықты сақтау
    min_distance = float('inf')
    optimal_points = None

    # Барлық координаталар бойынша өту
    for x in range(min(x1, x2, x3), max(x1, x2, x3) + 1):
        for y in range(min(y1, y2, y3), max(y1, y2, y3) + 1):
            # Бірінші сызықтың ұзындығы
            distance = abs(x1 - x) + abs(y1 - y)
            # Екінші сызықтың ұзындығы
            distance += abs(x2 - x) + abs(y2 - y)
            # Үшінші сызықтың ұзындығы
            distance += abs(x3 - x) + abs(y3 - y)

            # Егер ағымдағы қашықтық минималды болса, оны сақтау
            if distance < min_distance:
                min_distance = distance
                optimal_points = (x, y)

    return optimal_points
