def robot_route(n):
    route = []
    # Начальная точка маршрута
    route.append((n - 1, n - 1))  # Верхний правый угол
    
    # "Змейка" по квадрату
    for i in range(n):
        if i % 2 == 0:
            # Слева направо
            for j in range(n):
                route.append((j, i))
        else:
            # Справа налево
            for j in range(n - 1, -1, -1):
                route.append((j, i))
    
    # Сократить маршрут до ровно 2n - 1 точек
    route = route[:2 * n - 1]
    
    # Вывод результата
    for x, y in route:
        print(x, y)

# Пример вызова
n=int(input())
robot_route(n)
