﻿#include <iostream>
#include <vector>
using namespace std;


struct Point {
    double x, y;
};


void findLineEquation(const vector<Point>& points, double& m, double& b) {
    int n = points.size();
    double sum_x = 0, sum_y = 0, sum_xx = 0,sum_xy = 0;

    // Вычисляем необходимые суммы
    for (int i = 0; i < n; ++i) {
        sum_x +=points[i].x;
        sum_y += points[i].y;
        sum_xx+= points[i].x * points[i].x;
        sum_xy += points[i].x * points[i].y;
    }

   
    m = (n * sum_xy -sum_x * sum_y) / (n * sum_xx - sum_x * sum_x);
    b = (sum_y - m * sum_x) / n;
}


void findTwoPointsOnLine(double m,double b, double& x1, double& y1, double& x2, double& y2) {
    
    x1 = -10;  
    y1 = m * x1 + b;

    x2 = 10;   
    y2 = m * x2 + b;
}

int main() {
    vector<Point> points(3);

 
    for (int i = 0; i < 3; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    double m, b;
    findLineEquation(points, m, b);

   
    double x1, y1, x2, y2;
    findTwoPointsOnLine(m, b, x1, y1, x2, y2);

   
    cout << m << " " << b << " " << x1 << " " << y1 << " " << x2 << " " << y2 << endl;

    return 0;
}