﻿#include <iostream>
#include <vector>
#include <cmath>
using namespace std;


struct Point {
    double x,y;
};

void findLineThroughTwoPoints(Point p1, Point p2, double& m, double& b) {
    m = (p2.y -p1.y) / (p2.x - p1.x); 
    b = p1.y - m * p1.x; 
}


void findTwoPointsOnLine(double m, double b, double& x1, double& y1, double& x2, double& y2) {
   
    x1 = 1;
    y1 = m * x1 +b;

    x2 = 3;  
    y2 = m * x2 + b;
}

int main() {
    vector<Point> points(3);

   
    for (int i = 0; i < 3; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    double m, b;

    
    findLineThroughTwoPoints(points[0], points[1], m, b);

 
    double x1, y1, x2, y2;
    findTwoPointsOnLine(m, b, x1, y1, x2, y2);

    
    cout << int(x1) << " " << int(y1) << " " << int(x2) << " " << int(y2) << endl;

}