#include <bits/stdc++.h> 
using namespace std;

#define int long long
#define pb push_back
#define sz(s) (int)s.size()
#define pii pair<int,int>

const int inf=1e6;
const int MAX=110;

int n;
bool use[MAX][MAX];

const int dx[4]={0,1,0,-1};
const int dy[4]={1,0,-1,0};

void move(int &x,int &y,int i){
    i=(i-1)%4;
    x=x+dx[i],y=y+dy[i];
}

bool ok(int x){
    return (0<=x&&x<n);
}

void solve(){
    cin>>n;
    if(n==3){
        cout<<"2 2\n0 0\n3 0\n0 3\n0 1\n";
        return;
    }
    vector<pii> ord={{0,0}};
    for(int i=1;i<=2*n-6;i++){
        int x=ord.back().first,y=ord.back().second;
        move(x,y,i);
        ord.pb({x,y});
        move(x,y,i);
        while(ok(x)&&ok(y)&&!use[x][y]){
            use[x][y]=1;
            ord.pop_back();
            ord.pb({x,y});
            move(x,y,i);
        }
    }
    int cur=2*n-5;
    int x=ord.back().first,y=ord.back().second;
    for(int i=1;i<=4;i++)move(x,y,cur);
    ord.pb({x,y});
    for(int i=1;i<=3;i++){
        move(x,y,(cur+1));
        move(x,y,(cur+2));
    }
    ord.pb({x,y});
    for(int i=1;i<=3;i++){
        move(x,y,(cur+3));
    }
    ord.pb({x,y});
    for(int i=1;i<=3;i++){
        move(x,y,cur);
        move(x,y,(cur+1));
    }
    ord.pb({x,y});
    for(auto [x,y]:ord){
        cout<<x<<" "<<y<<"\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}