#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

void solve() {
    ld n, m, c;

    cin >> n >> m >> c;

    vector<pair<ld, ld>> a;

    a.push_back({0, 0});

    for (int i = 0; i < n; i++) {
        int x, t;

        cin >> x >> t;

        a.push_back({x, t});
    }

    a.push_back({m, 0});

    n = a.size();

    vector<ld> dp(n + 1, inf);

    dp[0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            int v = a[i - 1].first - a[j - 1].first;

            dp[i] = min(dp[i], dp[j] + v * v / c + a[i - 1].second);
        }
    }

    cout << dp[n] << "\n";
}

signed main() {
    // cout.precision(16);
    cout << fixed << setprecision(16);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}