#include <bits/stdc++.h>
using namespace std;

#define int long long
#define str string
#define endl '\n'
#define fs first
#define ss second
#define all(a) a.begin(), a.end()
#define print(a) for(auto x : a) cout << x << ' '; cout << endl;
#define printmp(a) for(auto x : a) cout << x[0] << ' ' << x[1] << endl;

const int mod = 1e9 + 7;
const int mx = 1e5 + 5;

void solve(){
    int n, q;
    cin >> n >> q;
    vector<map<int, set<int>>> graph(n + 1);
    vector<map<int, int>> color(n + 1);
    vector<int> prb(mx), beat(mx);
    int ans = 0;
    for(int i = 0; i < q; i ++){
        char c;
        int u, v, col;
        cin >> c >> u >> v >> col;
        if(c == '+'){
            if(prb[col] == 0)
                ans -= beat[col];
            if(color[u][col] == 0 and color[v][col] == 0)
                beat[col] ++;
            if(color[u][col] == 1 and color[*graph[u][col].begin()][col] == 1)
                prb[col] ++;
            if(color[v][col] == 1 and color[*graph[v][col].begin()][col] == 1)
                prb[col] ++;
            if(prb[col] == 0)
                ans += beat[col];
            color[u][col] ++;
            color[v][col] ++;
            graph[u][col].insert(v);
            graph[v][col].insert(u);
        }
        else{
            color[u][col] --;
            color[v][col] --;
            graph[u][col].erase(v);
            graph[v][col].erase(u);
            if(prb[col] == 0)
                ans -= beat[col];
            if(color[u][col] == 0 and color[v][col] == 0)
                beat[col] --;
            if(color[u][col] == 1 and color[*graph[u][col].begin()][col] == 1)
                prb[col] --;
            if(color[v][col] == 1 and color[*graph[v][col].begin()][col] == 1)
                prb[col] --;
            if(prb[col] == 0)
                ans += beat[col];
        }
        cout << ans << endl;
    }
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    #ifdef Javohir
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    // cin >> t;
    while(t --){
        solve();
        if(t > 0)
            cout << endl;
    }
}