def min_cuts(n, m, s):
    if s <= n * m:
        return 0
    
    min_cuts = float('inf')
    for x in range(1, n):
        for y in range(1, m):
            pieces = (x + 1) * (y + 1)
            area = pieces - 1
            if area >= s:
                min_cuts = min(min_cuts, x + y)
    
    return min_cuts

# Ввод данных
n, m, s = map(int, input().split())  # Ввод размеров и необходимого количества клеточек

# Определение минимального числа разрезов
result = min_cuts(n, m, s)

# Вывод результата
print(result)
