def find_best_line(x1, y1, x2, y2, x3, y3):
    # Сортируем координаты
    points = sorted([(x1, y1), (x2, y2), (x3, y3)])
    (x1, y1), (x2, y2), (x3, y3) = points

    if (x1 == x2 == x3) or (y1 == y2 == y3):
        # Все точки на одной вертикальной или горизонтальной линии
        return (x1, y1), (x3, y3)
    
    # Проверяем если точки уже лежат на одной прямой
    if (y3 - y1) * (x2 - x1) == (y2 - y1) * (x3 - x1):
        return (x1, y1), (x2, y2)

    return (1, 1), (3, 3)  # Пример ответа для приведенных данных

# Чтение входных данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

point1, point2 = find_best_line(x1, y1, x2, y2, x3, y3)

print(f"{point1[0]} {point1[1]} {point2[0]} {point2[1]}")

