#include <iostream>
using namespace std;

bool areCollinear(int x1, int y1, int x2, int y2, int x3, int y3) {
    return (x2 - x1) * (y3 - y1) == (y2 - y1) * (x3 - x1);
}

pair<int, int> fPoint(int A, int B, int C) {
    if (B != 0) return {0, -C / B};
    else return {-C / A, 0};
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    if (areCollinear(x1, y1, x2, y2, x3, y3)) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
    } else if (areCollinear(x1, y1, x3, y3, x2, y2)) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3 << endl;
    } else if (areCollinear(x2, y2, x3, y3, x1, y1)) {
        cout << x2 << " " << y2 << " " << x3 << " " << y3 << endl;
    } else {
        int A = y2 - y1;
        int B = x1 - x2;
        int C = -(A * x1 + B * y1);

        pair<int, int> p1 = fPoint(A, B, C);
        pair<int, int> p2 = {p1.first + 1, -(A * (p1.first + 1) + C) / B};

        cout << p1.first << " " << p1.second << " " << p2.first << " " << p2.second << endl;
    }
}
