def solve(n, a, b):
    cards = [(a[i], b[i]) for i in range(n)]

    cards_sorted = sorted(cards, key=lambda x: (min(x), max(x)))

    front = []
    back = []

    for card in cards_sorted:
        front.append(min(card))
        back.append(max(card))

    if sorted(front) == front and sorted(back) == back:
        print(" ".join(map(str, front)))
        print(" ".join(map(str, back)))
    else:
        print("-1")

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

solve(n, a, b)
