#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    vector<int> top, bottom; 
    int prevTop = 0, prevBottom = 0;
    for (int i = 0; i < n; ++i) {
        bool canUseA = (a[i] >= prevTop && b[i] >= prevBottom);
        bool canUseB = (b[i] >= prevTop && a[i] >= prevBottom);
        if (canUseA && (!canUseB || a[i] <= b[i])) {
            top.push_back(a[i]);
            bottom.push_back(b[i]);
            prevTop = a[i];
            prevBottom = b[i];
        } else if (canUseB) {
            top.push_back(b[i]);
            bottom.push_back(a[i]);
            prevTop = b[i];
            prevBottom = a[i];
        } else {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i : top) cout << i << " ";
    cout << endl;
    for (int i : bottom) cout << i << " ";
    cout << endl;

    return 0;
}

