def find_numbers(n, digits):
    fraction = int(digits) / (10 ** n)
    
    for b in range(1, 10**6):  
        a = int(fraction * b)  
        if 0 < a < b:  
            if abs(a / b - fraction) < 1e-10: 
                return "YES", a, b
    return "NO"

test_n = int(input(""))
test_digits = int(input(""))

result = find_numbers(test_n, test_digits)

if result == "NO":
    print(result)
else:
    print(result[0])
    print(result[1], result[2])
