def check_division(a, b, d):
    power = 10 ** len(d)
    target = int(d)
    
    if (a * power) // b != target:
        return False
    
    return (a * power) % b == 0

n = int(input())
d = input()

if d[-1] == '0':
    print("NO")
    exit()

numerator = int(d)
power = 10 ** n

for b in range(2, 1000000):
    a = (numerator * b) // power
    
    if 0 < a < b and check_division(a, b, d):
        print("YES")
        print(a, b)
        exit()

print("NO")