﻿#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

int solve(ll n, ll m, ll s) {
	if (n * m == s) return 0;
	else if (s % n == 0 || s % m == 0) {
		return 1;
	}
	else {
		for (ll i = 1; i <= n; i++) {
			if (s % i == 0 && s / i <= m) return 2;
			if (2 * i != n && (s - m * n + i * m) % (2 * i - n) == 0 && (s - m * n + i * m) % (2 * i - n) <= m) {
				return 2;
			}
		}
	}
	return 3;
}

int stress_solve(ll n, ll m, ll s) {
	if (n * m == s) return 0;
	if (s % n == 0 || s % m == 0) return 1;
	for (ll a = 1; a <= n; a++) {
		for (ll b = 1; b <= m; b++) {
			if (a * b == s || a * b + (n - a) * (m - b) == s) return 2;
		}
	}
	return 3;
}

int supersolve(ll n, ll m, ll s, int solve(ll, ll, ll)) {
	return min(min(solve(n, m, s), solve(m, n, s)), min(solve(n, m, n * m - s), solve(m, n, n * m - s)));
}

void test() {
	const int A = 7;
	while (true) {
		ll n = rand() % A + 1, m = rand() % A + 1, s = rand() % n * m + 1;
		if (supersolve(n, m, s, solve) != supersolve(n, m, s, stress_solve)) {
			cout << "ERROR";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	//test();
	ll n, m, s; cin >> n >> m >> s;
	cout << supersolve(n, m, s, solve);
	return 0;
}