﻿#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

ld dist(ll x1, ll y1, ll x2, ll y2) {
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

ld get_s(ll x1, ll y1, ll x2, ll y2) {
	return (x1 * y2 - x2 * y1) / 2.0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll x1, y1, x2, y2, x3, y3;
	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	ld s = get_s(x2 - x1, y2 - y1, x3 - x1, y3 - y1);
	ld a1 = s / dist(x1, y1, x2, y2);
	ld a2 = s / dist(x1, y1, x3, y3);
	ld a3 = s / dist(x2, y2, x3, y3);
	ld ans = min({ a1, a2, a3 });
	if (a1 == ans) {
		cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << "\n";
		return 0;
	}
	if (a2 == ans) {
		cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
		return 0;
	}
	if (a3 == ans) {
		cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3;
		return 0;
	}

}