from collections import defaultdict

def solve():
    n, q = map(int, input().split())  
    edge_count = defaultdict(int)      
    vertex_degree = defaultdict(lambda: defaultdict(int)) 
    total_beauty = 0                   
    is_superior_color = defaultdict(bool)  
    
    for _ in range(q):
        query = input().split()
        if query[0] == '+':
            v = int(query[1]) - 1
            u = int(query[2]) - 1
            c = int(query[3])
            
            
            edge_count[c] += 1
            vertex_degree[c][v] += 1
            vertex_degree[c][u] += 1
            
           
            if vertex_degree[c][v] > 1 or vertex_degree[c][u] > 1:
                is_superior_color[c] = False
            else:
                is_superior_color[c] = True
            
        elif query[0] == '-':
            v = int(query[1]) - 1
            u = int(query[2]) - 1
            c = int(query[3])
            
            
            edge_count[c] -= 1
            vertex_degree[c][v] -= 1
            vertex_degree[c][u] -= 1
            
            
            if vertex_degree[c][v] > 1 or vertex_degree[c][u] > 1:
                is_superior_color[c] = False
            else:
                is_superior_color[c] = True
            
        
        total_beauty = 0
        for color, count in edge_count.items():
            if is_superior_color[color]:
                total_beauty += count
        
        
        print(total_beauty)


solve()