#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define int long long
#define ld long double
using namespace std;
// "C:\Users\User\CLion\bin\mingw\bin\gcc.exe"
const int INF = 1e9 + 17;
const double PI = atan2(0, -1);
const double EPS = 1e-9;
const int MOD = 1e9 + 7;
vector<vector<int>> g;
vector<int> depth;
vector<int> up;
vector<bool> used;
vector<pair<int,int>> bridges;
map<pair<int,int>,int> isbridge;
vector<int> connectors;
vector<set<int>> vec;
map<pair<int,int>, int> number;
int maxcnt = 0;
bool cmp (pair <int,int> p1, pair <int,int> p2) {
    return (p1.first == p2.first && p1.second == p2.second) || (p1.first == p2.second && p1.second == p2.first);
}
void dfs(int u, int pr) {
    int counter = 0;
    depth[u] = (pr == -1 ? 0 : depth[pr] + 1);
    up[u] = depth[u];
    used[u] = true;
    for (int v : g[u]) {
        if (v == pr)continue;
        if (used[v])up[u] = min(up[u], depth[v]);
        else {
            counter++;
            dfs(v, u);
            up[u] = min(up[u],up[v]);
            if (up[v] > depth[u]) {
                isbridge[{u,v}]--;
                isbridge[{v,u}]--;
            }
            if (up[v] >= depth[u] && pr!=-1 || (pr==-1&&counter>=2)) {
                connectors.emplace_back(u);
            }
        }
    }
}
void dfs2(int u, int pr, int cnt) {
    used[u] = true;
    maxcnt = max(maxcnt, cnt);
    for (int v : g[u]) {
        if (v == pr)continue;
        if (used[v])continue;
        if (!isbridge[{u,v}]) {
            dfs2(v,u,maxcnt+1);
        }
        else {
            dfs2(v,u,cnt);
        }
    }
    vec[cnt].insert(u);
}
bool cmp2 (set <int> a, set<int> b) {
    if (a.begin()!=a.end() && b.begin()!=b.end()) {return *a.begin() < *b.begin();}
    if (a.begin()==a.end()) {return false;}
    return true;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, s;
    cin >> n >> m >> s;
    if(s == n * m)
        cout << 0;
    else if(s % n == 0 || s % m == 0)
        cout << 1;
    else {
        bool c = false;
        for(int i = 1;i <= n - 1;i++) {
            if(s >= m * i && (s - m * i) % (n - i) == 0 )
                c = true;
        }
        for(int i = 1;i <= m - 1;i++) {
            if(s >= n * i && (s - n * i) % (m - i) == 0) {
                c = true;
            }
        }
        if(!c) {
            cout << 3;
        }
        else {
            cout << 2;
        }
    }

}

/*
 *tg a = h/j;
 *a = atan2(a,b);
 *pi  = atan2 (0,-1);0 1
 *
 * atan2(a, b);
 * x == y -> |x-y|<EPS;
 * x < y -> x<y-EPS
 * x > y -> x>y+EPS
 * x <= y -> x<y+EPS
 * x >= y -> x>y-EPS
 * 1. выберем самую левую нижнюю точку
 * 2. {ai -= A};
 * sort(a);
 * h <- a[0], a[1];
 * for (int i = 2; i<n ;i++){
 *     while (h.size()>1 && point(h[h.size()-2],h[h.size()-1])*a[i]<=0){
 *         h.pop_back();
 *     }
 *     h.push_back(a[i])
 * }
 * dp[i][i+1] = 0
 * dp[L][R] = min по всем k (dp[l][k]+dp[k][r] +x[r]-x[l]) бревно
 * min(min(dp[L][K]+dp[K][R]), isequal(s[L],s[R-1])?dp[l+1][R-1]:(dp[l+1][r-1]+2))
 * depth[v] - глубина v
 * up[v] min depth у вершины в которую иожно попасть перейдя по обр ребру из поддерева v
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 */
