def galactic_timeline(n, a, b):
    cards = sorted((min(a[i], b[i]), max(a[i], b[i]), i) for i in range(n))
    result_a = []
    result_b = []
    
    max_a = max_b = 0
    
    for min_val, max_val, idx in cards:
        if max_a <= min_val and max_b <= max_val:
            result_a.append(min_val)
            result_b.append(max_val)
            max_a, max_b = min_val, max_val
        elif max_b <= min_val and max_a <= max_val:
            result_a.append(max_val)
            result_b.append(min_val)
            max_a, max_b = max_val, min_val
        else:
            # Невозможно
            return -1
    
    return result_a, result_b

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

result = galactic_timeline(n, a, b)

if result == -1:
    print(-1)
else:
    print(' '.join(map(str, result[0])))
    print(' '.join(map(str, result[1])))