def query(x, y):
    print(f"? {x} {y}", flush=True)
    return input().strip()

def answer(position):
    print(f"! {position}", flush=True)

def solve():
    candidates = [(x, y) for x in range(1, 9) for y in range(1, 9)]
    
    for _ in range(7):
        if len(candidates) == 1:
            x, y = candidates[0]
            position = f"{chr(x + ord('a') - 1)}{y}"
            answer(position)
            return
        mid_x, mid_y = candidates[len(candidates) // 2]

        response = query(mid_x, mid_y)

        if response == '+':
            candidates = [pos for pos in candidates if abs(pos[0] - mid_x) == abs(pos[1] - mid_y)]
        else:
            candidates = [pos for pos in candidates if abs(pos[0] - mid_x) != abs(pos[1] - mid_y)]

    if len(candidates) == 1:
        x, y = candidates[0]
        position = f"{chr(x + ord('a') - 1)}{y}"
        answer(position)