#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    unordered_map<int, set<pair<int, int>>> edges_by_color;
    unordered_map<int, unordered_map<int, int>> vertex_edges_by_color;
    long long total_beauty = 0;
    unordered_map<int, int> color_beauty;
    for (int i = 0; i < q; ++i) {
        char type;
        int v, u, c;
        cin >> type >> v >> u >> c;

        if (type == '+') {
            if (v > u) swap(v, u); 

            edges_by_color[c].insert({v, u});
            vertex_edges_by_color[v][c]++;
            vertex_edges_by_color[u][c]++;
            if (vertex_edges_by_color[v][c] == 2 || vertex_edges_by_color[u][c] == 2) {
                total_beauty -= color_beauty[c];
                color_beauty[c] = 0;
            } else {
                total_beauty -= color_beauty[c];
                color_beauty[c] = edges_by_color[c].size();
                total_beauty += color_beauty[c];
            }
        } else if (type == '-') {
            if (v > u) swap(v, u); 

            edges_by_color[c].erase({v, u});
            vertex_edges_by_color[v][c]--;
            vertex_edges_by_color[u][c]--;
            if (vertex_edges_by_color[v][c] <= 1 && vertex_edges_by_color[u][c] <= 1) {
                total_beauty -= color_beauty[c];
                color_beauty[c] = edges_by_color[c].size();
                total_beauty += color_beauty[c];
            }
        }
        cout << total_beauty << endl;
    }

    return 0;
}