def solve():
    import sys
    input = sys.stdin.read
    n = int(input().strip())
    
    if n % 2 == 0:
        print(-1)
        return

    board = [[0] * n for _ in range(n)]
    num = 1

    for i in range(n):
        if i % 2 == 0:
            for j in range(n):
                board[j][i] = num
                num = (num % n) + 1
        else:
            for j in range(n - 1, -1, -1):
                board[j][i] = num
                num = (num % n) + 1

    for row in board:
        print(" ".join(map(str, row)))