#include <iostream>
#include <string>
#include <cmath>

using namespace std;

int main() {
    int n; // Количество цифр после запятой
    string digits; // Строка с n цифрами после запятой

    cin >> n;
    cin >> digits;

    // Преобразуем строку в дробное число
    long long fractionalPart = stoll(digits); // Преобразуем строку в число
    long long denominator = pow(10, n); // Знаменатель дроби 10^n

    // Упрощаем дробь
    long long gcd = __gcd(fractionalPart, denominator);
    fractionalPart /= gcd;
    denominator /= gcd;

    // Проверяем условие задачи: 0 < a < b < 10^6
    if (fractionalPart > 0 && denominator > fractionalPart && denominator < 1000000) {
        cout << "YES" << endl;
        cout << fractionalPart << " " << denominator << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
