#include <bits/stdc++.h>
using namespace std;
using ll = long long;
long double point_to_line_distance(ll x1, ll y1, ll x2, ll y2, ll x3, ll y3) {
    long double numerator = abs((y2 - y1) * x3 - (x2 - x1) * y3 + x2 * y1 - y2 * x1);
    long double denominator = sqrtl((y2 - y1) * (y2 - y1) + (x2 - x1) * (x2 - x1));
    return numerator / denominator;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    vector<pair<ll, ll>> points = { {x1, y1}, {x2, y2}, {x3, y3} };
    long double min_distance = LLONG_MAX;
    pair<ll, ll> result1, result2;
    for (int i = 0; i < 3; ++i) {
        for (int j = i + 1; j < 3; ++j) {
            ll x_start = points[i].first, y_start = points[i].second;
            ll x_end = points[j].first, y_end = points[j].second;
            int k = 3 - i - j;
            ll x_remain = points[k].first, y_remain = points[k].second;
            long double distance = point_to_line_distance(x_start, y_start, x_end, y_end, x_remain, y_remain);
            if (distance < min_distance) {
                min_distance = distance;
                result1 = { x_start, y_start };
                result2 = { x_end, y_end };
            }
        }
    }
    cout << result1.first << " " << result1.second << " ";
    cout << result2.first << " " << result2.second << endl;
    return 0;
}
