def can_be_ordered(n, front, back):
    for i in range(n):
        if front[i] > back[i]:
            front[i], back[i] = back[i], front[i]
    
    ordered = sorted(zip(front, back))
    ordered_front = [card[0] for card in ordered]
    ordered_back = [card[1] for card in ordered]
    
    if ordered_front == sorted(ordered_front) and ordered_back == sorted(ordered_back):
        return ordered_front, ordered_back
    else:
        return -1

n = int(input())
front = list(map(int, input().split()))
back = list(map(int, input().split()))

result = can_be_ordered(n, front, back)
if result == -1:
    print(result)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
