#include <iostream>
#include <cmath>

int main() {
    double Ax, Ay;
    double Bx, By;
    double Cx, Cy;

    std::cin >> Ax >> Ay;
    std::cin >> Bx >> By;
    std::cin >> Cx >> Cy;

    double minSumDistances = -1;
    double bestP1x = 0, bestP1y = 0;
    double bestP2x = 0, bestP2y = 0;

    {
        double a = By - Ay;
        double b = Ax - Bx;
        double c = Bx * Ay - Ax * By;

        double dA = std::abs(a * Ax + b * Ay + c) / std::sqrt(a * a + b * b);
        double dB = std::abs(a * Bx + b * By + c) / std::sqrt(a * a + b * b);
        double dC = std::abs(a * Cx + b * Cy + c) / std::sqrt(a * a + b * b);

        double sumDistances = dA + dB + dC;

        if (minSumDistances == -1 || sumDistances < minSumDistances) {
            minSumDistances = sumDistances;
            bestP1x = Ax;
            bestP1y = Ay;
            bestP2x = Bx;
            bestP2y = By;
        }
    }

    {
        double a = Cy - Ay;
        double b = Ax - Cx;
        double c = Cx * Ay - Ax * Cy;

        double dA = std::abs(a * Ax + b * Ay + c) / std::sqrt(a * a + b * b);
        double dB = std::abs(a * Bx + b * By + c) / std::sqrt(a * a + b * b);
        double dC = std::abs(a * Cx + b * Cy + c) / std::sqrt(a * a + b * b);

        double sumDistances = dA + dB + dC;

        if (sumDistances < minSumDistances) {
            minSumDistances = sumDistances;
            bestP1x = Ax;
            bestP1y = Ay;
            bestP2x = Cx;
            bestP2y = Cy;
        }
    }

    {
        double a = Cy - By;
        double b = Bx - Cx;
        double c = Cx * By - Bx * Cy;

        double dA = std::abs(a * Ax + b * Ay + c) / std::sqrt(a * a + b * b);
        double dB = std::abs(a * Bx + b * By + c) / std::sqrt(a * a + b * b);
        double dC = std::abs(a * Cx + b * Cy + c) / std::sqrt(a * a + b * b);

        double sumDistances = dA + dB + dC;

        if (sumDistances < minSumDistances) {
            minSumDistances = sumDistances;
            bestP1x = Bx;
            bestP1y = By;
            bestP2x = Cx;
            bestP2y = Cy;
        }
    }

    std::cout << bestP1x << " " << bestP1y << " ";
    std::cout << bestP2x << " " << bestP2y << "\n";

    return 0;
}
