from math import gcd


def find_fraction(n, s):
    # Преобразуем строку S в число
    x = int(s)  # Целое число после запятой
    denominator = 10 ** n  # Делитель с n нулями

    # Сокращаем дробь x / denominator
    g = gcd(x, denominator)
    numerator = x // g
    denominator //= g

    # Проверяем все возможные значения b
    for k in range(1, 10 ** 6 // denominator + 1):
        b = denominator * k
        a = numerator * k
        if 0 < a < b < 10 ** 6:
            return "YES", a, b

    return "NO"


# Ввод данных
n = int(input())
s = input().strip()

# Решение
result = find_fraction(n, s)
if result == "NO":
    print(result)
else:
    print(result[0])
    print(result[1], result[2])