
#include <bits/stdc++.h>
using namespace std;

int minCuts(int n, int m, int s) {
    if (s > n * m) return -1; 
    
    int minCuts = INT_MAX;

    for (int x = 0; x < m; ++x) {
        for (int y = 0; y < n; ++y) {
            vector<int> widths(x + 1), heights(y + 1);

            for (int i = 0; i <= x; ++i)
                widths[i] = m / (x + 1) + (i < m % (x + 1) ? 1 : 0);

            for (int i = 0; i <= y; ++i)
                heights[i] = n / (y + 1) + (i < n % (y + 1) ? 1 : 0);
            vector<int> areas;
            for (int w : widths) {
                for (int h : heights) {
                    areas.push_back(w * h);
                }
            }

            vector<bool> dp(s + 1, false);
            dp[0] = true;

            for (int area : areas) {
                for (int k = s; k >= area; --k) {
                    dp[k] = dp[k] || dp[k - area];
                }
            }

            if (dp[s]) {
                minCuts = min(minCuts, x + y);
            }
        }
    }

    return minCuts == INT_MAX ? -1 : minCuts;
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    int result = minCuts(n, m, s);
    if (result != -1) {
        cout << result << endl;
    } else {
        cout << 0 << endl;
    }

    return 0;
}
