#include <bits/stdc++.h>
#define int long long
#define dl long double
#define MOD 998244353
#define forn(i, n) for(int i = 0; i < n; i++)
using namespace std;
const int maxn = (2e5 + 13);

void solve() {
    int n, m, s;
    cin >> n >> m >> s;

    vector<int> divs;
    for(int i = 1; i * i <= s; i++) {
        if (s % i == 0) divs.push_back(i);
    }

    if (s == n * m) {
        cout << 0 << "\n";
        return;
    }

    if (s % m == 0 || s % n == 0) {
        cout << 1 << "\n";
        return;
    }

    int x = -1, y = -1;
    for(auto div : divs) {
        if (div <= min(n, m) && s / div <= max(n, m)) {
            x = div;
            y = s / div;
        }
    }

    if (x == -1) {
        if (s / max(n , m) == min(n, m) - 1) {
            cout << 2 << "\n";
            return;
        }
        if ((s % max(n, m)) % (min(n, m) - s / max(n, m)) == 0) {
            cout << 2 << "\n";
            return;
        }

        int a = s / max(n, m);
        for (int i = 1; i <= max(n, m); i++) {
            int h1 = a * i;
            int h2 = (max(n, m) - i) * (min(n, m) - a);

            if (h1 + h2 == s) {
                cout << 2 << "\n";
                return;
            }
        }

        a = s / min(n, m);
        for (int i = 1; i <= min(n, m); i++) {
            int h1 = a * i;
            int h2 = (min(n, m) - i) * (max(n, m) - a);

            if (h1 + h2 == s) {
                cout << 2 << "\n";
                return;
            }
        }

        cout << 3 << "\n";
        return;
    }

    cout << 2 << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}