﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b) % MOD;
    }
    else
    {
        return (binpow(n, p - 1) * n) % MOD;
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    string s;
    cin >> s;

    if (n > 6) cout << "NO\n";
    else {
        int a = stoi(s), b = binpow(10, n);
        int d = gcd(a, b);
        a /= d;
        b /= d;
        if (b > 1e6) {
            cout << "NO\n";

        }
        else {
            cout << "YES\n" << a << ' ' << b << "\n";
        }
    }
}