﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b);
    }
    else
    {
        return (binpow(n, p - 1) * n);
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    ll n, m, s;
    cin >> n >> m >> s;
    if (n * m == s)
    {
        cout << 0;
    }
    else if (s % n == 0 || s % m == 0)
    {
        cout << 1;
    }
    else
    {
        for (ll x = 1; x < m; x++)
        {
            ll sum = n * x;
            ll d = -x;
            ll y = s - sum;
            if (y * d > 0)
            {
                if (abs(y) % abs(d) == 0 && y / d <= n)
                {
                    cout << 2;
                    return 0;
                }
            }
        }
        for (ll x = 1; x < m; x++)
        {
            ll sum = n * x;
            ll d = m - 2*x;
            ll y = s - sum;
            if (y * d > 0)
            {
                if (abs(y) % abs(d) == 0 && y / d <= n)
                {
                    cout << 2;
                    return 0;
                }
            }
        }
        s = n * m - s;
        for (ll x = 1; x < m; x++)
        {
            ll sum = n * x;
            ll d = -x;
            ll y = s - sum;
            if (y * d > 0)
            {
                if (abs(y) % abs(d) == 0 && y / d <= n)
                {
                    cout << 2;
                    return 0;
                }
            }
        }
        for (ll x = 0; x < m; x++)
        {
            ll sum = n * x;
            ll d = m - 2 * x;
            ll y = s - sum;
            if (y * d > 0)
            {
                if (abs(y) % abs(d) == 0 && y / d <= n)
                {
                    cout << 2;
                    return 0;
                }
            }
        }
        cout << 3;
    }
}