#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>
#define ff first
#define ss second
#define int ll
 
const int N = 2e5 + 1;
 
const ld EPS = 1e-16;
 
struct point{
    ld x, y;
};
int n;
point ans[N];

ld getlen(point a, point b){
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
 
vector<point> getinter(ld r, ld a, ld b, ld c){
    ld x0 = -a * c/(a * a + b * b), y0 = -b * c / (a * a + b * b);
    if (c*c > r*r*(a*a+b*b)+EPS)
        return {};
    else if (abs (c*c - r*r*(a*a+b*b)) < EPS) {
        return {{x0, y0}};
    }
    else {
        ld d = r*r - c*c/(a*a+b*b);
        ld mult = sqrtl (d / (a*a+b*b));
        ld ax, ay, bx, by;
        ax = x0 + b * mult;
        bx = x0 - b * mult;
        ay = y0 - a * mult;
        by = y0 + a * mult;
        return {{ax, ay}, {bx, by}};
    }
}
 
vector<point> getinter(point c2, ld r1, ld r2){
    if(abs(c2.x) < EPS && abs(c2.y) < EPS){
        if(r1 == r2)
            return {{r1, 0}};
        else    
            return {};
    }
    ld A = -2 * c2.x;
    ld B = -2 * c2.y;
    ld C = c2.x * c2.x + c2.y * c2.y + r1 * r1 - r2 * r2;
    return getinter(r1, A, B, C);
}
 
vector<point> getinter(point c1, ld r1, point c2, ld r2){
    c2.x -= c1.x;
    c2.y -= c1.y;
    vector<point> ret = getinter(c2, r1, r2);
    for(auto &e : ret)
        e.x += c1.x, e.y += c1.y;
    return ret;
}
 
void solve(){
    point A, B;
    cin >> A.x >> A.y;
    cin >> B.x >> B.y;
    cin >> n;
    ld mx = 0;
    ld sm = getlen(A, B);
    vector<pii> len;
    for(int i = 1; i <= n; i++){
        int a;
        cin >> a;
        sm += a;
        len.push_back({a, i});
        mx = max(mx, (ld)a);
    }
    if(n == 1){
        if(len[0].first != getlen(A, B)){
            cout << "Impossible\n";
            return;
        }else{
            cout << "Possible\n";
            cout << B.x << ' ' << B.y << '\n';
            return;
        }
    }
    if(2 * max(getlen(A, B), mx) > sm){
        cout << "Impossible\n";
        return;
    }
    ld d = 0;
    if(A.x == B.x && A.y == B.y){
        if(len.size() == 2){
            if(len[0].first != len[1].first){
                cout << "Impossible\n";
                return;
            }else{
                cout << "Possible\n";
                cout << A.x + len[0].first << ' ' << A.y << '\n';
                cout << A.x << ' ' << B.y << '\n';
                return;
            }
        }
        ans[1] = {(ld)len[0].first, 0};
        A.x += len[0].first;
        d = len[0].first;
        vector<pii> nlen = {};
        for(int i = 1; i < len.size(); i++)
            nlen.push_back(len[i]);
        len = nlen;
        if(len.size() == 0){
            cout << "AWDAWDAWD]\n";
            return;
        }
    }
    cout << "Possible\n";
    sort(len.begin(), len.end());
    if(getlen(A, B) > (ld)len.back().first){
        vector<pii> v1 = {}, v2 = {};
        ld ns = sm - getlen(A, B);
        ll s1 = 0, s2 = 0;
        for(int i = 0; i < len.size(); i++){
            if(s1 + len[i].first < ns / 2.0){
                s1 += len[i].first;
                v1.push_back(len[i]);
            }else{
                s2 += len[i].first;
                v2.push_back(len[i]);
            }
        }
        if(s1 == 0 || s1 == 0){
            cout << "AWDAWD\n";
            return;
        }
        vector<point> ret = getinter(A, s1, B, s2);
        point C = ret[0];
        point AC = {C.x - A.x, C.y - A.y};
        AC.x /= getlen(A, C);
        AC.y /= getlen(A, C);
        point CB = {B.x - C.x, B.y - C.y};
        CB.x /= getlen(B, C);
        CB.y /= getlen(B, C);
        for(auto e : v1){
            ans[e.second] = {AC.x * e.first, AC.y * e.first};
        }
        for(auto e : v2){
            ans[e.second] = {CB.x * e.first, CB.y * e.first};
        }
    }else{
        swap(A, B);
        point AB = {B.x - A.x, B.y - A.y};
        AB.x /= getlen(A, B);
        AB.y /= getlen(A, B);
        ld ns = sm - len.back().first;
        ld s1 = getlen(A, B), s2 = 0;
        ld d = ns;
        vector<pii> v1 = {}, v2 = {};
        for(int i = 0; i < len.size() - 1; i++){
            if(d > len.back().first){
                d -= 2 * len[i].first;
                s1 += len[i].first;
                v1.push_back(len[i]);
            }else{
                s2 += len[i].first;
                v2.push_back(len[i]);
            }
        }
        if(s1 == 0 || s1 == 0){
            cout << "AWDAWD\n";
            return;
        }
        point C = {A.x + AB.x * s1, A.y + AB.y * s1};
        for(auto e : v1){
            ans[e.second] = {AB.x * e.first, AB.y * e.first};
        }
        vector<point> ret = getinter(A, len.back().first, C, s2);
        if(ret.size() == 0){
             cout << "AWDAWD\n";
             return;
        }
        point D = ret[0];
        point CD = {D.x - C.x, D.y - C.y};
        if(getlen(C, D) == 0){
            cout << "AWDAWD\n";
            return;
        }
        CD.x /= getlen(C, D);
        CD.y /= getlen(C, D);
        for(auto e : v2){
            ans[e.second] = {CD.x * e.first, CD.y * e.first};
        }
        ans[len.back().second] = {A.x - D.x, A.y - D.y};
        swap(A, B);
    }
    point cur = A;
    cur.x -= d;
    for(int i = 1; i <= n; i++){
        point pr = cur;
        cur.x += ans[i].x;
        cur.y += ans[i].y;
        cout << fixed << setprecision(15) << cur.x << ' ' << cur.y << '\n';
    }
}
 
signed main(){
    int t = 1;
    //cin>>t;
    while(t--) solve();
}