#include <bits/stdc++.h>

using ll = long long;

void run() {
    ll n, m, s;
    std::cin >> n >> m >> s;
    if (n * m == s) {
        std::cout << 0;
        return;
    }
    if (s % n == 0 || s % m == 0) {
        std::cout << 1;
        return;
    }
    if (s < n || s < m) {
        std::cout << 2;
        return;
    }
    for (ll i = 1; i < n; i++) {
        // 1
        if (s % i == 0 && s / i < m) {
            std::cout << 2;
            return;
        }
        // 2
        if (s % i == 0 && m - s / i > 0 && m - s / i < m) {
            std::cout << 2;
            return;
        }
        // 3
        if (s % (n - i) == 0 && s / (n - i) < m) {
            std::cout << 2;
            return;
        }
        // 4
        if (s % (n - i) == 0 && m - s / (n - i) > 0 && m - s / (n - i) < m) {
            std::cout << 2;
            return;
        }
        // 123
        if ((m * n - s) % (n - i) == 0 && m - (m * n - s) / (n - i) > 0 && m - (m * n - s) / (n - i) < m) {
            std::cout << 2;
            return;
        }
        // 124
        if ((n * m - s) % (n - i) == 0 && (n * m - s) / (n - i) < m && (n * m - s) / (n - i) > 0) {
            std::cout << 2;
            return;
        }
        // 14
        if (n - 2 * i != 0 && (n * m - s - m * i) % (n - 2 * i) == 0 && (n * m - s - m * i) / (n - 2 * i) > 0 && (n * m - s - m * i) / (n - 2 * i) < m) {
            std::cout << 2;
            return;
        }
        // 23
        if (n - 2 * i != 0 && (s - m * i) % (n - 2 * i) == 0 && (s - m * i) / (n - 2 * i) > 0 && (s - m * i) / (n - 2 * i) < m) {
            std::cout << 2;
            return;
        }
        // 234
        if ((n * m - s) % i == 0 && (n * m - s) / i < m) {
            std::cout << 2;
            return;
        }
        // 134
        if ((n * m - s) % i == 0 && m - (n * m - s) / i > 0 && m - (n * m - s) / i < m) {
            std::cout << 2;
            return;
        }
    }
    std::cout << 3;

}

int main() {
    std::ios::sync_with_stdio(false), std::cin.tie(nullptr);
#ifdef debug
    std::freopen("input.txt", "r", stdin);
#endif
    ll TTT = 1;
    // std::cin >> TTT
    while (TTT--) {
        run();
        std::cout << '\n';
    }
}
/*
#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

class CHT {
    struct line {
        ld k, b;
        ld y(ld x) { return k * x + b; }
    };
    std::vector<std::pair<ld, line>> a;

    ld cross(line a1, line a2) {
        return (a2.b - a1.b) / (a1.k - a2.k);
    }
public:

    void add(line e) {
        while (!a.empty() && cross(a.back().second, e) < a.back().first) {
            a.pop_back();
        }
        if (a.empty()) {
            a.push_back({-1e18, e});
        } else {
            a.emplace_back(cross(a.back().second, e), e);
        }
    }

    line get(ld x) {
        ll l = 0, r = a.size();
        while (r - l > 1) {
            ll m = (l + r) / 2;
            if (a[m].first < x) l = m; else r = m;
        }
        return a[l].second;
    }
};

void run() {
    ld n, m, c;
    std::cin >> n >> m >> c;
    std::vector<ld> x(n);
    std::vector<ld> dp(n);
    CHT bb;
    bb.add({0, 0});
    for (int i = 0; i < n; ++i) {
        std::cin >> x[i];
        ll t;
        std::cin >> t;
        ld bx = bb.get(-2 * x[i]).y(-2 * x[i]);
        dp[i] = ((x[i] * x[i]) / c + bx + t);
        bb.add({ld(x[i] / c), (x[i] * x[i] / c + dp[i])});
    }
    ld ans = 1e18;
    for (int i = 0; i < n; ++i) {
        ld dst = (m - x[i]);
        ans = std::min(ans, dp[i] + dst * dst / c);
    }
    std::cout << ans;
}

std::mt19937 rng(clock());

ll correct(ll n, ll m, ll s) {
    if (n * m == s) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }
    if (s < n || s < m) {
        return 2;
    }
    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j < m; j++) {
            // 1
            if (i * j == s) return 2;
            // 2
            if (i * (m - j) == s) return 2;
            // 3
            if ((n - i) * j == s) return 2;
            // 4
            if ((n - i) * (m - j) == s) return 2;
            // 14
            if (i * j + (n - i) * (m - j) == s) return 2;
            // 23
            if (i * j + (n - i) * (m - j) == n * m - s) return 2;
            // 123
            if ((n - i) * (m - j) == n * m - s) return 2;
            // 124
            if ((n - i) * j == n * m - s) return 2;
            // 134
            if (i * (m - j) == n * m - s) return 2;
            // 234
            if (i * j == n * m - s) return 2;
        }
    }
    return 3;
}

ll wrong(ll n, ll m, ll s) {
    if (n * m == s) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }
    if (s < n || s < m) {
        return 2;
    }
    for (ll i = 1; i < n; i++) {
        // 1
        if (s % i == 0 && s / i < m) {
            return 2;
        }
        // 2
        if (s % i == 0 && m - s / i > 0 && m - s / i < m) {
            return 2;
        }
        // 3
        if (s % (n - i) == 0 && s / (n - i) < m) {
            return 2;
        }
        // 4
        if (s % (n - i) == 0 && m - s / (n - i) > 0 && m - s / (n - i) < m) {
            return 2;
        }
        // 123
        if ((m * n - s) % (n - i) == 0 && m - (m * n - s) / (n - i) > 0 && m - (m * n - s) / (n - i) < m) {
            return 2;
        }
        // 124
        if ((n * m - s) % (n - i) == 0 && (n * m - s) / (n - i) < m && (n * m - s) / (n - i) > 0) {
            return 2;
        }
        // 14
        if (n - 2 * i != 0 && (n * m - s - m * i) % (n - 2 * i) == 0 && (n * m - s - m * i) / (n - 2 * i) > 0 && (n * m - s - m * i) % (n - 2 * i) < m) {
            return 2;
        }
        // 23
        if (n - 2 * i != 0 && (s - m * i) % (n - 2 * i) == 0 && (s - m * i) / (n - 2 * i) > 0 && (s - m * i) % (n - 2 * i) < m) {
            return 2;
        }
        // 234
        if ((n * m - s) % i == 0 && (n * m - s) / i < m) {
            return 2;
        }
        // 134
        if ((n * m - s) % i == 0 && m - (n * m - s) / i > 0 && m - (n * m - s) / i < m) {
            return 2;
        }
    }
    return 3;
}



int main() {
//    while (true) {
//        ll n = rng() % 4 + 1;
//        ll m = rng() % 4 + 1;
//        ll s = rng() % (n * m) + 1;
//        ll cor = correct(n, m, s), wro = wrong(n, m, s);
//        if (cor != wro) {
//            std::cout << n << ' ' << m << ' ' << s << '\n';
//            std::cout << cor << '\n' << wro;
//            return 0;
//        }
//    }
    ll n, m, s;
    std::cin >> n >> m >> s;
    wrong(n, m, s);
}

//int main() {
//    std::ios::sync_with_stdio(false), std::cin.tie(nullptr);
//#ifdef debug
//    std::freopen("input.txt", "r", stdin);
//#endif
//    ll TTT = 1;
//    // std::cin >> TTT
//    while (TTT--) {
//        run();
//        std::cout << '\n';
//    }
//}*/
