import heapq
def solve():
    n, m, c = map(int, input().split())
    stations = []
    for _ in range(n):
        x, t = map(int, input().split())
        stations.append((x, t))
    stations.append((m, 0))
    pq = [(0, 0)] 
    dp = [float('inf')] * (n + 1)
    dp[0] = 0  
    for i in range(n + 1):
        x_i, t_i = stations[i]
        while pq and pq[0][0] <= dp[i]:
            prev_time, j = heapq.heappop(pq)
            if prev_time + t_i < dp[i]:
                dp[i] = prev_time + t_i
            heapq.heappusq(pq,dp[i,n])time
