#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;

int main() {
    int n, m, c;
    cin >> n >> m >> c;
    
    vector<int> x(n + 2);
    vector<int> t(n + 2);
    x[0] = 0;
    t[0] = 0;

    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> t[i];
    }
    x[n + 1] = m;
    t[n + 1] = 0;

    vector<double> dp(n + 2, numeric_limits<double>::infinity());
    dp[0] = 0;
    dp[1] = static_cast<double>(x[1] * x[1]) / c;

    for (int i = 2; i <= n + 1; ++i) {
        for (int j = 0; j < i; ++j) {
            dp[i] = min(dp[i], dp[j] + t[j] + static_cast<double>((x[i] - x[j]) * (x[i] - x[j])) / c);
        }
    }

    cout << dp[n + 1] << endl;

    return 0;
}