/**
 *    data : 09.07.2024  
 *     
**/
#define ORD_SET
#include <bits/stdc++.h>
// #include "algo/turnikmen.h"

using namespace std;
using hash_t = uint64_t;

#ifdef ORD_SET
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#ifdef ROPE
#include <ext/rope>
using namespace __gnu_cxx;
#endif

#define int long long
#define ld long double
#define bitt __builtin_popcountll
#define bitzero __builtin_clz
#define TASK_NAME "log"

void fReopen () {

    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif

    // freopen(TASK_NAME ".in", "r", stdin);
    // freopen(TASK_NAME ".out", "w", stdout);
}

const int N = 1e6;
const int MOD = 1e9 + 7;

ld get_dist(int a, int b, int c, int x, int y) {
    return abs(a * x + b * y + c) / sqrt(a * a + b * b);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1; 
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    ld mn = 1e18;
    int px1 = 0, py1 = 0, px2 = 0, py2 = 0;
    if (x1 != x2 || y1 != y2) {
        int a = y1 - y2;
        int b = x2 - x1;
        int c = x1 * y2 - x2 * y1;

        ld d = get_dist(a, b, c, x3, y3);
        if (d < mn) {
            mn = d;
            px1 = x1, py1 = y1;
            px2 = x2, py2 = y2;
        }
    }
    if (x1 != x3 || y1 != y3) {
        int a = y1 - y3;
        int b = x3 - x1;
        int c = x1 * y3 - x3 * y1;

        ld d = get_dist(a, b, c, x2, y2);
        if (d < mn) {
            mn = d;
            px1 = x1, py1 = y1;
            px2 = x3, py2 = y3;
        }
    }
    if (x2 != x3 || y2 != y3) {
        int a = y2 - y3;
        int b = x3 - x2;
        int c = x2 * y3 - x3 * y2;

        ld d = get_dist(a, b, c, x1, y1);
        if (d < mn) {
            mn = d;
            px1 = x2, py1 = y2;
            px2 = x3, py2 = y3;
        }
    }

    cout << px1 << " " << py1 << " " << px2 << " " << py2 << "\n";
}
