def cheburashka_number(k):
    # Initialize the first Чебурашка number and the step increment
    current_number = 2  # The first Чебурашка number
    increment = 3       # Difference between consecutive numbers
    
    # Loop to find the k-th Чебурашка number
    for _ in range(1, k):
        current_number += increment
        increment += 1  # Increment grows by 1 each step
    
    return current_number

# Input
k = int(input("Введите номер искомого числа Чебурашки (1 <= k <= 10^9): "))

# Output the result
print(cheburashka_number(k))
