def min_cuts(n, m, s):
    # Если s равно всей площади, резать не нужно
    if s == n * m:
        return 0

    min_cuts = float('inf')  # Инициализируем минимальное количество разрезов

    # Перебираем количество вертикальных разрезов
    for x in range(n):
        # Размер каждого вертикального сегмента
        segment_width = m // (x + 1)
        if m % (x + 1) != 0:
            segment_width += 1

        # Проверяем минимальное количество горизонтальных разрезов
        if s % segment_width == 0:
            y = s // segment_width - 1
            if y < n:
                min_cuts = min(min_cuts, x + y)

    return min_cuts if min_cuts != float('inf') else -1


# Ввод данных
n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
