def min_cuts(n, m, s):
    # Если s равно общей площади листа, разрезы не нужны
    if s == n * m:
        return 0

    # Проверка на 1 разрез по вертикали или горизонтали
    for i in range(1, n):
        if i * m == s or (n - i) * m == s:
            return 1
    for j in range(1, m):
        if j * n == s or (m - j) * n == s:
            return 1

    # Проверка на 2 разреза
    for i in range(1, n):
        for j in range(1, m):
            if (i * m + (n - i) * j == s) or (j * n + (m - j) * i == s):
                return 2

    # Проверка на 3 разреза
    for i1 in range(1, n):
        for i2 in range(i1 + 1, n):
            if ((i1 * m) + ((i2 - i1) * m) + ((n - i2) * m) == s):
                return 3
        for j1 in range(1, m):
            if ((i1 * m) + ((n - i1) * j1) + (j1 * n) == s):
                return 3

    for j1 in range(1, m):
        for j2 in range(j1 + 1, m):
            if ((j1 * n) + ((j2 - j1) * n) + ((m - j2) * n) == s):
                return 3

    # Проверка на 4 разреза
    for i1 in range(1, n):
        for i2 in range(i1 + 1, n):
            for j1 in range(1, m):
                if ((i1 * m) + ((i2 - i1) * m) + ((n - i2) * j1) + ((m - j1) * n) == s):
                    return 4

    # Проверка на 5 разрезов
    for i1 in range(1, n):
        for i2 in range(i1 + 1, n):
            for j1 in range(1, m):
                for j2 in range(j1 + 1, m):
                    if ((i1 * m) + ((i2 - i1) * m) + ((n - i2) * j1) + ((m - j1) * j2) + ((m - j2) * n) == s):
                        return 5

    # Если решение не найдено за 5 разрезов
    return -1

# Чтение входных данных
n, m, s = map(int, input().split())

# Получение результата
result = min_cuts(n, m, s)

# Вывод результата
print(result)