#include <iostream>
#include <cmath>
#include <string>
using namespace std;

bool is_finite(long long b) {
    while (b % 2 == 0) b /= 2;
    while (b % 5 == 0) b /= 5;
    return b == 1;
}

int main() {
    int p;
    string digits;
    cin >> p >> digits;

    long long n = stoll(digits);
    long long denominator = pow(10, p);

    for (long long b = 1; b < 1000000000; b++) {
        if ((b * n) % denominator == 0) {
            long long a = (b * n) / denominator;
            if (a < b && is_finite(b)) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }
    cout << "NO" << endl;
    return 0;
}