#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <cmath>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

void solve() {
    ll c, h;
    cin >> c >> h;
    double d = c * c - 4 * h * h;
    if (d < 0) {
        cout << -1;
        return;
    }
    d = sqrt(d);
    double x = (c - d) / 2, y = (c + d) / 2;
    double a = sqrt(h * h + x * x), b = sqrt(h * h + y * y);
    if (a + b > c) {
        cout << (double)c * h / 2.0;
    }
    else {
        cout << -1;
    }
}

int main() {
    //cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
