#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <cmath>
#include <unordered_map>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

bool okay(ll n, ll m, ll s) {
    return (s % n == 0 || s % m == 0);
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    s = max(s, n * m - s);
    if (n * m == s) {
        cout << 0;
        return;
    }
    else if (okay(n, m, s)) {
        cout << 1;
        return;
    }
    else {
        for (ll x = 1; x < n; x++) {
            if (s - x * m < 0ll) {
                continue;
            }
            if (okay(n - x, m, s - x * n)) {
                cout << 2;
                return;
            }
            if (x < n / 2ll && (s - x * m) % (n - 2ll * x) == 0ll) {
                cout << 2;
                return;
            }
        }
        for (ll x = 1; x < m; x++) {
            if (s - x * n < 0ll) {
                continue;
            }
            if (okay(m - x, n, s - x * m)) {
                cout << 2;
                return;
            }
            if (x < m / 2ll && (s - x * n) % (m - 2ll * x) == 0ll) {
                cout << 2;
                return;
            }
        }
    }
    cout << 3;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
