#include <iostream>
#include <cmath>
using namespace std;
double call(int c, int h) {
    if (c <= 0 || h <= 0) {
        return -1;
    }
    double d = c * c - 4.0 * h * h;
    if (d < 0) {
        return -1;
    }
    double p = (c + sqrt(d)) / 2.0;
    double q = (c - sqrt(d)) / 2.0;
    if (p <= 0 || q <= 0) {
        return -1;
    }
    return 0.5 * c * h;
}
int main() {
    int c, h;
    cin >> c >> h;
    double res = call(c, h);
    if (res == -1) {
        cout << -1 << endl;
    } else {
        cout << res << endl;
    }

    return 0;
}
