#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    vector<int> front(n), back(n);
    int lastFront = 0, lastBack = 0;

    for (int i = 0; i < n; ++i) {
        if (a[i] >= lastFront && b[i] >= lastBack) {
            front[i] = a[i];
            back[i] = b[i];
            lastFront = a[i];
            lastBack = b[i];
        } else if (b[i] >= lastFront && a[i] >= lastBack) {
            front[i] = b[i];
            back[i] = a[i];
            lastFront = b[i];
            lastBack = a[i];
        } else {
            cout << -1 << endl;
            return 0;
        }
    }

    for (int x : front) cout << x << " ";
    cout << endl;
    for (int x : back) cout << x << " ";
    cout << endl;

    return 0;
}