#include <bits/stdc++.h>

using namespace std;

string query(int x, int y) {
    cout << "? " << x << " " << y << endl;
    string response;
    cin >> response;
    return response;
}

int main() {
    pair<int, int> corners[] = {{1, 1}, {1, 8}, {8, 1}, {8, 8}};
    int x = -1, y = -1;

    for (auto [cx, cy] : corners) {
        if (query(cx, cy) == "+") {
            x = cx;
            y = cy;
            break;
        }
    }

    int low = 1, high = 8;
    while (low <= high) {
        int mid = (low + high) / 2;
        if (query(mid, mid) == "+") {
            x = mid;
            y = mid;
            low = mid + 1;
        } else {
            high = mid - 1;
        }
    }

    cout << "! " << x << " " << y << endl;
    return 0;
}

