
#include <iostream>
#include <cmath>
#include <string>
using namespace std;

int main()
{
    int c, h;
    cin >> c >> h;
    //Находим d
    int disc = c * c - (4 * h * h); //дискриминант уравнения d2-dc+h2=0
    if (disc < 0) {
        cout << -1;
        return 0;
    }
    double d1, d2; //ответы на уравнение
    d1 = (c + sqrt(disc))/2;
    d2 = (c - sqrt(disc))/2;
    //вот и ответы на d;
    if (d1 < 0 && d2 < 0) { //нету ответов больше 0
        cout << -1;
        return 0;
    }

    //находим катеты
    if (d1 > 0) {
        double e1 = c - d1;
        double a1 = sqrt(d1 * d1 + (h * h));
        double b1 = sqrt(e1 * e1 + (h * h));
        if (int(a1* a1 + b1 * b1) == int(c * c)) {///надо округлить
            cout << int((a1 * b1) / 2); //выводим площадь
            return 0;
        }
    }
    else if (d2 > 0) {
        double e2 = c - d2;
        double a2 = sqrt(d2 * d2 + (h * h));
        double b2 = sqrt(e2 * e2 + (h * h));
        if (int(a2* a2 + b2 * b2) == int(c * c)) {///надо округлить
            cout << int((a2 * b2) / 2); //выводим площадь
            return 0;
        }
    }
    cout << -1;
    return 0;
}