#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, s;
    cin >> n >> m >> s;

    if (s == n * m) {
        cout << 0 << '\n';
        return 0;
    }

    int r = INT_MAX;

    for (int x = 0; x <= 100; ++x) {
        int w = m / (x + 1);
        int rw = m % (x + 1);
        if (w == 0) break;
        for (int y = 0; y <= 100; ++y) {
            int h = n / (y + 1);
            int rh = n % (y + 1);
            if (h == 0) break;
            vector<int> pieces;
            for (int i = 0; i < (x + 1) * (y + 1); ++i) {
                pieces.push_back(h * w);
            }
            for (int i = 0; i < x + 1; ++i) {
                if (rh > 0) pieces.push_back(rh * w);
            }
            for (int i = 0; i < y + 1; ++i) {
                if (rw > 0) pieces.push_back(h * rw);
            }
            if (rh > 0 && rw > 0) {
                pieces.push_back(rh * rw);
            }
            vector<bool> dp(s + 1, false);
            dp[0] = true;

            for (int piece : pieces) {
                for (int k = s; k >= piece; --k) {
                    dp[k] = dp[k] || dp[k - piece];
                }
            }

            if (dp[s]) {
                r = min(r, x + y);
            }
        }
    }

    cout << r << '\n';
    return 0;
}
