#include <bits/stdc++.h>
using namespace std;

#define MAX_COLOR 100000

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    unordered_map<int, unordered_map<int, int>> ce;
    unordered_map<int, int> cb;
    unordered_map<int, unordered_set<int>> cg;
    unordered_map<int, int> bad_nodes;
    vector<int> results;
    
    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;

        int edge = min(v, u) * MAX_COLOR + max(v, u);

        if (t == '+') {
            cg[c].insert(edge);
            ce[c][v]++;
            ce[c][u]++;
            cb[c]++;

            if (ce[c][v] > 1) bad_nodes[c] = 1;
            if (ce[c][u] > 1) bad_nodes[c] = 1;
        } 
        else {
            cg[c].erase(edge);
            ce[c][v]--;
            ce[c][u]--;
            cb[c]--;

            if (ce[c][v] == 1 && bad_nodes[c]) bad_nodes[c] = 0;
            if (ce[c][u] == 1 && bad_nodes[c]) bad_nodes[c] = 0;
        }

        int tb = 0;
        for (auto& [color, count] : cb) {
            if (!bad_nodes[color]) {
                tb += count;
            }
        }

        results.push_back(tb);
    }

    for (int result : results) {
        cout << result << '\n';
    }

    return 0;
}
