#include <bits/stdc++.h>
using namespace std;

#define MAX_COLOR 100000

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    unordered_map<int, unordered_map<int, int>> ce;
    unordered_map<int, int> cb;
    unordered_map<int, unordered_set<int>> cg;
    unordered_map<int, int> bad_nodes;
    int tb = 0;

    auto update_tb = [&]() {
        tb = 0;
        for (auto& [color, count] : cb) {
            if (bad_nodes[color] == 0) {
                tb += count;
            }
        }
    };

    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;

        int edge = min(v, u) * MAX_COLOR + max(v, u);

        if (t == '+') {
            cg[c].insert(edge);
            ce[c][v]++;
            ce[c][u]++;
            cb[c]++;

            if (ce[c][v] == 2) bad_nodes[c]++;
            if (ce[c][u] == 2) bad_nodes[c]++;
        } 
        else {
            cg[c].erase(edge);
            ce[c][v]--;
            ce[c][u]--;
            cb[c]--;

            if (ce[c][v] == 1) bad_nodes[c]--;
            if (ce[c][u] == 1) bad_nodes[c]--;
        }

        update_tb();
        cout << tb << '\n';
    }

    return 0;
}
