from collections import defaultdict

MAX_COLOR = 100000

def main():
    n, q = map(int, input().split())
    
    ce = defaultdict(lambda: defaultdict(int))
    cb = defaultdict(int)
    cg = defaultdict(set)
    
    tb = 0
    
    for _ in range(q):
        t, v, u, c = input().split()
        v, u, c = int(v), int(u), int(c)
        
        if t == '+':
            cg[c].add(min(v, u) * MAX_COLOR + max(v, u))
            ce[c][v] += 1
            ce[c][u] += 1
            cb[c] += 1
        else:
            cg[c].remove(min(v, u) * MAX_COLOR + max(v, u))
            ce[c][v] -= 1
            ce[c][u] -= 1
            cb[c] -= 1
        
        tb = 0
        for color in cg:
            is_excellent = True
            for vtx in ce[color]:
                if ce[color][vtx] > 1:
                    is_excellent = False
                    break
            if is_excellent:
                tb += cb[color]
        
        print(tb)

if __name__ == "__main__":
    main()
