#include <bits/stdc++.h>
using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    vector<pair<int, int>> cards(n);

    for (int i = 0; i < n; ++i) {
        cards[i] = {a[i], b[i]};
    }

    sort(cards.begin(), cards.end(), [](const pair<int, int>& p1, const pair<int, int>& p2) {
        return (p1.first + p1.second) < (p2.first + p2.second);
    });

    for (int i = 0; i < n; ++i) {
        if (cards[i].first > cards[i].second) {
            swap(cards[i].first, cards[i].second);
        }
    }

    for (int i = 1; i < n; ++i) {
        if (cards[i].first < cards[i - 1].first || cards[i].second < cards[i - 1].second) {
            cout << -1 << endl;
            return 0;
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << cards[i].first << " ";
    }
    cout << endl;

    for (int i = 0; i < n; ++i) {
        cout << cards[i].second << " ";
    }
    cout << endl;

    return 0;
}
