def min_cuts(n, m, s):
    if s == n * m:
        return 0
    min_cuts_needed = float('inf')
    for height in range(1, n + 1):
        for width in range(1, m + 1):
            area = height * width
            if area < s:
                continue
            full_sheets = (n // height) * (m // width)
            if full_sheets > 0:
                cuts = (height - 1) + (width - 1)
                min_cuts_needed = min(min_cuts_needed, cuts)
    return min_cuts_needed
n, m, s = map(int, input().split())
print(min_cuts(n, m, s))