def solve():
    n = int(input())
    a = list(map(int, input().split()))
    b = list(map(int, input().split()))


    cards = []
    for i in range(n):
        cards.append((min(a[i], b[i]), max(a[i], b[i]), a[i], b[i]))


    cards.sort()


    face_sorted = []
    reverse_sorted = []
    last_face = -1
    last_reverse = -1

    for card in cards:
        min_val, max_val, face, reverse = card
        if min_val > last_face and reverse > last_reverse:
            face_sorted.append(face)
            reverse_sorted.append(reverse)
            last_face = face
            last_reverse = reverse
        elif max_val > last_face and min_val > last_reverse:
            face_sorted.append(reverse)
            reverse_sorted.append(face)
            last_face = reverse
            last_reverse = face
        else:
            print(-1)
            return

    print(' '.join(map(str, face_sorted)))
    print(' '.join(map(str, reverse_sorted)))
solve()
