#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ff first
#define ss second
#define tobit(n) bitset<128>(n)
#define all(v) (v).begin(), (v).end() 
#define rtt(v) rotate(vec.begin(), vec.begin() + k, vec.end()); //move k elements back
int dx[] = {1,0,-1,0,1,1,-1,-1}; int dy[] = {0,1,0,-1,1,-1,1,-1};
const int MOD = 1e9 + 7;
int binpownm(int n, int m){
    if(m <= 1) return n;
    if(m % 2 == 0){
        int t = binpownm(n, m / 2); return t * t;
    } else return binpownm(n, m - 1) * n;
}
string tobin(int n){
    if(n == numeric_limits<int>::min()) return "-1" + string(numeric_limits<int>::digits, '0');
    string res;
    res.reserve(numeric_limits<int>::digits + 1);
    bool cur = (n < 0);
    if(cur) n = -n;
    do { res += char('0' + n % 2); n = n / 2; } while (n > 0);
    if(cur) res += '-';
    return string(res.crbegin(), res.crend());
}
void merge(vector<int>& v, int l, int m, int r){
    vector<int> result; 
    int i = l, j = m + 1;
    while(i <= m && j <= r){
        if(v[i] <= v[j]) result.emplace_back(v[i]), i++;
        else result.emplace_back(v[j]), j++;
    } while(i <= m){
        result.emplace_back(v[i]); i++;
    } while(j <= r){
        result.emplace_back(v[j]); j++; 
    } for(int i = l; i <= r; i++) v[i] = result[i - l];
}
void mergeSORT(vector<int>& v, int l, int r){
    if(l < r){
        int m = (l + r) / 2;
        mergeSORT(v, l, m);
        mergeSORT(v, m + 1, r);
        merge(v, l, m, r);
    }
}
// Алгоритм Манакера || "Короче строка s и мы хотим найти в ней все подпалиндромы" //
vector<int> manacher_odd(string s){ //для нечетных размеров палиндромов
    vector<int> v(s.size(), 1);
    int l = 0, r = 0;
    for(int i = 1; i < s.size(); i++){
        if(i < r) v[i] = min(r - i + 1, v[l + r - i]);
        while(i - v[i] >= 0 && i + v[i] < s.size() && s[i - v[i]] == s[i + v[i]]) v[i]++;
        if(i + v[i] - 1 > r) l = i - v[i] + 1, r = i + v[i] - 1;
    } return v;
}
// Алгоритм Манакера || "Короче строка s и мы хотим найти в ней все подпалиндромы" //
vector<int> manacher_even(string s){ //для четного размеров палиндромов
    vector<int> v(s.size(), 0);
    int l = -1, r = -1;
    for(int i = 0; i < s.size() - 1; i++){
        if(i < r) v[i] = min(r - i, v[l + r - i - 1]);
        while (i - v[i] >= 0 && i + v[i] + 1 < s.size() && s[i - v[i]] == s[i + v[i] + 1]) v[i]++;
        if(i + v[i] > r) l = i - v[i] + 1, r = i + v[i];
    } return v;
}
// PRIMERNO kak pref function no on ishet maksimalnye stroki //
vector<int> z_func(string s){
    vector<int> z(s.size());
    z[0] = 0;
    int l = 0, r = 0;
    for(int i = 1; i < s.size(); i++){
        if(i <= r){
            z[i] = min(z[i - l], r - i + 1);
        }
        while(i + z[i] < s.size() && s[z[i]] == s[i + z[i]]){
            z[i] += 1;
        }
        if(i + z[i] - 1 > r){
            l = i;
            r = i + z[i] - 1;
        }
    } return z;
}
int BIN(vector<int> v, int l, int r, int x){
    if(r >= l){
        int m = l + (r - l) / 2;
        if(v[m] == x) return m;
        if(v[m] > x) return BIN(v, l, m - 1, x);
        return BIN(v, m + 1, r, x);
    } return -1;
}
// PREFIX FUNC p[i] = kolichestvo kakoihto sufix p[i] ravnyy prefu // 
vector<int> p_func(string s){
    vector<int> p(s.size(), 0);
    for(int i = 1; i < s.size(); i++){
        int cur = p[i - 1];
        while(s[i] != s[cur] && cur > 0) cur = p[cur - 1];
        if(s[i] == s[cur]) p[i] = cur + 1;
    } return p;
}
// check to find element in 2D array //
vector<int> FIND2D(vector<vector<int>>& v, int k){
    for(int i = 0; i < v.size(); i++){
        vector<int> cur;
        for(int j = 0; j < v[i].size(); j++){
            cur.emplace_back(v[i][j]);
        }
        int res = BIN(cur, 0, cur.size() - 1, k);
        vector<int> qwe;
        qwe.emplace_back(i);
        qwe.emplace_back(res);
        if(res != -1) return qwe;
    }
    vector<int> qwe = {-1};
    return qwe;
}
// increasing subsequence in arr of size n
int lis(vector<int>& arr) {
    int n = arr.size();
    vector<int> lis(n, 1);

    // Compute optimized LIS values in
    // bottom-up manner
    for (int i = 1; i < n; i++) {
        for (int prev = 0; prev < i; prev++) {
            if (arr[i] > arr[prev] && lis[i] < lis[prev] + 1) {
                lis[i] = lis[prev] + 1;
            }
        }
    }

    // Return maximum value in lis
    return *max_element(lis.begin(), lis.end());
}
vector<vector<int>> build_prefix_sums_2d(const vector<vector<int>>& a){
    int n = a.size();
    int m = a[0].size();
    vector<vector<int>> prefix_sum(n + 1 , vector<int>(m + 1, 0));
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            prefix_sum [i + 1][ j + 1] = prefix_sum[i][j + 1] + prefix_sum[i + 1][j] - prefix_sum[i][j] + a[i][j];
        }
    } return prefix_sum;
}
int findGCD(vector<int> arr, int n){
    int result = arr[0];
    for(int i = 1; i < n; i++) result = __gcd(arr[i], result);
    return result;
}
signed main(){
    int n, a, b; cin >> n;
    string str; cin >> str;
    a = stoll(str), b = 1;
    if(n == 1 && str == "2"){
        cout << "YES\n" << 1 << " " << 5; return 0;
    }
    for(int i = 0; i < n; i++) b *= 10;
    a /= __gcd(a, b); b /= __gcd(a, b);
    // cout << (double)2 / (double)3;
    if(a < b && b <= 1000000){
        cout << "YES\n" << a << " " << b;
    } else cout << "NO";
}
const int fastIO = [](){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    return 0;   
}();
