#include <iostream>
#include <string>
#include <cmath>

using namespace std;

int gcd(int x, int y) {
    while (y != 0) {
        int temp = x % y;
        x = y;
        y = temp;
    }
    return x;
}

int main() {
    int n;
    string s;
    cin >> n >> s;

    while (s.size() > 1 && s[0] == '0') {
        s = s.substr(1);
    }

    int a = stoi(s);
    int b = pow(10, n);

    int divisor = gcd(a, b);
    a /= divisor;
    b /= divisor;

    if (a < b) {
        cout << "YES\n" << a << " " << b;
    } else {
        cout << "NO";
    }

    return 0;
}

