#include <iostream>
#include <cmath>

using namespace std;

int main() {
    double h, c;
    cin >> c >> h;

    if (c <= 0 || h <= 0 || h >= c) {
        cout << -1;
        return 0;
    }
    double radius = c / 2.0;
    if(h > radius){
        cout << -1;
        return 0;
    }
    double D = c * c - 4 * h * h;

    if (D < 0) {
        cout << -1;
    } else {
        double a = (c + sqrt(D)) / 2;
        double b = (c - sqrt(D)) / 2;

        if (a > 0 && b > 0) {
            double area = 0.5 * c * h;
            cout << area;
        } else {
            cout << -1;
        }
    }

    return 0;
}

