#include <iostream>
#include <unordered_map>
#include <unordered_set>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    unordered_map<int, int> ec;
    unordered_map<int, unordered_set<int>> ex;

    long long bty = 0;

    for (int i = 0; i < q; ++i) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            ec[c]++;
            ex[c].insert(v);
            ex[c].insert(u);
        } else if (op == '-') {
            ec[c]--;
            ex[c].erase(v);
            ex[c].erase(u);
        }

        bty = 0;

        for (auto& e : ec) {
            int col = e.first;
            int cnt = e.second;
            if (ex[col].empty()) {
                bty += cnt;
            }
        }

        cout << bty << endl;
    }

    return 0;
}

