#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("O3")
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    const int MAX_C = 100005;
    vector<vector<int>> vertices(MAX_C);
    vector<vector<int>> degrees(MAX_C);
    vector<int> bad_c(MAX_C, 0);
    vector<int> m_c(MAX_C, 0);

    long long sum_beauty = 0;

    auto update_degree = [&](int vertex, int c, bool add) -> void {

        auto it = lower_bound(vertices[c].begin(), vertices[c].end(), vertex);
        int idx = it - vertices[c].begin();

        if (it != vertices[c].end() && *it == vertex) {

            if (add) {
                degrees[c][idx]++;
                if (degrees[c][idx] == 2) {
                    bad_c[c]++;
                }
            } else {
                if (degrees[c][idx] == 2) {
                    bad_c[c]--;
                }
                degrees[c][idx]--;
                if (degrees[c][idx] == 0) {
                    vertices[c].erase(vertices[c].begin() + idx);
                    degrees[c].erase(degrees[c].begin() + idx);
                }
            }
        } else if (add) {

            vertices[c].insert(vertices[c].begin() + idx, vertex);
            degrees[c].insert(degrees[c].begin() + idx, 1);
        }
    };

    while (q--) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        bool was_superior = (bad_c[c] == 0);
        int prior_m_c = m_c[c];

        if (op == '+') {
            update_degree(v, c, true);
            update_degree(u, c, true);
            m_c[c]++;
        } else {
            update_degree(v, c, false);
            update_degree(u, c, false);
            m_c[c]--;
        }

        bool is_superior_now = (bad_c[c] == 0);

        if (was_superior) {
            if (is_superior_now) {
                sum_beauty += (op == '+') ? 1 : -1;
            } else {
                sum_beauty -= prior_m_c;
            }
        } else if (is_superior_now) {
            sum_beauty += m_c[c];
        }

        cout << sum_beauty << '\n';
    }

    return 0;
}