#include <cmath>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

#define ll long long
#define vi vector<int>
#define vll vector<long long>
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, n) for (int i = n - 1; i >= 0; --i)
#define fastio ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#include <iostream>
#include <cmath>

using namespace std;

int current_x = 0, current_y = 0;
char make_move(int x, int y) {

    cout <<'?'<<" "<<x << " " << y << endl;
    char result;
    cin >> result;
    return result;
}

int find_max_move() {
    int low = 0, high = 8;
    
    int cur_pos =0;
    while (low <= high ) {
        int mid = ((low + high) / 2);
        
        if(mid==0){
            break;
        }
        if (make_move( mid, mid) == '+') {
            cur_pos += mid;
            high -= mid;
            low = 0;
        } else {
            high = mid;
        }
    }
    
    return cur_pos;
}


int find_max_move1() {
    int low = 0, high = -8;
    
    int cur_pos =0;
    while (low >= high ) {
        int mid = ((low + high) / 2);
        
        if(mid==0){
            break;
        }
        if (make_move( mid, mid) == '+') {
            cur_pos += mid;
            high -= mid;
            low = 0;
        } else {
            high = mid;
        }
    }
    
    return cur_pos*-1;
}


int main() {
    char arr[8] = {'a','b','c','d','e','f','g','h'};
    int main_diag=find_max_move();
    int sec_diag=find_max_move1();
    cout<<'!'<<" "<<arr[sec_diag]<<8-main_diag<<endl;

    
    return 0;
}
