#include <cmath>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

#define ll long long
#define vi vector<int>
#define vll vector<long long>
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, n) for (int i = n - 1; i >= 0; --i)
#define fastio ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#include <iostream>
#include <cmath>

using namespace std;


double dist(ll x1, ll y1, ll x2, ll y2, ll x0, ll y0) {
    long double m = (y2 - y1) / (x2 - x1);
    long double b = y1 - m * x1;

    long double A = m;
    long double B = -1;
    long double C = b;

    return abs(A * x0 + B * y0 + C) / sqrt(A * A + B * B);
}


int main() {
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1>>x2>>y2>>x3>>y3;

    
    long double q1=dist(x1,y1,x2,y2,x3,y3);
    long double q2=dist(x1,y1,x3,y3,x2,y2);
    long double q3=dist(x3,y3,x2,y2,x1,y1);

    
    
    long double minans = min(min(q1,q2),q3);

    if(minans==q1){
        cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2;
        return 0;
    }else if(minans==q2){
        cout<<x1<<" "<<y1<<" "<<x3<<" "<<y3;
        return 0;
    }else if(minans==q3){
        cout<<x2<<" "<<y2<<" "<<x3<<" "<<y3;
        return 0;
    }

    return 0;
}
