#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &	u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

	int n, q; cin >> n >> q;
	
	vector <map<int,int>> mp(n);
	map <int,int> st, bad;
	
	auto upd = [&](int x, int c, int v){
		if ( mp[x][c] > 1 ) bad[c] -= 1;
		
		mp[x][c] += v;
		
		if ( mp[x][c] > 1 ) bad[c] += 1;
		
		st[c] += v;
		
		if ( st[c] == 0 ) st.erase(c);
		if ( bad[c] == 0 ) bad.erase(c);
	};
	
	while ( q-- ){
		char x; cin >> x;
		
		int u, v, c; cin >> u >> v >> c;
		
		--u, --v;
		
		upd(u, c, (x == '-') ? -1 : 1);
		upd(v, c, (x == '-') ? -1 : 1);
		
		cout << (int)st.size() - (int)bad.size() << ln;
	}

    cout << '\n';
}
