#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    // Выводим маршрут робота
    vector<pair<int, int>> path;
    
    // Начинаем с точки (0, 0)
    path.push_back({0, 0});
    
    // Проходим по строкам зигзагообразно
    for (int i = 0; i < n; ++i) {
        if (i % 2 == 0) {
            // Четные строки: идем вправо
            path.push_back({i, n-1});
        } else {
            // Нечетные строки: идем влево
            path.push_back({i, 0});
        }
    }

    // Завершаем маршрут в точке (n-1, n-1)
    path.push_back({n-1, n-1});
    
    // Выводим маршрут
    for (const auto& p : path) {
        cout << p.first << " " << p.second << endl;
    }

    return 0;
}
