#include <bits/stdc++.h>
using namespace std;
#define ff first
#define ss second

const int N = 1e5;

#define int long long

typedef long long ll; 
int close(int s, int n){
    return s - (s % n);
} 
  
bool can_form_s_with_cuts(int n, int m, int s, int x_cuts, int y_cuts) {  
    vector<int> widths, heights;  

    if(x_cuts == 0) {  
        widths.push_back(n);  
    }else if (x_cuts == 1) {  
        for (int w1 = 1; w1 <= n-1; w1++) {  
            int w2 = n - w1;  
            widths = {w1, w2};  
            if (y_cuts == 0) {  
                heights.push_back(m);  
            } else if (y_cuts == 1) {  
                for (int h1 = 1; h1 <= m -1; h1++) {  
                    int h2 = m - h1;  
                    heights = {h1, h2};  
  
                    vector<int> areas;  
                    for (int wi : widths) {  
                        for (int hj : heights) {  
                            areas.push_back(wi * hj);  
                        }  
                    }  
                    int sz = areas.size();  
                    for (int mask = 1; mask < (1<<sz); ++mask) {  
                        int sum =0;  
                        for (int i=0;i<sz;++i) {  
                            if (mask & (1<<i)) {  
                                sum += areas[i];  
                            }  
                        }  
                        if (sum == s) {  
                            return true;  
                        }  
                    }  
                }  
            } else if (y_cuts == 0) {  
                heights = {m};  
                vector<int> areas;  
                for (int wi : widths) {  
                    for (int hj : heights) {  
                        areas.push_back(wi * hj);  
                    }  
                }  
  
                int sz = areas.size();  
                for (int mask = 1; mask < (1<<sz); ++mask) {  
                    int sum =0;  
                    for (int i=0;i<sz;++i) {  
                        if (mask & (1<<i)) {  
                            sum += areas[i];  
                        }  
                    }  
                    if (sum == s) {  
                        return true;  
                    }  
                }  
            }  
        }  
    } else if (x_cuts == 2) {  
        return false;  
    }  
    return false;  
}  
  
main() {  
    int n, m, s;  cin >> n >> m >> s;  
    if(s == n * m) {  
        cout << 0 << endl;  
        return 0;  
    }  
  
    bool possible = false;  
    if (s % m == 0) {  
        int w1 = s / m;  
        if (1 <= w1 && w1 <= n -1)  
            possible = true;  
    }  
    if (s % n == 0) {  
        int h1 = s / n;  
        if (1 <= h1 && h1 <= m -1)  
            possible = true;  
    }  
    if (possible) {  
        cout << 1 << endl;  
        return 0;  
    }  
    int max_cuts = 4;  
    bool found = false;  
    for (int total_cuts = 2; total_cuts <= max_cuts; ++total_cuts) {
        for (int x_cuts = 0; x_cuts <= total_cuts; ++x_cuts) {  
            int y_cuts = total_cuts - x_cuts;  
            if (x_cuts > n -1 || y_cuts > m -1) continue;  
            if (can_form_s_with_cuts(n, m, s, x_cuts, y_cuts)) {  
                cout << total_cuts << endl;  
                found = true;  
                return 0;  
            }  
        }  
    }  
    cout << 3 << endl;  
    return 0;  
}
