#include <bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
  
const int N = 1e5;
  
#define int long long
  
int close(int s, int n){
    return s - (s % n);
}
  
  
int can_cut(int n, int m, int s, int i, int j){
    vector<int> v;
    if(n >= i && m >= j){
        v.push_back(i * j);
        v.push_back(j * (n-i));
        v.push_back(i * (m-j));
        v.push_back((m-j) * (n-i));
        int sz = v.size();
        for(int mask = 0; mask < (1<<sz); mask++){
            int sum = 0;
            for(int i = 0;i < sz; i++){
                if(mask & (1<<i)){
                    sum+= v[i];
                }
            }
            if(sum == s) return 1;
        }
    }
    v.clear();
    if(n >= j && m >= i){
        v.push_back(i * j);
        v.push_back(j * (m-i));
        v.push_back(i * (n-j));
        v.push_back((n-j) * (m-i));
        int sz = v.size();
        for(int mask = 0; mask < (1<<sz); mask++){
            int sum = 0;
            for(int i = 0;i < sz; i++){
                if(mask & (1<<i)){
                    sum+= v[i];
                }
            }
            if(sum == s) return 1;
        }
    }
    return 0;
}
  
  
int solve(int n, int m, int s){
     if(n * m == s){
       return 0;
    }
    if(s % n == 0){
        if(s/n <= m) return 1;
    }
    if(s%m == 0){
        if(s/m <= n) return 1;
    }
    
    if(s < n or s < m){
        return 2;
    }
    for(int i = 1;i * i <= s; i++){
        if(s % i == 0){
            int j = s / i;
            if(i <= n && j <= m){
                return 2;
            }
            if(i <= m && j <= n){
                return 2;
            }
        }
    }
    for(int total = 1; total <= 1500; total++){
        for(int x_cut = 0; x_cut <= total; x_cut++){
            int y_cut = total-x_cut;
            if(x_cut > n-1 or y_cut > m-1) continue;
            if(can_cut(n, m, s, x_cut, y_cut)){
                return 2;
            }
        }
    }
    return 3;
} 
 
int is_prime(int n){
    for(int i = 2; i * i <= n; i++){
        if(n % i == 0) return 0;
    }
    return 1;
}
 
  
main(){
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
     
    int n, m, s; cin >> n >> m >> s;
    int answer = solve(n, m, s);
    if(answer < 3){
        cout << answer;
        return 0;
    }
    for(int x_cut = 1; x_cut <= n; x_cut++){
        for(int y_cut = max(0LL,s / m-100); y_cut <= s /m+100 && y_cut <= m; y_cut++){
            if(x_cut > n-1 or y_cut > m-1) continue;
            if(x_cut < 0 or y_cut < 0) continue;
            if(can_cut(n, m, s, x_cut, y_cut)){
                cout << 2;
                return 0;
            }
        }
    }
    cout << 3;
    return 0;
}
