#include <bits/stdc++.h>

using namespace std;

struct point {
    long long x, y;
};

point operator-(point a, point b) {
    return (point){a.x - b.x, a.y - b.y};
}

long long operator^(point a, point b) {
    return a.x * b.y - b.x * a.y;
}

long double len(point a) {
    return sqrt((a.x * a.x) + (a.y * a.y));
}

long double dist(point a, point b, point c) {
    return ((b - a) ^ (c - a)) / len(b - a);
}

int main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    point a, b, c;

    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;

    vector<pair<long double, int>> ans;

    vector<pair<point, point>> st;

    st.push_back({a, b});
    st.push_back({a, c});
    st.push_back({b, c});

    ans.push_back({dist(a, b, c), 0});
    ans.push_back({dist(a, c, b), 1});
    ans.push_back({dist(b, c, a), 2});

    sort(ans.begin(), ans.end());

    a = st[ans[0].second].first;
    b = st[ans[0].second].second;
    cout << a.x << " " << a.y << " " << b.x << " " << b.y << "\n";

    return 0;
}
