def galactic_timeline(n, a, b):
    # Создаем два списка для хранения возможных последовательностей
    face_up_order = []
    face_down_order = []

    # Используем две переменные для отслеживания текущих годов на лицевой и обратной стороне
    current_face = -1
    current_back = -1

    # Флаг, чтобы определить, возможно ли построить последовательность
    possible = True

    for i in range(n):
        if a[i] > current_face:
            face_up_order.append(a[i])
            current_face = a[i]
        else:
            possible = False
            break

    if not possible:
        current_face = -1
        possible = True
        face_up_order.clear()
        for i in range(n):
            if b[i] > current_back:
                face_down_order.append(b[i])
                current_back = b[i]
            else:
                possible = False
                break

    if possible:
        return list(range(1, n + 1)), list(range(n + 1, 2 * n + 1))
    else:
        return -1

# Чтение входных данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Получаем результат и выводим
result = galactic_timeline(n, a, b)
if result == -1:
    print(-1)
else:
    face_up, face_down = result
    print(*face_up)
    print(*face_down)
