#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}


void solve() {
    ll n;
    cin >> n;
    if (n < 5) {
        if (n == 1) {
            cout << 1;
            return;
        }
        cout << -1;
        return;
    }
    vector<vector<ll>> matr(n, vector<ll>(n, 0));
    for (ll i = 0; i < n; i++) {
        matr[0][i] = 1;
    }
    ll x = 2;
    for (ll j = 0; j < n / 2; j++) {
        for (ll i = j + 1; i < n; i++) {
            matr[i][j] = x;
        }
        for (ll i = 1; i <= j + 1; i++) {
            matr[i][j + 1] = x;
        }
        x++;
    }
    ll p = 1;
    for (ll j = n / 2 + 1; j < n; j++) {
        for (ll k = j; k < n; k++) {
            matr[p][k] = x;
        }
        for (ll i = p; i < p + n / 2; i++) {
            matr[i][j] = x;
        }
        for (ll k = n / 2; k <= j; k++) {
            matr[p + n / 2][k] = x;
        }
        p++;
        x++;
    }

    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            cout << matr[i][j] << " ";
        }
        cout << '\n';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}