
#include <iostream>
using namespace std;
long long findCheburashkaNumber(long long k) {
    long long count = 0; // Счетчик чисел Чебурашки
    long long m = 0;     // Номер шага
    while (count < k) {
        m++;
        long long S_m = m * (m + 1) / 2; // Сумма первых m чисел
        if (S_m % 2 == 0) {             // Проверяем, делится ли на 2
            count++;
        }
    }
    return m * (m + 1) / 2; // Возвращаем k-е число Чебурашки
}

int main() {
    long long k;
    cin >> k; // Ввод k
    cout << findCheburashkaNumber(k) << endl; // Вывод результата
    return 0;
}