#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,avx2")
#pragma GCC optimize("unroll-loops")
using namespace std;
bool Q = 0;
struct Line {
    mutable long long k, m, p;
    bool operator<(const Line& o) const {
        return Q ? p < o.p : k < o.k;
    }
};
struct LineContainer : multiset<Line> {
    const long long inf = LLONG_MAX;
    long long div(long long a, long long b) {
        return a / b - ((a ^ b) < 0 && a % b);
    }
    bool isect(iterator x, iterator y) {
        if (y == end()) {
            x->p = inf;
            return false;
        }
        if (x->k == y->k) {
            x->p = x->m > y->m ? inf : -inf;
        } else {
            x->p = div(y->m - x->m, x->k - y->k);
        }
        return x->p >= y->p;
    }
    void add(long long k, long long m) {
        auto z = insert({k, m, 0}), y = z++, x = y;
        while (isect(y, z)) z = erase(z);
        if (x != begin() && isect(--x, y)) isect(x, y = erase(y));
        while ((y = x) != begin() && (--x)->p >= y->p)
            isect(x, erase(y));
    }
    long long query(long long x) {
        Q = 1;
        auto l = *lower_bound({0, 0, x}); Q = 0;
        return l.k * x + l.m;
    }
    
};
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, c;
    cin >> n >> m >> c;
    long long x[n + 2], t[n + 2];
    long long dp[n + 2];
    x[0] = 0;
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> t[i];
    }
    dp[0] = 0;
    x[n + 1] = m;
    t[n + 1] = 0;
    LineContainer o;
    for (int i = 1; i <= n + 1; i++) {
        // dp[i] = LLONG_MAX;
        // for (int j = 0; j < i; j++) {
        //     dp[i] = min(dp[i], dp[j] + (x[i] - x[j]) * (x[i] - x[j]) + t[i] * c);
        // }
        o.add(2 * x[i - 1], -(x[i - 1] * x[i - 1] + dp[i - 1]));
        dp[i] = -o.query(x[i]) + x[i] * x[i] + t[i] * c;
        // cout << dp[i] << ' ';
    }
    // cout << endl;
    cout << fixed << setprecision(10) << dp[n + 1] / c << endl;
}