def solve(n, a, b):
    p = []
    for i in range(n):
        p.append([a[i], b[i]])

    for flip in range(1 << n):
        q = []
        for i in range(n):
            if flip & (1 << i):
                q.append([b[i], a[i]])
            else:
                q.append([a[i], b[i]])

        q.sort()
        ok = True
        prev = -1
        for x in q:
            if x[0] <= prev:
                ok = False
            prev = x[0]

        prev = -1
        for x in q:
            if x[1] <= prev:
                ok = False
            prev = x[1]

        if ok:
            up = []
            down = []
            for x in q:
                up.append(x[0])
                down.append(x[1])
            return up, down

    return [-1]

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
ans = solve(n, a, b)
if ans == [-1]:
    print(-1)
else:
    print(*ans[0])
    print(*ans[1])