def dist(x, y, x1, y1, x2, y2):
    if x1 == x2:
        return abs(x - x1)
    k = (y2 - y1) / (x2 - x1)
    b = y1 - k * x1
    return abs(k * x - y + b) / (k * k + 1) ** 0.5

def solve(x1, y1, x2, y2, x3, y3):
    pts = [(x1, y1), (x2, y2), (x3, y3)]
    mn = float('inf')
    res = None

    for i in range(3):
        for j in range(i + 1, 3):
            ax, ay = pts[i]
            bx, by = pts[j]
            s = 0
            for x, y in pts:
                s += dist(x, y, ax, ay, bx, by)
            if s < mn:
                mn = s
                res = (ax, ay, bx, by)

    return res

x1, y1, x2, y2, x3, y3 = map(int, input().split())
ax, ay, bx, by = solve(x1, y1, x2, y2, x3, y3)
print(ax, ay, bx, by)