def min_cuts(n, m, s):
    # Егер s бүкіл парақтың ауданына тең болса, кесу қажет емес
    if s == n * m:
        return 0
    # Егер s n немесе m арқылы толық бөлінсе, 1 кесу жеткілікті
    if s % n == 0 and s // n <= m:
        return 1
    if s % m == 0 and s // m <= n:
        return 1
    # Егер s екі бөлікке бөлу арқылы құрылса, 2 кесу қажет
    for x in range(1, n):
        if x * m >= s and (s - x * m) % n == 0:
            return 2
    for y in range(1, m):
        if y * n >= s and (s - y * n) % m == 0:
            return 2
    # Егер s мүмкін болмаса
    return -1

while True:
    try:
        # Енгізу
        user_input = input().strip()
        if not user_input:  # Егер бос енгізу болса, циклды аяқтаймыз
            break
        n, m, s = map(int, user_input.split())

        # Нәтижені есептеу
        result = min_cuts(n, m, s)

        # Нәтижені шығару
        if result == -1:
            print("2")
        else:
            print(result)
    except ValueError:
        print("Дұрыс форматта енгізіңіз: n m s")
