def autonomous_robot_route(n):
    route = []
    for i in range(n):
        # Move horizontally across the row
        if i % 2 == 0:
            # Left to right for even rows
            route.extend([(x, i) for x in range(n)])
        else:
            # Right to left for odd rows
            route.extend([(x, i) for x in range(n - 1, -1, -1)])
    
    # Print the route
    for point in route:
        print(point[0], point[1])

# Input
n = int(input())
autonomous_robot_route(n)
