import math

def solve():
    # Чтение входных данных
    x0, y0 = map(int, input().split())
    x1, y1 = map(int, input().split())
    n = int(input())
    a = list(map(int, input().split()))
    
    # Расчет расстояния между точками
    distance = math.sqrt((x1 - x0) ** 2 + (y1 - y0) ** 2)
    if distance > sum(a):
        print("Impossible")
        return
    
    # Построение траектории
    print("Possible")
    current_x, current_y = x0, y0
    remaining_distance = distance
    for i in range(n):
        # Оставшееся расстояние до конечной точки
        remaining_distance = math.sqrt((x1 - current_x) ** 2 + (y1 - current_y) ** 2)
        
        # Направление прыжка
        if remaining_distance == 0:
            dx, dy = 0, 0
        else:
            dx = (x1 - current_x) / remaining_distance
            dy = (y1 - current_y) / remaining_distance
        
        # Координаты следующей точки
        next_x = current_x + a[i] * dx
        next_y = current_y + a[i] * dy
        print(f"{next_x:.8f} {next_y:.8f}")
        current_x, current_y = next_x, next_y
