def find_line(x1, y1, x2, y2, x3, y3):
    # Находим центроид треугольника
    cx = (x1 + x2 + x3) // 3
    cy = (y1 + y2 + y3) // 3

    # Для поиска второй точки прямой, которая минимизирует расстояние
    # Используем одну из точек, например (x1, y1)
    dx = x1 - cx
    dy = y1 - cy

    # Получаем два направления, изначально направим от cx, cy к одной из точек
    x2 = cx + dy
    y2 = cy - dx

    return cx, cy, x2, y2

# Чтение входных данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Нахождение координат прямой
x1_new, y1_new, x2_new, y2_new = find_line(x1, y1, x2, y2, x3, y3)

# Вывод результата
print(x1_new, y1_new, x2_new, y2_new)


