n = int(input())
ai = list(map(int, input().split()))
bi = list(map(int, input().split()))
cards = []
for idx in range(n):
    a = ai[idx]
    b = bi[idx]
    if a > b:
        a, b = b, a
    cards.append((b, a, idx))

cards.sort()

top_sequence = [card[1] for card in cards]
bottom_sequence = [card[0] for card in cards]

possible = all(top_sequence[i] <= top_sequence[i + 1] for i in range(n - 1))

if possible:
    print(' '.join(map(str, top_sequence)))
    print(' '.join(map(str, bottom_sequence)))
else:
    print(-1)