def minimal_cuts(m, n):
    """
    Вычисляет минимальное количество разрезов для разделения листа размером m x n на клетки.
    :param m: количество строк (высота листа)
    :param n: количество столбцов (ширина листа)
    :return: минимальное количество разрезов
    """
    if m <= 0 or n <= 0:
        return 0  # Невалидный размер
    return (m - 1) + (n - 1)

# Пример использования
m = 3  # высота листа
n = 6  # ширина листа
print(f"Минимальное количество разрезов для {m} x {n}: {minimal_cuts(m, n)}")
