def calculate_minimum_time(n, m, c, stations):
    stations.append((m, 0))  
    stations.sort()  

    current_fuel = c
    current_position = 0
    total_time = 0

    for i in range(n + 1):
        distance_to_next_station = stations[i][0] - current_position

        if distance_to_next_station > current_fuel:
            return -1  

        current_fuel -= distance_to_next_station
        total_time += distance_to_next_station  

        if i < n:
            current_fuel = c  
            total_time += stations[i][1]  
        
        current_position = stations[i][0]

    return total_time


n = 3
m = 10
c = 5
stations = [(2, 3), (5, 1), (9, 2)]

print(calculate_minimum_time(n, m, c, stations))
