
def solve(n):
    if n % 2 == 0:
        return -1
    
    result = [[0] * n for _ in range(n)]
    current_mino = 1

    for i in range(0, n, 2):
        for j in range(0, n, 2):
            result[i][j] = current_mino
            result[i+1][j] = current_mino
            result[i][j+1] = current_mino
            result[i+1][j+1] = current_mino
            current_mino += 1
    
    return result

def print_result(result):
    if result == -1:
        print(result)
    else:
        for row in result:
            print(" ".join(map(str, row)))

# Пример использования:
n = int(input("Введите размер n: "))
result = solve(n)
print_result(result)
