#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    map<int, set<pair<int, int>>> dct;

    for (int i = 0; i < q; i++) {
        string s;
        int v, u, c;
        cin >> s >> v >> u >> c;

        if (v < u) {
            swap(u, v);
        }

        if (s == "+") {
            dct[c].insert({u, v});
        } else {
            dct[c].erase({u, v});
        }

        int ans = 0;
        for (const auto& kv : dct) {
            const auto& v_set = kv.second;
            set<int> s;

            for (const auto& edges : v_set) {
                if (s.find(edges.first) == s.end()) {
                    s.insert(edges.first);
                } else {
                    break;
                }
                if (s.find(edges.second) == s.end()) {
                    s.insert(edges.second);
                } else {
                    break;
                }
            }
            if (s.size() == v_set.size() * 2) {
                ans += v_set.size();
            }
        }
        cout << ans << endl;
    }

    return 0;
}

