#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    map<int, set<pair<int, int>>> dct;
    vector<int> ls(n + 1, 0);
    map<int, set<int>> dct_s;
    for (int i = 0; i < q; ++i) {
        char s;
        int v, u, c;
        cin >> s >> v >> u >> c;

        if (v > u) {
            swap(v, u);
        }

        if (s == '+') {
            dct[c].insert({v, u});
        } else {
            dct[c].erase({v, u});
        }

        bool valid = true;
        dct_s[c].clear();

        for (const auto& edge : dct[c]) {
            if (dct_s[c].count(edge.first) || dct_s[c].count(edge.second)) {
                valid = false;
                break;
            }
            dct_s[c].insert(edge.first);
            dct_s[c].insert(edge.second);
        }

        ls[c] = valid ? 1 : 0;

        int result = 0;
        for (int i = 1; i <= n + 1; ++i) {
            if (ls[i] == 1) {
                result += dct[i].size();
            }
        }

        cout << result << endl;
    }

    return 0;
}
