n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]
import heapq
def minimum_time(n, m, c, stations):
     stations = [(0, 0)] + stations + [(m, 0)]
     dp = [float('inf')] * (n + 2)
    dp[0] = 0  # Время на старте (в Санкт-Петербурге)
     pq = [(0, 0)]  # (время, индекс точки)
      while pq:
        current_time, i = heapq.heappop(pq)
        
        if current_time > dp[i]:
            continue
        
        x_i, t_i = stations[i]
for j in range(i + 1, n + 2):
    x_j, t_j = stations[j]
    # Расстояние между точками
    distance = x_j - x_i
         if distance <= c:
                # Время движения до следующей точки
                speed = distance  # Это же будет расход топлива на 1 единицу расстояния
                travel_time = distance / speed
                
                new_time = current_time + travel_time + t_i
                if new_time < dp[j]:
                    dp[j] = new_time
                    heapq.heappush(pq, (new_time, j))
    
    return dp[n + 1]
result = minimum_time(n, m, c, stations)
print(f"{result:.10f}")
