#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <cassert>
#include <unordered_set>
#include <set>
using namespace std;

#define int long long
#define fast ios_base::sync_with_stdio(false); cin.tie(NULL);
const int maxn = 2e5 + 5;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), all_elements;
    map<int, int> frequency;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        frequency[a[i]]++;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        frequency[b[i]]++;
    }

    for (auto &x : frequency) {
        all_elements.push_back(x.first);
    }
    sort(all_elements.begin(), all_elements.end());

    for (int i = 0; i < n; i++) {
        a[i] = lower_bound(all_elements.begin(), all_elements.end(), a[i]) - all_elements.begin() + 1;
        b[i] = lower_bound(all_elements.begin(), all_elements.end(), b[i]) - all_elements.begin() + 1;
    }

    vector<pair<int, int> > pairs;
    for (int i = 0; i < n; i++) {
        pairs.emplace_back(min(a[i], b[i]), max(a[i], b[i]));
    }

    sort(pairs.begin(), pairs.end());

    bool valid = true;
    for (int i = 0; i < n; i++) {
        if (pairs[i].first != i + 1) {
            valid = false;
            break;
        }
    }

    if (valid) {
        for (int i = 0; i < n; i++) {
            cout << pairs[i].first << " ";
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            cout << pairs[i].second << " ";
        }
        cout << endl;
    } else {
        cout << -1 << endl;
    }
}

signed main() {
    fast
    int t = 1;
    while (t--) {
        solve();
    }
}