#include <iostream>
#include <vector>
using namespace std;

// Функция для проверки числа на соответствие правилам
bool isCheburashka(int n) {
    int sum = 0;
    for (int k = 1; sum < n; ++k) {
        sum += k;
        if (sum == n && n % k == 1) {
            return true;
        }
    }
    return false;
}

int main() {
    int k;
    cin >> k;

    // Вектор для хранения чисел Чебурашки
    vector<int> cheburashki;

    // Перебор всех чисел, пока не найдём k чисел Чебурашки
    int n = 1;
    while (cheburashki.size() < k) {
        if (isCheburashka(n)) {
            cheburashki.push_back(n);
        }
        ++n;
    }

    // Вывод k-го числа Чебурашки
    cout << cheburashki[k - 1] << endl;

    return 0;
}
