#include <iostream>
#include <algorithm>
using namespace std;

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    int minCuts = INT_MAX;

    // Перебираем все возможные размеры прямоугольников, которые могут иметь площадь s
    for (int height = 1; height <= n; ++height) {
        if (s % height == 0) {
            int width = s / height;
            if (width <= m) {
                // Разрезы для данного размера прямоугольника
                int verticalCuts = n - height;
                int horizontalCuts = m - width;
                minCuts = min(minCuts, verticalCuts + horizontalCuts);
            }
        }
    }

    cout << minCuts << endl;
    return 0;
}
