#include <iostream>
#include <cmath>
#include <vector>
#define int long long
using namespace std;

double pointToLineDistance(int x1, int y1, int x2, int y2, int x3, int y3) {
    double A = y2 - y1;
    double B = x1 - x2;
    double C = x2 * y1 - x1 * y2;
    return abs(A * x3 + B * y3 + C) / sqrt(A * A + B * B);
}

signed main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    double d1 = pointToLineDistance(x1, y1, x2, y2, x3, y3);
    double d2 = pointToLineDistance(x1, y1, x3, y3, x2, y2);
    double d3 = pointToLineDistance(x2, y2, x3, y3, x1, y1);

    if (d1 <= d2 && d1 <= d3) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
    } else if (d2 <= d1 && d2 <= d3) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3 << endl;
    } else {
        cout << x2 << " " << y2 << " " << x3 << " " << y3 << endl;
    }

    return 0;
}