#include <bits/stdc++.h>

#ifdef LOCAL
#include "algo/debug.h"
#else
#define print(...)
#endif

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define str string

#define all(v)  v.begin(), v.end()
#define fi      first
#define se      second
#define pb      push_back
#define ent     cout << "\n";
#define sz(v)   ll(v.size())

using namespace std;

const long long MOD = 1e9+7, inf = 1e18;

ld dist(ld x1, ld y1, ld x2, ld y2) {
    return sqrtl(ld(powl(x1 - x2, 2.0) + powl(y1 - y2, 2.0)));
}

ld f(ld x1, ld y1, ld x2, ld y2, ld x3, ld y3) {
    if (x1 == x2) {
        return dist(x3, y3, x2, y3);
    }
    else if (y1 == y2) {
        return dist(x3, y3, x3, y2);
    }

    ld k1 = ld(y1 - y2) / ld(x1 - x2);
    ld b1 = y1 - k1 * x1;
    ld k2 = (x1 - x2) / (y2 - y3);
    ld b2 = x1 - k2 * y1;

    ld x4 = k2 * y3 + b2;
    ld y4 = k1 * x3 + b1;

    // cout << x3 << ' ' << y4 << '\n';

    return min(dist(x3, y3, x4, y3), dist(x3, y3, x3, y4));
}

void solve() {
    ld x[5], y[5];

    for (ll i=1; i<=3; i++) {
        cin >> x[i] >> y[i];
    }

    ld mn1 = f(x[1], y[1], x[2], y[2], x[3], y[3]);
    ld mn2 = f(x[3], y[3], x[1], y[1], x[2], y[2]);
    ld mn3 = f(x[2], y[2], x[3], y[3], x[1], y[1]);

    ld ans = inf; ll a1 = 1e10, a2 = 1e10, a3 = 1e10, a4 = 1e10;

    ans = mn1;
    a1 = x[1];
    a2 = y[1];
    a3 = x[2];
    a4 = y[2];
    if (mn2 < ans) {
        ans = mn2;
        a1 = x[3];
        a2 = y[3];
        a3 = x[1];
        a4 = y[1];
    }
    if (mn3 < ans) {
        ans = mn3;
        a1 = x[3];
        a2 = y[3];
        a3 = x[2];
        a4 = y[2];
    }

    // print(mn1, mn2, mn3);

    cout << a1 << ' ' << a2 << ' ' << a3 << ' ' << a4 << '\n';
}

int32_t main() {
    #ifdef ONLINE_JUDGE
        // freopen("input.txt","r",stdin);
        // freopen("output.txt","w",stdout);
    #endif
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    ll ttest=1;
    // cin >> ttest;

    for (ll test_number=1; test_number<=ttest; test_number++) {
        solve();
    }

    return 0;
}