def min_cuts_f(n, m, s):
    if s == n * m:
        return 0
    min_cuts = float('inf')
    for x in range(n):
        vertical_strips = x + 1
        if s % vertical_strips == 0:
            height = s // vertical_strips
            if height <= m:
                min_cuts = min(min_cuts, x)
    for y in range(m):
        horizontal_strips = y + 1
        if s % horizontal_strips == 0:
            width = s // horizontal_strips
            if width <= n:
                min_cuts = min(min_cuts, y)
    for x in range(n):
        for y in range(m):
            vertical_pieces = x + 1
            horizontal_pieces = y + 1
            if vertical_pieces * horizontal_pieces >= s:
                min_cuts = min(min_cuts, x + y)
    return min_cuts
n, m, s = map(int, input().split())
print(min_cuts_f(n, m, s))