def solve():
    n = int(input())
    face = list(map(int, input().split()))
    reverse = list(map(int, input().split()))
    cards = [(min(face[i], reverse[i]), max(face[i], reverse[i])) for i in range(n)]
    cards.sort()
    top_side = []
    bottom_side = []
    last_face = -1
    last_reverse = -1

    for card in cards:
        if card[0] >= last_face and card[1] >= last_reverse:
            top_side.append(card[0])
            bottom_side.append(card[1])
            last_face = card[0]
            last_reverse = card[1]
        elif card[1] >= last_face and card[0] >= last_reverse:
            top_side.append(card[1])
            bottom_side.append(card[0])
            last_face = card[1]
            last_reverse = card[0]
        else:
            print(-1)
            return
    print(" ".join(map(str, top_side)))
    print(" ".join(map(str, bottom_side)))
solve()