﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
//ll gcd(ll a, ll b) {
//    if (b == 0) return a;
//    return gcd(b, a % b);
//}
ll get(ll n, ll m, ll s) {
    for (int i = 1; i <= n; i++) {
        if (i * m == s)
            return 1;
        if (i * m < s)
            continue;
        ll sum = i * m;
        while (sum > s) {
            sum -= i;
        }
        if (sum == s)
            return 2;
        else
            return 3;
    }
}

vector <vector <int>> used;
vector <int> dx = { 0, 1, 0, -1 };
vector <int> dy = { 1, 0, -1, 0 };

int x = 0, y = 0;
int n;

bool check(int xx, int yy) {
    return 0 <= xx && xx < n && 0 <= yy && yy < n;
}

vector <vector <pair <int, int>>> sh = { 
    {{-3, -3}, {-3, 0}, {0, -3}, {-2, -3}},
    {{-3 ,3}, {0, 3}, {-3, 0}, {-3, 2}},
    {{3, -3}, {3, 0}, {0, -3}, {2, -3}},
    {{3, 3}, {0, 3},{3, 0}, {3, 2}} };

void solve() {
    cin >> n;
    if (n == 3) {
        cout << "2 2\n0 0\n3 0\n0 3\n0 1";
        return;
    }
    used.resize(n, vector <int>(n));
    cout << x << " " << y << "\n";
    used[0][0] = 1;
    int cur = 0;
    for (int i = 0; i < 2 * n - 6; ++i) {
        while (check(x + dx[cur], y + dy[cur]) && !used[x + dx[cur]][y + dy[cur]]) {
            x += dx[cur];
            y += dy[cur];
            used[x][y] = 1;
        }
        if (i != 2 * n - 7) {
            cout << x << " " << y << "\n";
            cur = (cur + 1) % 4;
        }
        else {
            x += dx[cur];
            y += dy[cur];
            cout << x << " " << y << "\n";
        }
    }
    if (check(x - 1, y - 1) && !used[x - 1][y - 1]) {
        for (int i = 0; i < 4; ++i) {
            cout << sh[0][i].first + x << " " << sh[0][i].second + y << "\n";
        }
    }
    else if (check(x - 1, y + 1) && !used[x - 1][y + 1]) {
        for (int i = 0; i < 4; ++i) {
            cout << sh[1][i].first + x << " " << sh[1][i].second + y << "\n";
        }
    }
    else if (check(x + 1, y - 1) && !used[x + 1][y - 1]) {
        for (int i = 0; i < 4; ++i) {
            cout << sh[2][i].first + x << " " << sh[2][i].second + y << "\n";
        }
    }
    else {
        for (int i = 0; i < 4; ++i) {
            cout << sh[3][i].first + x << " " << sh[3][i].second + y << "\n";
        }
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}