def galactic_timeline(n, top, bottom):
    # Сортируем карточки по минимальному значению каждой из сторон
    cards = [(min(top[i], bottom[i]), max(top[i], bottom[i])) for i in range(n)]
    
    # Сортируем по первому значению (минимальному из двух сторон)
    cards.sort()

    # Проверка возможности создания возрастающих рядов
    top_sorted = [cards[i][0] for i in range(n)]
    bottom_sorted = [cards[i][1] for i in range(n)]

    # Проверяем, является ли отсортированный ряд строго возрастающим
    if all(top_sorted[i] < top_sorted[i + 1] for i in range(n - 1)) and \
       all(bottom_sorted[i] < bottom_sorted[i + 1] for i in range(n - 1)):
        # Если оба ряда возрастают, выводим результат
        print(*top_sorted)
        print(*bottom_sorted)
    else:
        print(-1)

# Пример использования
n = int(input())
top = list(map(int, input().split()))
bottom = list(map(int, input().split()))

galactic_timeline(n, top, bottom)

