import math

def f1(A, B, C, x0, y0):
    return abs(A * x0 + B * y0 + C) / math.sqrt(A * A + B * B)

def main():
    x1, y1, x2, y2, x3, y3 = map(int, input().split())

    mn = float('inf')
    ans1, ans2, ans3, ans4 = 0, 0, 0, 0

    for i in range(3):
        if i == 0:
            xa, ya = x1, y1
        elif i == 1:
            xa, ya = x2, y2
        else:
            xa, ya = x3, y3

        if i == 0:
            xB, yB = x2, y2
        elif i == 1:
            xB, yB = x3, y3
        else:
            xB, yB = x1, y1

        A = yB - ya
        B = xa - xB
        C = xB * ya - xa * yB

        dist = 0
        dist += f1(A, B, C, x1, y1)
        dist += f1(A, B, C, x2, y2)
        dist += f1(A, B, C, x3, y3)

        if dist < mn:
            mn = dist
            ans1, ans2 = xa, ya
            ans3, ans4 = xB, yB

    print(ans1, ans2)
    print(ans3, ans4)

if __name__ == "__main__":
    main()
