#include <bits/stdc++.h>
#define fr first
#define sc second
#define ll long long
#define pb push_back
#define no cout << "NO" << endl
#define yes cout << "YES" << endl
#define IShowSpeed ios_base::sync_with_stdio(0); cin.tie(0);
using namespace std;

double distanceToLine(int x1, int y1, int x2, int y2, int px, int py)
{
    int A = y2 - y1;
    int B = x1 - x2;
    int C = -(A * x1 + B * y1);
    return abs(A * px + B * py + C) / sqrt(A * A + B * B);
}

pair<pair<int, int>, pair<int, int>> findOptimalTrench(int x1, int y1, int x2, int y2, int x3, int y3)
{
    double dist1 = distanceToLine(x1, y1, x2, y2, x3, y3);
    double dist2 = distanceToLine(x1, y1, x3, y3, x2, y2);
    double dist3 = distanceToLine(x2, y2, x3, y3, x1, y1);

    if (dist1 <= dist2 && dist1 <= dist3) {
        return {{x1, y1}, {x2, y2}};
    } else if (dist2 <= dist1 && dist2 <= dist3) {
        return {{x1, y1}, {x3, y3}};
    } else {
        return {{x2, y2}, {x3, y3}};
    }
}

void mercurii()
{
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    auto ans = findOptimalTrench(x1, y1, x2, y2, x3, y3);
    cout << ans.first.first << " " << ans.first.second << endl;
    cout << ans.second.first << " " << ans.second.second << endl;
}
/*
 4 5 8 10 9 100

 9 100
 4 5
 ================
 1 3 4 6 9 14

 9 14
 1 3
 ================
 13 88 104 200 888 12


 888 12
 13 88
 */
int main() {
    IShowSpeed
    ll t = 1;
    // cin >> t;
    while (t--) {
        mercurii();
    }
}
