#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

bool check(double c, double h) {
    double D = c * c * c * c - 4 * c * c * h * h;
    double t1, t2;

    if (D > 0) {
        t1 = (c*c - sqrt(D)) / 2;
        t2 = (c*c + sqrt(D)) / 2;
    }
    else if (D == 0) {
        t1 = t2 = c*c / 2;
    } else {
        return false;
    }

    return (t1 >= 0 || t2 >= 0);
}

int main() {
    double c, h;
    cin >> c >> h;
    if (check(c, h)) {
        cout << c * h / 2 << '\n';
    } else {
        cout << -1 << '\n';
    }
}
