import math

def find_fraction(n, digits):
    # Число a из строки цифр после запятой
    a = int(digits)
    # Число b как 10^n
    b = 10 ** n
    
    # Проверка, что дробь несократима
    gcd_ab = math.gcd(a, b)
    a //= gcd_ab
    b //= gcd_ab
    
    # Проверка условий задачи
    if 0 < a < b < 10**6:
        return "YES", a, b
    else:
        return "NO"

# Чтение данных
n = int(input())
digits = input().strip()

# Выполнение
result = find_fraction(n, digits)

# Вывод результата
if result == "NO":
    print("NO")
else:
    print(result[0])
    print(result[1], result[2])


