def min_cuts(n, m, s):
    if s == n * m:
        return 0  

    min_cuts_required = float('inf')

    for x in range(n):
        if s % (x + 1) == 0:  
            y_cuts_needed = s // (x + 1) - 1
            if y_cuts_needed < m:
                min_cuts_required = min(min_cuts_required, x + y_cuts_needed)

    for y in range(m):
        if s % (y + 1) == 0:
            x_cuts_needed = s // (y + 1) - 1
            if x_cuts_needed < n:
                min_cuts_required = min(min_cuts_required, y + x_cuts_needed)

    return min_cuts_required if min_cuts_required != float('inf') else -1

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
