def min_cuts(n, m, s):
    # Если весь лист уже равен s, разрезы не нужны
    if n * m == s:
        return 0

    min_cuts = float('inf')

    # Перебираем количество вертикальных разрезов
    for x in range(n):
        horizontal_area = x * m
        if horizontal_area > s:
            break

        remaining = s - horizontal_area
        if remaining % m == 0:
            y = remaining // m
            if y <= m:
                min_cuts = min(min_cuts, x + y)

    # Перебираем количество горизонтальных разрезов
    for y in range(m):
        vertical_area = y * n
        if vertical_area > s:
            break

        remaining = s - vertical_area
        if remaining % n == 0:
            x = remaining // n
            if x <= n:
                min_cuts = min(min_cuts, x + y)

    return min_cuts


n, m, s = map(int, input().split())
print(min_cuts(n, m, s))


