def solve_galactic_timeline(n, a, b):
    # Списки для итогового упорядочивания
    face_result = []
    back_result = []

    # Минимальный год, начиная с которого нужно упорядочить
    min_face = -float('inf')
    min_back = -float('inf')

    for i in range(n):
        # Проверяем возможность оставить карточку или перевернуть
        if (a[i] >= min_face and b[i] >= min_back) or (b[i] >= min_face and a[i] >= min_back):
            # Выбираем минимальное изменение
            if a[i] >= min_face and b[i] >= min_back:
                face_result.append(a[i])
                back_result.append(b[i])
                min_face, min_back = a[i], b[i]
            elif b[i] >= min_face and a[i] >= min_back:
                face_result.append(b[i])
                back_result.append(a[i])
                min_face, min_back = b[i], a[i]
        else:
            # Если невозможно, выводим -1
            return -1

    return face_result, back_result


# Чтение данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение задачи
result = solve_galactic_timeline(n, a, b)

if result == -1:
    print(-1)
else:
    print(*result[0])
    print(*result[1])
