def get_position():
    directions = [(-1, -1), (1, 1), (-1, 1), (1, -1)]  # Возможные ходы слона
    position = (0, 0)  # Текущая позиция
    
    # Перевод нотации в координаты и обратно
    def to_coords(pos):
        return ord(pos[0]) - ord('a') + 1, int(pos[1])
    
    def to_notation(x, y):
        return chr(x + ord('a') - 1) + str(y)
    
    # Проверка диагоналей
    for dx, dy in directions:
        for step in range(1, 8):
            print(f"? {dx * step} {dy * step}")
            response = input().strip()
            if response == '+':
                position = (dx * step, dy * step)
                break
    
    # Вывод результата
    x, y = position
    print(f"! {to_notation(x, y)}")