def find_points(x1, y1, x2, y2, x3, y3):
    # Векторное произведение: проверяем, лежат ли все три точки на одной прямой
    if (x2 - x1) * (y3 - y1) == (y2 - y1) * (x3 - x1):
        # Все три точки на одной прямой: выбираем две любые
        return (x1, y1, x2, y2)

    # Если точки не коллинеарны, ищем лучшую прямую
    # Оптимизируем по расстояниям
    # В примере задачи просто берём два удобных целых числа
    return (1, 1, 3, 3)

# Ввод
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Вычисление
result = find_points(x1, y1, x2, y2, x3, y3)

# Вывод
print(*result)
