#include <stdio.h>

typedef long long ll;

ll gcd(ll a, ll b) {
    while (b) {
        ll t = b;
        b = a % b;
        a = t;
    }
    return a;
}

int main() {
    int n;
    char digits[20];
    scanf("%d", &n);
    scanf("%s", digits);

    ll d = 0;
    for (int i = 0; i < n; ++i) {
        d = d * 10 + (digits[i] - '0');
    }

    ll ten_pow_n = 1;
    for (int i = 0; i < n; ++i) {
        ten_pow_n *= 10;
    }

    ll g = gcd(d, ten_pow_n);

    ll a = d / g;
    ll b = ten_pow_n / g;

    if (a > 0 && a < b && a < 1000000 && b < 1000000) {
        printf("YES\n%lld %lld\n", a, b);
    } else {
        printf("NO\n");
    }

    return 0;
}