from collections import defaultdict

aa = defaultdict(lambda: defaultdict(set))
aa1 = defaultdict(int)

def pop(v, u, c, op):
    if op == '+':
        aa[c][v].add(u)
        aa[c][u].add(v)
        aa1[c] += 1
    elif op == '-':
        aa[c][v].discard(u)
        aa[c][u].discard(v)
        aa1[c] -= 1

def colcul():
    k = 0
    for color, nodes in aa.items():
        is_superior = True
        for vertex, adjacent in nodes.items():
            if len(adjacent) > 1:
                is_superior = False
                break
        if is_superior:
            k += aa1[color]
    return k

n, q = map(int, input().split())
for _ in range(q):
    op, v, u, c = input().split()
    v, u, c = int(v), int(u), int(c)
    pop(v, u, c, op)

    print(colcul())
