from collections import defaultdict

n, q = map(int, input().split())

g = {}
cg = defaultdict(lambda: defaultdict(int))

def klychkov(puck):
    count1 = 0
    for (u, v, c), x in g.items():
        if x and c == puck:
            count1 += 1
    return count1

for _ in range(q):
    k1 = input().split()
    op = k1[0]
    u, v, c = int(k1[1]), int(k1[2]), int(k1[3])
    k2 = (min(u, v), max(u, v), c)

    if op == '+':
        g[k2] = True
        cg[u][c] += 1
        cg[v][c] += 1
    else:
        g[k2] = False
        cg[u][c] -= 1
        cg[v][c] -= 1

    res = 0
    for puck in set([c for (u, v, c), i in g.items() if i]):
        k3 = True
        for counts in cg.values():
            if puck in counts and counts[puck] > 1:
                k3 = False
                break
        if k3:
            res += klychkov(puck)

    print(res)