from collections import defaultdict

n, q = map(int, input().split())

g = {}
rg = defaultdict(lambda: defaultdict(int))

def klychkov(puck):
    count1 = 0
    for (u, v, c), x in g.items():
        if x and c == puck:
            count1 += 1
    return count1

for _ in range(q):
    q1 = input().split()
    op, u, v, c = q1[0], int(q1[1]), int(q1[2]), int(q1[3])
    k2 = (min(u, v), max(u, v), c)

    if op == '+':
        g[k2] = True
        rg[u][c] += 1
        rg[v][c] += 1
    else:
        g[k2] = False
        rg[u][c] -= 1
        rg[v][c] -= 1

    res = 0
    for i in {c for (u, v, c), y in g.items() if y}:
        k3 = False
        for counts in rg.values():
            if i in counts and counts[i] > 1:
                k3 = True
                break
        if not k3:
            res += klychkov(i)

    print(res)