def klychkov(arr1, arr2):
    if len(arr1) <= 1:
        return arr1, arr2
    m = len(arr1) // 2
    l1, l2 = klychkov(arr1[:m], arr2[:m])
    r1, r2 = klychkov(arr1[m:], arr2[m:])
    res1, res2 = [], []
    i, j = 0, 0
    while i < len(l1) or j < len(r1):
        if i < len(l1) and (j == len(r1) or l1[i] <= r1[j]):
            res1.append(l1[i])
            res2.append(l2[i])
            i += 1
        else:
            res1.append(r1[j])
            res2.append(r2[j])
            j += 1
    return res1, res2

a = int(input())
b = list(map(int, input().split()))
c = list(map(int, input().split()))
f = []
f2 = []
for i in range(a):
    f.append(min(b[i], c[i]))
    f2.append(max(b[i], c[i]))

f, f2 = klychkov(f, f2)

if all(f2[i] <= f2[i+1] for i in range(a-1)):
    print(*f)
    print(*f2)
else:
    print(-1)