#include <bits/stdc++.h>
using namespace std;

int main() {
    long long n, q;
    cin >> n >> q;

    unordered_map<long long, long long> total_count;
    vector<unordered_map<long long, long long>> node_color_count(n + 1);
    unordered_map<long long, long long> invalid_count;
    long long valid_sum = 0;

    while (q--) {
        char op;
        long long v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            if (++node_color_count[v][c] == 2) {
                if (invalid_count[c]++ == 0) valid_sum -= total_count[c];
            }
            if (++node_color_count[u][c] == 2) {
                if (invalid_count[c]++ == 0) valid_sum -= total_count[c];
            }
            if (++total_count[c] == 1 && invalid_count[c] == 0) valid_sum += 1;
        } else if (op == '-') {
            if (--total_count[c] == 0 && invalid_count[c] == 0) valid_sum -= 1;
            if (--node_color_count[v][c] == 1) {
                if (--invalid_count[c] == 0) valid_sum += total_count[c];
            }
            if (--node_color_count[u][c] == 1) {
                if (--invalid_count[c] == 0) valid_sum += total_count[c];
            }
        }

        cout << valid_sum << endl;
    }

    return 0;
}
