#include <iostream>
#include <string>
#include <cmath>

using namespace std;
using ll = long long;

int main() {
    ll n; // количество знаков после запятой
    string digits; // сами цифры после запятой

    // Чтение входных данных
    cin >> n;
    cin >> digits;

    // Преобразуем дробную часть в целое число
    ll fractional_part = stoi(digits); // цифры после запятой как целое число
    ll denominator = pow(10, n); // знаменатель для получения дробного числа

    // Ищем подходящие a и b
    for (ll b = fractional_part + 1; b < 1000000; ++b) { // b > a
        if (b % denominator == 0) { // b должно быть кратно знаменателю
            ll a = (b / denominator) * fractional_part;
            if (a > 0 && a < b) { // Условие на a и b
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    // Если не нашли, выводим NO
    cout << "NO" << endl;
    return 0;
}