#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

int computeGCD(long long x, long long y)
{
    while (y != 0)
    {
        long long t = y;
        y = x % y;
        x = t;
    }
    return x;
}

string bigIntMod(const string& s, long long m)
{
    long long res = 0;
    for (char c : s) {
        res = (res * 10 + (c - '0')) % m;
    }
    return to_string(res);
}

int main() {
    int length;
    string input;
    cin >> length >> input;
    string num1 = input;
    string num2 = "1" + string(length, '0');

    long long divisor = computeGCD(stoll(num1), stoll(num2));

    num1 = to_string(stoll(num1) / divisor);
    num2 = to_string(stoll(num2) / divisor);

    if (stoll(num1) < stoll(num2) && stoll(num2) < 1000000)
    {
        cout << "YES" << endl;
        cout << num1 << " " << num2 << endl;
    }
    else
    {
        cout << "NO" << endl;
    }
    return 0;
}
