def solve(n, a, b):

    cards = [(a[i], b[i]) for i in range(n)]
    
    
    cards.sort()

    face_years = []
    back_years = []


    last_face = -1  
    last_back = -1  

    for card in cards:
        a_i, b_i = card


        if a_i >= last_face:
            face_years.append(a_i)
            last_face = a_i
        elif b_i >= last_face:
            back_years.append(b_i)
            last_face = b_i
        else:

            return -1

    if len(face_years) != n or len(back_years) != n:
        return -1


    print(" ".join(map(str, face_years)))
    print(" ".join(map(str, back_years)))



n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))


solve(n, a, b)
