#include <bits/stdc++.h>
using namespace std;

#define MAX_COLOR 100005

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int n, q;
    cin >> n >> q;

    vector<int> edge_count(MAX_COLOR, 0);
    vector<vector<int>> vertex_edges(MAX_COLOR, vector<int>(n + 1, 0));

    long long total_beauty = 0;

    for (int i = 0; i < q; ++i) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            
            edge_count[c]++;
            vertex_edges[c][v]++;
            vertex_edges[c][u]++;
        } else if (op == '-') {
            edge_count[c]--;
            vertex_edges[c][v]--;
            vertex_edges[c][u]--;
        }

        total_beauty = 0;
        for (int color = 1; color <= 100000; ++color) {
            bool is_excellent = true;
            if (edge_count[color] > 0) {
                for (int i = 1; i <= n; ++i) {
                    if (vertex_edges[color][i] > 1) {
                        is_excellent = false;
                        break;
                    }
                }
            }
            if (is_excellent) {
                total_beauty += edge_count[color];
            }
        }

        cout << total_beauty << '\n';
    }

}
