import math

def calculate_triangle_area(c, h):
    if h <= 0 or h >= c:
        return -1
    exists = False
    for a in range(1, c):
        b = math.sqrt(c**2 - a**2)  
        if b.is_integer() and a * int(b) == h * c:  
            exists = True
            break
    if exists:
        return 0.5 * c * h
    else:
        return -1
c = int(input())
h = int(input())
result = calculate_triangle_area(c, h)
if result == -1:
    print(result)
else:
    print(f"{result:.1f}")