#include <iostream>
#include <cmath>
using namespace std;

int main() {
    double c, h;
    cin >> c >> h;

    
    if (h > c) {
        cout << -1 << endl;
        return 0;
    }

    
    double discriminant = c * c - 4 * h * c;
    if (discriminant < 0) {
        cout << -1 << endl;
        return 0;
    }

    
    double a = (c + sqrt(discriminant)) / 2;
    double b = (c - sqrt(discriminant)) / 2;

    
    if (a > 0 && b > 0) {
        cout << 0.5 * a * b << endl;  
    } else {
        cout << -1 << endl;  
    }

    return 0;
}