import math

def simplify_fraction(a, b):
    gcd = math.gcd(a, b)
    
    a_simplified = a // gcd
    b_simplified = b // gcd
    
    return a_simplified, b_simplified

length = int(input())
number = int(input())

numerator = number
denominator = 10 ** length

simplified_a, simplified_b = simplify_fraction(numerator, denominator)

if (simplified_b / (10 ** 6)) >= 1:
    print("NO")
else:
    print(f"YES\n{simplified_a} {simplified_b}")
