#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    ll A, B, S;
    cin >> A >> B >> S;
    
    if(S == A * B){
        cout << 0;
        return 0;
    }
    
    bool one_cut = false;
    
    if(B != 0 && S % B == 0){
        ll k = S / B;
        if(k >=1 && k < A){
            one_cut = true;
        }
    }
    
    if(A != 0 && S % A == 0){
        ll k = S / A;
        if(k >=1 && k < B){
            one_cut = true;
        }
    }
    
    if(one_cut){
        cout << 1;
        return 0;
    }
    
    bool two_cuts = false;
    for(ll x = 1; x < A && !two_cuts; x++){
        for(ll y =1; y < B && !two_cuts; y++){
            ll area1 = x * y;
            ll area2 = x * (B - y);
            ll area3 = (A - x) * y;
            ll area4 = (A - x) * (B - y);
            
            vector<ll> areas = {area1, area2, area3, area4};
            for(int mask =1; mask < (1<<4); mask++){
                ll sum =0;
                for(int i=0;i<4;i++) if(mask & (1<<i)) sum += areas[i];
                if(sum == S){
                    two_cuts = true;
                    break;
                }
            }
        }
    }
    
    if(two_cuts){
        cout << 2;
        return 0;
    }
    
    cout << 3;
}