
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define F first
#define S second
double dist(ld x1, ld y1, ld x2, ld y2, ld x3, ld y3){
    if(x1 == x2){
        return abs(x3 - x1);
    }
    if(y1 == y2){
        return abs(y3 - y1);
    }
    ld a = abs((y2 - y1)*x3 - (x2 - x1)*y3 + (x2*y1 - y2*x1));
    ld b = sqrt((y2 - y1)*(y2 - y1) + (x2 - x1)*(x2 - x1));
    return a / b;
}
ld eps = 1e-9;
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    ld d1 = dist(x1, y1, x2, y2, x3, y3);
    ld d2 = dist(x1, y1, x3, y3, x2, y2);
    ld d3 = dist(x2, y2, x3, y3, x1, y1);

    double mn = d1;
    pair<pair<ll, ll>, pair<ll, ll>> line = {{x1, y1}, {x2, y2}};

    if(d2 < mn - eps){
        mn = d2;
        line = {{x1, y1}, {x3, y3}};
    }
    if(d3 < mn - eps){
        mn = d3;
        line = {{x2, y2}, {x3, y3}};
    }
    if(line.F == line.S){
        cout << line.F.F << " " << line.F.S << " " << (line.F.F +1) << " " << line.F.S;
        return 0;
    }
    cout << line.F.F << " " << line.F.S << " " << line.S.F << " " << line.S.F;
    return 0;
}
