# Функция для преобразования индексов в шахматную нотацию
def to_chess_notation(x, y):
    # x: 0-7 для столбцов (a-h), y: 0-7 для строк (1-8)
    return chr(ord('a') + x) + str(8 - y)

# Основная логика поиска начальной позиции слона
def find_bishop_position():
    # Массив возможных ходов (x, y) по диагонали
    moves = [(1, 1), (-1, -1), (1, -1), (-1, 1)]
    
    # Для поиска координат слона, начнем с центра доски
    # Попробуем максимальные возможные ходы
    for dx, dy in moves:
        # Запрашиваем ход с максимальными смещениями по диагонали
        print(f"? {dx} {dy}")
        response = input().strip()  # В ответе будет '+' или '-'
        
        if response == '+':
            # Если ход успешен, значит слон находится в каком-то месте, откуда такой ход возможен
            # Мы ограничиваем поиск одной из клеток, откуда такой ход мог бы быть
            # Например, для хода (1,1) можно ожидать, что слон находится где-то на линии,
            # которая тянется от нижнего левого к верхнему правому углу.
            # Мы продолжаем искать слона, пока не локализуем его точное местоположение.
            pass
        elif response == '-':
            # Если ход невозможен, мы исключаем эту линию поиска
            pass
        
        # Повторяем процесс, сужая область поиска
