#include <bits/stdc++.h>

using namespace std;
const int maxn = 250002;
#define int long double
#define ld long double
using pii = pair<int, int>;
constexpr char nl = '\n';
const int inf = 1e13;

// pair<int, int> dp[maxn];

struct line {
    int k, b;
    line() {}
    line(int a, int _b) { k = a, b = _b; }
    int get(int x) { return k * x + b; }
};

vector<line> lines;
vector<int> dots;

int cross(line a, line b) {
    int x = (b.b - a.b) / (a.k - b.k);
    if (b.b < a.b) x--;
    return x;
}


void add(line cur) {
    while (lines.size() && lines.back().get(dots.back()) > cur.get(dots.back())) {
        lines.pop_back();
        dots.pop_back();
    }
    if (lines.empty())
        dots.push_back(-inf);
    else
        dots.push_back(cross(lines.back(), cur));
    lines.push_back(cur);
}

int get(int x) {
    int pos = lower_bound(dots.begin(), dots.end(), x) - dots.begin() - 1;
    return lines[pos].get(x);
}


signed main() {
    ios::sync_with_stdio(false), cout.tie(nullptr), cin.tie(nullptr);
    int n, m, c; cin >> n >> m >> c;
    cout.precision(20);
    vector<pair<int, int>> a(n + 1);
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i].first >> a[i].second;
    }
    a.emplace_back(m, 0);
    vector<ld> dp(n + 2, inf);
    dp[0] = 0;
    for (int i = 1; i < n + 2; i++) {
        ld ai = (a[i - 1].first * a[i - 1].first) / c;
        ai = ai + dp[i - 1];
        ld bi = -2 * a[i - 1].first;
        line x(bi, ai);
        add(x);
        int lll = a[i].first / c;
        int ls = get(lll);
        dp[i] = a[i].second + (a[i].first * a[i].first) / c;
        dp[i] = dp[i] + ls;
    }
    cout << fixed << dp[n + 1];
}
