#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

template<typename A, typename B>
istream& operator>> (istream& in, pair<A, B>& p) {
    in >> p.first >> p.second;
    return in;
}
template<typename A>
istream& operator>> (istream& in, vector<A>& p) {
    for(auto& x : p) in >> x;
    return in;
}
template<typename A, typename B>
ostream& operator<<(ostream& out, pair<A, B> p) {
    out << p.first << ' ' << p.second;
    return out;
}
template<typename A>
ostream& operator<<(ostream& out, vector<A> p) {
    for(auto& x : p) out << x << ' ';
    return out;
}

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

struct point {
    int x, y;

    [[nodiscard]] int size() const {
        return (x * x + y * y);
    }
};

istream& operator>> (istream& in, point& a) {
    in >> a.x >> a.y;
    return in;
}
ostream& operator<< (ostream& out, point& a) {
    out << a.x << ' ' << a.y;
    return out;
}

point vec(point a, point b) {
    point v{};
    v.x = b.x - a.x;
    v.y = b.y - a.y;
    return v;
}

void solve() {
    int n; cin >> n;
    if(n == 3) {
        cout << "2 2\n0 0\n3 0\n0 3\n0 1";
        return;
    }
    vector<pair<int, int>> ans;
    auto rec = [&](auto& self, int v, int xstart, int ystart) {
        if(v == 4) {
            cout << xstart << ' ' << ystart + 2 << '\n';
            cout << xstart << ' ' << ystart + 4 << '\n';
            cout << xstart + 3 << ' ' << ystart + 1 << '\n';
            cout << xstart << ' ' << ystart + 1 << '\n';
            cout << xstart + 3 << ' ' << ystart + 4 << '\n';
            cout << xstart + 3 << ' ' << ystart << '\n';
            return;
        }
        if(v % 2 == 1) {
            self(self, v - 1, xstart + 1, ystart);
            cout << xstart << ' ' << ystart << '\n';
            cout << xstart << ' ' << ystart + v - 1 << '\n';
        } else {
            self(self, v - 1, xstart, ystart + 1);
            cout << xstart + v - 1 << ' ' << ystart + v - 1 << '\n';
            cout << xstart + v - 1 << ' ' << ystart << '\n';
        }
    };
    rec(rec, n, 0, 0);
    if(n%2 == 0) cout << 0 << ' ' << 0;
    else cout << n - 1 << ' ' << n - 1;
}

signed main() {
    cout << fixed << setprecision(16);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}