def min_cuts(n, m, s):
    
    if s % n == 0 or s % m == 0:
        return 1
    
   
    min_cuts = float('inf')
    
    
    for x in range(min(n, s // m) + 1):  
        remaining = s - x * m
        if 0 <= remaining <= n * m and remaining % n == 0:
            min_cuts = min(min_cuts, x + 1)
    
    for y in range(min(m, s // n) + 1):  
        remaining = s - y * n
        if 0 <= remaining <= n * m and remaining % m == 0:
            min_cuts = min(min_cuts, y + 1)
    
    return min_cuts if min_cuts != float('inf') else -1


n, m, s = map(int, input().split())


print(min_cuts(n, m, s))
