from datetime import datetime, timedelta

class GalacticEvent:
    def _init_(self, name, description, event_time):
        self.name = name
        self.description = description
        self.event_time = event_time  # Время события в галактических единицах времени

    def _str_(self):
        return f"{self.name}: {self.description} (время: {self.event_time})"

class GalacticTimeline:
    def _init_(self):
        self.events = []
        self.start_time = datetime(1, 1, 1)  # Начало отсчета времени (например, "начало Вселенной")

    def add_event(self, event):
        """Добавить событие на таймлайн."""
        self.events.append(event)

    def display_timeline(self):
        """Отобразить события на таймлайне."""
        for event in sorted(self.events, key=lambda x: x.event_time):
            time_display = self.start_time + timedelta(days=event.event_time)
            print(f"{time_display.strftime('%Y-%m-%d %H:%M:%S')} - {event}")

# Пример создания галактического таймлайна
galactic_timeline = GalacticTimeline()

# Добавим несколько событий
galactic_timeline.add_event(GalacticEvent(
    "Рождение звездной системы",
    "Образование новой звездной системы в галактике.",
    event_time=1000000  # Время в миллионах лет
))

galactic_timeline.add_event(GalacticEvent(
    "Падение астероида на планету",
    "Космическое тело разрушает планету в одной из звездных систем.",
    event_time=2000000
))

galactic_timeline.add_event(GalacticEvent(
    "Первые разумные формы жизни",
    "Развитие первых разумных существ на обитаемой планете.",
    event_time=3500000
))

galactic_timeline.add_event(GalacticEvent(
    "Галактическая война",
    "Конфликт между цивилизациями в разных уголках галактики.",
    event_time=4000000
))

galactic_timeline.add_event(GalacticEvent(
    "Конец галактической войны",
    "Заключение мира после долгих лет разрушений.",
    event_time=4500000
))


galactic_timeline.display_timeline()
