def query(x, y):
    print(f"? {x} {y}")
    response = input().strip()
    return response

def find_bishop_position():
    possible_positions = set()
   
   
    for i in range(8):
        for j in range(8):
            possible_positions.add((i, j))  
    
    
    movements = [(1, 1), (1, -1), (-1, 1), (-1, -1)]   
    
    for dx, dy in movements:
       
        response = query(dx, dy)
        
        if response == "+":
            
            new_possible_positions = set()
            for i, j in possible_positions:
                if (i + dx >= 0 and i + dx < 8) and (j + dy >= 0 and j + dy < 8):
                    new_possible_positions.add((i + dx, j + dy))
            possible_positions &= new_possible_positions
        else:
           
            new_possible_positions = set()
            for i, j in possible_positions:
                if not (0 <= i + dx < 8 and 0 <= j + dy < 8):
                    new_possible_positions.add((i, j))
            possible_positions &= new_possible_positions
    
   
    if possible_positions:
        (initial_row, initial_col) = possible_positions.pop()
        final_position = chr(initial_col + ord('a')) + str(8 - initial_row)
        print(f"! {final_position}")

# find_bishop_position()
