#include <bits/stdc++.h>
using namespace std;
int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; i++) {
        cards[i] = {a[i], b[i]};
    }
    sort(cards.begin(), cards.end(), [](pair<int, int>& x, pair<int, int>& y) {
        return min(x.first, x.second) < min(y.first, y.second);
    });
    vector<int> top(n), bottom(n);
    for (int i = 0; i < n; i++) {
        top[i] = min(cards[i].first, cards[i].second);
        bottom[i] = max(cards[i].first, cards[i].second);
    }
    for (int i = 1; i < n; i++) {
        if (top[i] < top[i - 1] || bottom[i] < bottom[i - 1]) {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i = 0; i < n; i++) cout << top[i] << " ";
    cout << endl;
    for (int i = 0; i < n; i++) cout << bottom[i] << " ";
    cout << endl;
    return 0;
}
