using System;
using System.Collections.Generic;
using System.Linq;

namespace ConsoleApp4
{
    internal class Program
    {
        static void Main(string[] args)
        {
            int n = Convert.ToInt32(Console.ReadLine());

            // Считываем две строки и разделяем их на массивы строк
            string[] list1 = Console.ReadLine().Split(' ');
            string[] list2 = Console.ReadLine().Split(' ');

            // Преобразуем массивы в списки и объединяем их
            var combinedList = new List<string>(list1.Concat(list2));

            // Проверяем на наличие повторяющихся элементов
            if (combinedList.Distinct().Count() != combinedList.Count)
            {
                Console.WriteLine(-1);
                return;
            }

            // Сортируем объединённый список
            combinedList.Sort();

            // Выводим список, по 4 элемента в строке
            for (int i = 0; i < combinedList.Count; i++)
            {
                Console.Write(combinedList[i] + " ");
                if ((i + 1) % 4 == 0)
                    Console.WriteLine();
            }

            // Если последний ряд не завершился на 4 элемента, выводим пустую строку
            if (combinedList.Count % 4 != 0)
                Console.WriteLine();
        }
    }
}
