def create_route(n):
    # Список для хранения координат маршрута
    route = []
    
    # Добавляем начальную точку
    route.append((0, 0))
    
    # Генерируем точки маршрута
    for i in range(n):
        if i % 2 == 0:
            # Двигаемся вправо по текущей строке
            for j in range(n):
                if not (i == 0 and j == 0):  # Пропускаем начальную точку
                    route.append((i, j))
        else:
            # Двигаемся влево по текущей строке
            for j in range(n - 1, -1, -1):
                route.append((i, j))
    
    # Добавляем конечную точку
    route.append((n - 1, n - 1))
    
    return route

# Чтение размера сетки
n = int(input("Введите размер сетки (n): ").strip())

# Получаем маршрут
route = create_route(n)

# Вывод конечной точки
print(route[-1][0], route[-1][1])

# Вывод всех остальных точек маршрута
for point in route[:-1]:  # Исключаем конечную точку из вывода
    print(point[0], point[1])
