def find_line(x1, y1, x2, y2, x3, y3):
    # Средние значения координат
    mx = (x1 + x2 + x3) / 3
    my = (y1 + y2 + y3) / 3
    
    # Параметры прямой вида y = ax + b
    numerator = (x1 - mx) * (y1 - my) + (x2 - mx) * (y2 - my) + (x3 - mx) * (y3 - my)
    denominator = (x1 - mx) ** 2 + (x2 - mx) ** 2 + (x3 - mx) ** 2
    
    a = numerator / denominator
    b = my - a * mx
    
    return a, b

# Чтение входных данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

a, b = find_line(x1, y1, x2, y2, x3, y3)

# Находим две точки на прямой y = ax + b
x4, y4 = 1, int(a * 1 + b)
x5, y5 = 3, int(a * 3 + b)

print(f"{x4} {y4} {x5} {y5}")
