def min_cuts(n, m, s):
    if s == n * m:
        return 0

    min_cuts = float('inf')

    for i in range(1, n):
        if s % (i * m) == 0 or s <= i * m or (i * m >= s and (i * m - s) % m == 0):
            min_cuts = min(min_cuts, 1)

    for j in range(1, m):
        if s % (j * n) == 0 or s <= j * n or (j * n >= s and (j * n - s) % n == 0):
            min_cuts = min(min_cuts, 1)

    for i in range(1, n):
        for j in range(1, m):
            if i * m + j * n - i * j >= s:
                min_cuts = min(min_cuts, 1 + 1)

    return min_cuts if min_cuts != float('inf') else -1

n, m, s = map(int, input().split())

result = min_cuts(n, m, s)

print(result)