from collections import defaultdict

def process_queries(n, q, queries):
    
    edge_count = defaultdict(int)  
    vertex_degree = defaultdict(lambda: defaultdict(int))  
    
    total_beauty = 0

    
    results = []
    for query in queries:
        action, v, u, c = query
        v, u, c = int(v), int(u), int(c)

        if action == '+':
            
            edge_count[c] += 1
            vertex_degree[c][v] += 1
            vertex_degree[c][u] += 1

            total_beauty
            if vertex_degree[c][v] == 1 and vertex_degree[c][u] == 1:
                total_beauty += 1
        elif action == '-':
            
            edge_count[c] -= 1
            vertex_degree[c][v] -= 1
            vertex_degree[c][u] -= 1

            
            if vertex_degree[c][v] == 0 and vertex_degree[c][u] == 0:
                total_beauty -= 1
        
        results.append(total_beauty)
    
    return results


n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]


results = process_queries(n, q, queries)
for res in results:
    print(res)
