#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;
    
    // Если n нечётное, сразу выводим -1, так как решение невозможно
    if (n % 2 != 0) {
        cout << -1 << endl;
        return 0;
    }

    // Инициализируем поле
    vector<vector<int>> grid(n, vector<int>(n));

    // Нумерация для n-миношек, будем идти змейкой
    int current = 1;

    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) { // Четные строки
            for (int j = 0; j < n; j++) {
                grid[i][j] = current;
                if (j == n - 1) current++;
            }
        } else { // Нечетные строки
            for (int j = n - 1; j >= 0; j--) {
                grid[i][j] = current;
                if (j == 0) current++;
            }
        }
    }

    // Выводим результат
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << grid[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
