#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

struct Point{
    ld x, y;
    Point(){

    }
    Point(ld _x, ld _y){
        x = _x;
        y = _y;
    }
    Point(Point a, Point b){
        x = b.x - a.x;
        y = b.y - a.y;
    }
    ld ln() {
        return sqrt(x * x + y * y);
    }
    Point operator+(Point a){
        return Point(x + a.x, y + a.y);
    }
    Point operator-(Point a){
        return Point(x - a.x, y - a.y);
    }
    Point operator/(ld k){
        return Point(x / k, y / k);
    }
    Point operator*(ld k){
        return Point(x * k, y * k);
    }
    Point rev(){
        return Point(y, x);
    }
    ld operator%(Point a){
        return x * a.y - y * a.x;
    }
    ld operator*(Point a){
        return x * a.x + y * a.y;
    }
};

void viperr() {
    Point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    Point vec1 = a - c, vec2 = a - b, vec3 = b - c;
    if(vec1.ln() >= vec2.ln() && vec1.ln() >= vec3.ln()){
        cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y;
    }
    else if(vec1.ln() <= vec2.ln() && vec2.ln() >= vec3.ln()){
        cout << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y;
    }
    else{
        cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    viperr();
    return 0;
}