﻿#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct cht {
	struct Line {
		ld a = 0, b = LLONG_MAX;
		ld operator() (ll x) {
			return x * a + b;
		}
		ld intercetion(Line& l) {
			return (b - l.b) / ld(l.a - a);
		}
	};
	struct Seg {
		ld start = -1e9;
		Line f;
	};
	vector<Seg> stack;
	void add(Line f) {
		while (stack.size() > 0 && f(stack.back().start) < stack.back().f(stack.back().start)) {
			stack.pop_back();
		}
		stack.push_back({ (stack.size() ? stack.back().f.intercetion(f) : -1e9), f });
	}
	ld get(ll x) {
		return (--lower_bound(stack.begin(), stack.end(), x, [](Seg& l, ll r) {return l.start <= r; }))->f(x);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll n, m, c; cin >> n >> m >> c;
	vector<ll> x(n), t(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> t[i];
	}
	cht hull;
	hull.add({ 0, 0 });
	vector<ld> dp(n);
	for (int i = 0; i < n; i++) {
		dp[i] = hull.get(x[i]) + x[i] * x[i] / ld(c) + t[i];
		hull.add({ -2.0 * x[i] / c, dp[i] + x[i] * x[i] / ld(c)});
	}
	cout << hull.get(m) + m * m / ld(c);

	return 0;
}