#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>
using namespace std;
int main() {
    double x0, y0, x1, y1, n, sum = 0;
    cin >> x0 >> y0 >> x1 >> y1 >> n;
    vector<int> steps(n);
    for (int i = 0; i < n; ++i) {
        cin >> steps[i];
        sum += steps[i];
    }
    double distance = sqrt(pow(x0 - x1, 2) + pow(y0 - y1, 2));
    if (sum >= distance) { 
        cout << "Possible" << endl;
        double x = x1 - x0;
        double y = y1 - y0;
        double dist = distance;
        for (int i = 0; i < n; ++i) {
            double stepSize = (double)steps[i] / sum * distance; 
            if (dist >= stepSize) {
                x0 += (x / distance) * stepSize;
                y0 += (y / distance) * stepSize;
                dist -= stepSize;
            }
            else {
                x0 += x;
                y0 += y;
            }
            cout << fixed << setprecision(10) << x0 << " " << y0 << endl; 
        }
    }
    else {
        cout << "Impossible" << endl;
    }
    return 0;
}
