# Ввод
n, q = map(int, input().split())

# Словарь для хранения рёбер каждого цвета по вершинам
edges = {}

# Массив для подсчёта суммы красоты
total_beauty = 0

# Для каждого запроса
for _ in range(q):
    # Считываем запрос
    op, v, u, c = input().split()
    v, u, c = int(v) - 1, int(u) - 1, int(c)  # индексы с 0 для удобства

    # Если ребро добавляется
    if op == "+":
        if c not in edges:
            edges[c] = [0] * n  # Создаем массив для этого цвета, если его нет

        edges[c][v] += 1
        edges[c][u] += 1

    # Если ребро удаляется
    elif op == "-":
        edges[c][v] -= 1
        edges[c][u] -= 1

    # Подсчитываем красоту графа
    beauty = 0
    for color, vertex_count in edges.items():
        # Проверяем, является ли цвет превосходным
        if all(count <= 1 for count in vertex_count):
            beauty += sum(1 for count in vertex_count if count == 1)

    # Выводим результат для текущего запроса
    print(beauty)