﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <bitset>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iterator>
#include <numeric>
#include <sstream>
#include <iomanip>
#define decimal fixed << setprecision(17)
using namespace std;
using ll = long long;
using dd = long double;
ll nod(ll a, ll b) {
    return b == 0 ? a : nod(b, a % b);
}
bool cmp(const pair <ll, ll>& a, const pair <ll, ll>& b) {
    return (a.first < b.first && a.second < b.second) || (a.second < b.first && a.first < b.second);
}
void solve() {/*/
    ll n;
    cin >> n;
    vector <ll> a(n);
    vector <ll> b(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    if (n == 1) {
        cout << a[0] << "\n" << b[0];
        return;
    }
    vector <pair <ll, ll>> c(n);
    for (ll i = 0; i < n; ++i) {
        c[i] = { a[i], b[i] };
    }
    sort(c.begin(), c.end(), cmp);
    for (ll i = 1; i < n; ++i) {
        if (c[i - 1].first > c[i].first) {
            swap(c[i - 1].first, c[i - 1].second);
        }
    }
    if (c[n - 2].first > c[n - 1].first || c[n - 2].second > c[n - 1].second) {
        swap(c[n - 1].first, c[n - 1].second);
    }
    bool f = true;
    for (ll i = 1; i < n; ++i) {
        if (c[i - 1].first > c[i].first || c[i - 1].second > c[i].second) {
            f = false;
        }
    }
    if (f) {
        for (ll i = 0; i < n; ++i) {
            cout << c[i].first << ' ';
        }
        cout << "\n";
        for (ll i = 0; i < n; ++i) {
            cout << c[i].second << ' ';
        }
    }
    else {
        cout << -1;
    }/*/
    ll n, m, s;
    cin >> n >> m >> s;
    if (n * m == s) {
        cout << 0;
        return;
    }
    ll ans = 2;
    for (ll i = 1; i < n; ++i) {
        if (m * (n - i) == s || m * i == s) {
            cout << 1;
            return;
        }
    }
    for (ll i = 1; i < m; ++i) {
        if (n * (m - i) == s || n * i == s) {
            cout << 1;
            return;
        }
    }
    for (ll x = 1; x < n; ++x) {
        if (x * 2 == n) {
            continue;
        }
        if (((s - m * x) % (n - 2 * x) == 0 && (s - m * x) / (n - 2 * x) <= m) || ((n * m - s - m * x) % (n - 2 * x) == 0 && (n * m - s - m * x) / (n - 2 * x) <= m)) {
            cout << 2;
            return;
        }
    }
    for (ll y = 1; y < m; ++y) {
        if (y * 2 == m) {
            continue;
        }
        if (((s - n * y) % (m - 2 * y) == 0 && (s - n * y) / (m - 2 * y) <= n) || ((n * m - s - n * y) % (m - 2 * y) == 0 && (n * m - s - n * y) / (m - 2 * y) <= n)) {
            cout << 2;
            return;
        }
    }
    for (ll x = 1; x < n; ++x) {
        if (s % x == 0) {
            if (s / x < m) {
                cout << 2;
                return;
            }
        }
        if ((n * m - s) % x == 0) {
            if ((n * m - s) / x < m) {
                cout << 2;
                return;
            }
        }
    }
    for (ll x = 1; x < m; ++x) {
        if (s % x == 0) {
            if (s / x < n) {
                cout << 2;
                return;
            }
        }
        if ((n * m - s) % x == 0) {
            if ((n * m - s) / x < n) {
                cout << 2;
                return;
            }
        }
    }
    if (s > 100) {
        cout << 5;
        return;
    }
    cout << 3;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

}