﻿#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#define ll long long
#define ben(a) a.begin(), a.end()

using namespace std;

bool isp(long long a) {
    for (int i = 2; i < sqrt(a) + 1; ++i) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

int main()
{
    long long n, m, s;
    cin >> n >> m >> s;

    if (s == n * m) {
        cout << 0;
        return 0;
    }

    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return 0;
    }

    /*if (n == 2 && m == 2) {
        if (s == 2) {
            cout << 1;
            return 0;
        }
        else {
            cout << 2;
            return 0;
        }
    }*/

    if (isp(s)) {
        if (s > max(n, m)) {
            s = n * m - s;
            if (isp(s)) {
                s = min(s, n * m - s);
                for (long long a = 1; a < m; ++a) {
                    long long l = 1;
                    long long r = n;
                    
                    while (l < r) {
                        long long md = (l + r) / 2;

                        if (a * md == s || a * (n - md) == s || md * (m - a) == s || (n - md) * (m - a) == s) {
                            cout << 2;
                            return 0;
                        }

                        if (a * (n - md) + md * (m - a) <= s) {
                            if (a * 2 <= m) {
                                l = md;
                            }
                            else {
                                r = md;
                            }
                        }
                        else {
                            if (a * 2 <= m) {
                                r = md;
                            }
                            else {
                                l = md;
                            }
                        }
                        if (a * (n - md) + md * (m - a) == s) {
                            cout << 2;
                            return 0;
                        }
                    }

                    if (a * l + (n - l) * (m - a) == s) {
                        cout << 2;
                        return 0;
                    }
                }
                cout << 3;
                return 0;
            }
        }
    }

    cout << 2;
    return 0;
}