def solve():
    n = int(input())
    a = list(map(int, input().split()))
    b = list(map(int, input().split()))
    
    cards = [(a[i], b[i]) for i in range(n)]
    
    cards.sort()
    
    face = []
    back = []
    
    prev_face = prev_back = -1
    
    for f, b_ in cards:
        if f >= prev_face and b_ >= prev_back:
            if f <= b_:
                face.append(f)
                back.append(b_)
                prev_face = f
                prev_back = b_
            else:
                face.append(b_)
                back.append(f)
                prev_face = b_
                prev_back = f
        else:
            print(-1)
            return
    
    print(" ".join(map(str, face)))
    print(" ".join(map(str, back)))
