def solve_timeline(n, a, b):
    cards = list(zip(a, b))
    cards.sort(key=lambda x: min(x[0], x[1]))
    top = []
    bottom = []
    top_prev = bottom_prev = 0
    for card in cards:
        if card[0] >= top_prev and card[1] >= bottom_prev:
            top.append(card[0])
            bottom.append(card[1])
            top_prev, bottom_prev = card[0], card[1]
        elif card[1] >= top_prev and card[0] >= bottom_prev:
            top.append(card[1])
            bottom.append(card[0])
            top_prev, bottom_prev = card[1], card[0]
        else:
            return -1
    return top, bottom
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
result = solve_timeline(n, a, b)
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))