def solve(n):
    # List to store the points in the path
    path = []
    
    # Step 1: Start at (n-1, n-1)
    path.append((n-1, n-1))
    
    # Step 2: First move down column n-1
    for i in range(n-1, -1, -1):
        path.append((i, n-1))
    
    # Step 3: Move left across the last row
    for j in range(n-2, -1, -1):
        path.append((n-1, j))
    
    # Print the points in the required format
    for point in path:
        print(f"{point[0]} {point[1]}")
    
# Read the input
n = int(input())

# Solve the problem for the given n
solve(n)
