#include <iostream>
#include <unordered_map>
#include <vector>
using namespace std;

struct G {
    int a;
    int b;
    bool c;
    unordered_map<int, int> d;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    char op;
    int x, y, z;

    unordered_map<int, G> m;
    long long total = 0;

    for (int i = 0; i < q; ++i) {
        cin >> op >> x >> y >> z;
        if (x == y) continue;

        G& g = m[z]; 

        bool prevC = g.c;
        int prevA = g.a;

        if (m.find(z) == m.end()) {
            m[z] = {0, 0, true, unordered_map<int, int>()};
        }

        if (op == '+') {
            g.d[x] += 1;
            g.d[y] += 1;
            g.a += 1;

            if (g.d[x] == 2) {
                g.b += 1;
            }
            if (g.d[y] == 2) {
                g.b += 1;
            }

        } else if (op == '-') {
            g.d[x] -= 1;
            g.d[y] -= 1;
            g.a -= 1;

            if (g.d[x] == 1) {
                g.b -= 1;
            }
            if (g.d[x] == 0) {
                g.d.erase(x);
            }

            if (g.d[y] == 1) {
                g.b -= 1;
            }
            if (g.d[y] == 0) {
                g.d.erase(y);
            }
        }

        g.c = (g.b == 0);

        if (g.c != prevC) {
            if (g.c) {
                total += g.a;
            } else {
                total -= prevA;
            }
        } else if (g.c) {
            total += (g.a - prevA);
        }

        cout << total << '\n';
    }

    return 0;
}
