#include <bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;

ll a[100001], b[100001];

void merge(ll l, ll mid, ll r){
    vector <ll> vec1;
    vector <ll> vec2;
    ll u1 = l;
    ll u2 = mid + 1;
    while(u1 <= mid && u2 <= r){
        if(a[u1] <= a[u2]){
            vec1.pb(a[u1]);
            vec2.pb(b[u1]);
            u1 ++;
        }
        else{
            vec1.pb(a[u2]);
            vec2.pb(b[u2]);
            u2 ++;
        }
    }
    while(u1 <= mid){
        vec1.pb(a[u1]);
        vec2.pb(b[u1]);
        u1 ++;
    }
    while(u2 <= r){
        vec1.pb(a[u2]);
        vec2.pb(b[u2]);
        u2 ++;
    }
    for(int i = l; i <= r; i++){
        a[i] = vec1[i - l];
        b[i] = vec2[i - l];
    }
}

void merge_sort(ll l, ll r){
    if(l == r) return;
    ll mid = (l + r)/2;
    merge_sort(l, mid);
    merge_sort(mid + 1, r);
    merge(l, mid, r);
}

int main(){
    int n;
    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < n; i++){
        cin >> b[i];
    }
    
    for(int i = 0;i < n; i++){
        if(a[i] >= b[i]) swap(a[i], b[i]);
    }
    
    merge_sort(0, n - 1);
    
    for(int i = 0; i < n - 1; i++){
        if(b[i] > b[i + 1]){
            cout << -1;
            return 0;
        }
    }
    
    for(int i = 0; i < n; i++){
        cout << a[i] << ' ';
    }
    cout << endl;
    for(int i = 0; i < n; i++){
        cout << b[i] << ' ';
    }
    
}